
#include "Carre_Herbe.hpp"
#include "GrassDefines.h"
#include "GrassRandom.h"

Carre_Herbe::Carre_Herbe()
{
//pointeurs
_n00 = NULL;_n10 = NULL;
_n01 = NULL;_n11 = NULL;
for (short i=0;i<9;i++) _nc[i]=NULL;

//random attributes
m_seedRandom=short(GRAND_SEED_MAX*GRandRealRandom());

//actif / densite
m_isActive=false;
m_density=0.0f;
m_typeOfDrawing=DRAWGRASS_NONE;
}


void Carre_Herbe::setNoeuds(Noeud *noeud0,
		            Noeud *noeud1,
	                    Noeud *noeud2,
		            Noeud *noeud3)
{
_n00 = noeud0;
_n10 = noeud1;
_n01 = noeud2;
_n11 = noeud3;
}
void Carre_Herbe::setNodesCrushing(NodeCrushing *node00,
				  NodeCrushing *node10,
				  NodeCrushing *node20,
				  NodeCrushing *node01,
				  NodeCrushing *node11,
				  NodeCrushing *node21,
				  NodeCrushing *node02,
				  NodeCrushing *node12,
				  NodeCrushing *node22)
{
_nc[0]=node00;
_nc[1]=node10;
_nc[2]=node20;
_nc[3]=node01;
_nc[4]=node11;
_nc[5]=node21;
_nc[6]=node02;
_nc[7]=node12;
_nc[8]=node22;
}


void Carre_Herbe::AfficheInformationDensite() const
{
glBegin(GL_QUADS);	
glColor3f(0.0f,m_density,0.0f);
glVertex3d(_n00->m_position[0], _n00->m_position[1], _n00->m_heightTex2D);
glVertex3d(_n01->m_position[0], _n01->m_position[1], _n01->m_heightTex2D);
glVertex3d(_n11->m_position[0], _n11->m_position[1], _n11 ->m_heightTex2D);
glVertex3d(_n10->m_position[0], _n10->m_position[1], _n10->m_heightTex2D);
glEnd();
}


void Carre_Herbe::draw2D() const
{	
GRandSeed(m_seedRandom);  
GReal aleaTexCoord;
GRand(aleaTexCoord);aleaTexCoord*=0.25f*GRASS_NUMBER_PATCHE_TYPE_1;
GReal coordTex[]={m_density-GRASS_NUMBER_PATCHE_TYPE_1+aleaTexCoord,
		  m_density-aleaTexCoord};

glBegin(GL_QUADS);		
//sommet 0
glTexCoord2f(coordTex[0] , 0.0f);
glNormal3f(0.0f,0.0f,0.35f*_n00->m_grass._norm0z+0.65f*_n00->m_grass._norm1z);
glVertex3d(_n00->m_position.x, _n00->m_position.y, _n00->m_heightTex2D);
//sommet 1	
glTexCoord2f(coordTex[1] , 0.0f);
glNormal3f(0.0f,0.0f,0.35f*_n10->m_grass._norm0z+0.65f*_n10->m_grass._norm1z);
glVertex3d(_n10->m_position.x, _n10->m_position.y, _n10->m_heightTex2D);
//sommet 3
glTexCoord2f(coordTex[1] , 1.0f);
glNormal3f(0.0f,0.0f,0.35f*_n11->m_grass._norm0z+0.65f*_n11->m_grass._norm1z);
glVertex3d(_n11->m_position.x, _n11->m_position.y, _n11->m_heightTex2D);
//sommet 2
glTexCoord2f(coordTex[0] , 1.0f);
glNormal3f(0.0f,0.0f,0.35f*_n01->m_grass._norm0z+0.65f*_n01->m_grass._norm1z);
glVertex3d(_n01->m_position.x, _n01->m_position.y, _n01->m_heightTex2D);
glEnd();
}


int Carre_Herbe::drawTransition3D_2D5(const short& polygonsPerGrass,
				      const short& polygonsPerVitre) const
{
SPatchesCoords coords;
static std::vector<SPatchesCoords> vp;
vp.clear();vp.reserve(SharedData::m_numberMaxGrassesPerPatche);

short i;
Herbe herbe;
GReal rapportDistance;
short nbGrasses=static_cast<short>(SharedData::m_numberMaxGrassesPerPatche*m_density);;

//DECALAGE PROGRESSIF  TRANSITION 2D <-> 2D5
//calcul distance max du carre au marcheur

rapportDistance = (m_distanceToCamera-SharedData::m_distanceTransition3D_2D5)
		 /(SharedData::m_distance3D-SharedData::m_distanceTransition3D_2D5);

//calcul des points
GRandSeed(m_seedRandom);  
for (i=nbGrasses;i!=0;i--)
	{
	//generation position
	GRand(coords.m_x);
	GRand(coords.m_y);	
	
	//transition 3D <-> 2D5
	if (coords.m_x<0.5f)
	  {
	  if (coords.m_y<0.5f) coords.m_x=(1.0f-rapportDistance)*coords.m_x 
	  				 + rapportDistance*coords.m_y;
	  else coords.m_x=(1.0f-rapportDistance)*coords.m_x 
	  		  + rapportDistance*(1.0f-coords.m_y);
	  }
	else
	  {
	  if (coords.m_y<0.5f) coords.m_x=(1.0f-rapportDistance)*coords.m_x 
	  				+ rapportDistance*(1.0f-coords.m_y);
	  else coords.m_x=(1.0f-rapportDistance)*coords.m_x 
	  		+ rapportDistance*coords.m_y;
	  }
	vp.push_back(coords);
	}

//classement par profondeur
//std::sort (vp.begin(), vp.end(), CompPatchesCoord_xIncrease());

bool crushing=false;
for (i=0;i<9;++i) if (_nc[i]->m_isCrushed){crushing=true;break;}
if (crushing) 
	{
	//construction des nodesCrushing
       _nc[0]->Make(_n00);
       _nc[2]->Make(_n10);
       _nc[6]->Make(_n01);
       _nc[8]->Make(_n11);	
       _nc[1]->Make(_n00,_n10);
       _nc[3]->Make(_n00,_n01);
       _nc[5]->Make(_n10,_n11);
       _nc[7]->Make(_n01,_n11);
       _nc[4]->Make(_n00,_n10,_n01,_n11);	

       for (i=0;i<nbGrasses;i++)
	     {
	     if (vp[i].m_x<0.5f)
		  {
		  if (vp[i].m_y<0.5f)
		  herbe.MakeWithNoise(_nc[0]->m_grass,_nc[1]->m_grass,
				      _nc[3]->m_grass,_nc[4]->m_grass,
				      vp[i].m_x*2.0f,vp[i].m_y*2.0f);
		  else
		  herbe.MakeWithNoise(_nc[3]->m_grass,_nc[4]->m_grass,
				      _nc[6]->m_grass,_nc[7]->m_grass,
				      vp[i].m_x*2.0f,(vp[i].m_y-0.5f)*2.0f);
		  }
	     else
		  {
		  if (vp[i].m_y<0.5f)
		  herbe.MakeWithNoise(_nc[1]->m_grass,_nc[2]->m_grass,
				      _nc[4]->m_grass,_nc[5]->m_grass,
				      (vp[i].m_x-0.5f)*2.0f,vp[i].m_y*2.0f);
		  else
		  herbe.MakeWithNoise(_nc[4]->m_grass,_nc[5]->m_grass,
				      _nc[7]->m_grass,_nc[8]->m_grass,
				      (vp[i].m_x-0.5f)*2.0f,(vp[i].m_y-0.5f)*2.0f);
		  }
	     herbe.Draw(polygonsPerGrass);
	     }	
	return 2*polygonsPerGrass*nbGrasses;
	}

//dessin des herbes
for (i=0;i<nbGrasses;i++)
	{
	herbe.MakeWithNoise(_n00->m_grass,_n10->m_grass,
			    _n01->m_grass,_n11->m_grass,
			    vp[i].m_x,vp[i].m_y);
	herbe.Draw(polygonsPerGrass);
	}	

return 2*polygonsPerGrass*nbGrasses;
}






int Carre_Herbe::draw2D5(const short& polygonsPerVitre) const
{   
   short i;
   Herbe grassCourbure;
   Vitre vitre;
   bool crushing=false;
   
   GRandSeed(m_seedRandom);  
   GReal aleaTexCoord;
   GRand(aleaTexCoord);aleaTexCoord*=0.25f*GRASS_NUMBER_PATCHE_TYPE_1;
   
   GReal heightMin=0.0f;
   if (SharedData::m_enableAjustmentHeight2D5)
   	{
	GReal distMin=Min(_n00->m_distanceToCamera,_n01->m_distanceToCamera);
	distMin=Min(distMin,_n10->m_distanceToCamera);
	distMin=Min(distMin,_n11->m_distanceToCamera);
	GReal distMax=Max(_n00->m_distanceToCamera,_n01->m_distanceToCamera);
	distMax=Max(distMax,_n10->m_distanceToCamera);
	distMax=Max(distMax,_n11->m_distanceToCamera);
	
	//approximation -> prise en compte de tous les z. Fonctionne bien.
	//pour faire juste : prendre en compte les trois hauteurs 
	//(avec des coef pour eviter les discontinuites) des noeuds opposes 
	//a celui le plus pres.
	GReal maxZ;
	maxZ=Max(_n00->m_position.z,_n01->m_position.z);
	maxZ=Max(maxZ,_n10->m_position.z);
	maxZ=Max(maxZ,_n11->m_position.z);
	
	//prise en compte un peu du denivelle...
	GReal minZ;
	minZ=Min(_n00->m_position.z,_n01->m_position.z);
	minZ=Min(minZ,_n10->m_position.z);
	minZ=Min(minZ,_n11->m_position.z);
	maxZ+=0.1f*(maxZ-minZ);
	
	heightMin=SharedData::m_cameraPosition.z
		 +(distMin/distMax)*(maxZ-SharedData::m_cameraPosition.z);
	}
	

   for (i=0;i<9;++i) if (_nc[i]->m_isCrushed){crushing=true;break;}
   if (crushing)
      {
      _nc[0]->Make(_n00);
      _nc[2]->Make(_n10);
      _nc[6]->Make(_n01);
      _nc[8]->Make(_n11);	
      _nc[1]->Make(_n00,_n10);
      _nc[3]->Make(_n00,_n01);
      _nc[5]->Make(_n10,_n11);
      _nc[7]->Make(_n01,_n11);
      _nc[4]->Make(_n00,_n10,_n01,_n11);

      GReal CoordsTex[5];
      CoordsTex[0]=m_density-aleaTexCoord;
      CoordsTex[1]=m_density-GRASS_NUMBER_PATCHE_TYPE_1*0.25f-0.50f*aleaTexCoord;
      CoordsTex[2]=m_density-GRASS_NUMBER_PATCHE_TYPE_1*0.50f;	           
      CoordsTex[3]=m_density-GRASS_NUMBER_PATCHE_TYPE_1*0.75f+0.50f*aleaTexCoord;
      CoordsTex[4]=m_density-GRASS_NUMBER_PATCHE_TYPE_1+aleaTexCoord;	
	
      Herbe grassTmp;
      grassTmp.Make(_nc[1]->m_grass,_nc[3]->m_grass,0.5f);
      grassCourbure.MakeAtFirstGrassPosition(_nc[0]->m_grass,grassTmp,0.5f);
      if (SharedData::m_enableAjustmentHeight2D5) 
   	grassCourbure._pos1.z=Max(grassCourbure._pos1.z,heightMin);
      vitre.draw(_nc[0]->m_position,grassTmp._pos0,
		 grassCourbure,
		 _nc[0]->m_grass._norm0z,_nc[0]->m_grass._norm1z,
		 grassTmp._norm0z,grassTmp._norm1z,
		 polygonsPerVitre, 
		 CoordsTex[4],
		 CoordsTex[3]);	  
      grassCourbure.MakeAtFirstGrassPosition(grassTmp,_nc[4]->m_grass,0.5f);
      if (SharedData::m_enableAjustmentHeight2D5) 
   	grassCourbure._pos1.z=Max(grassCourbure._pos1.z,heightMin);
      vitre.draw(grassTmp._pos0,_nc[4]->m_position,
		 grassCourbure,
		 grassTmp._norm0z,grassTmp._norm1z,
		 _nc[4]->m_grass._norm0z,_nc[4]->m_grass._norm1z,
		 polygonsPerVitre, 
		 CoordsTex[3],
		 CoordsTex[2]);	  

      grassTmp.Make(_nc[5]->m_grass,_nc[7]->m_grass,0.5f);
      grassCourbure.MakeAtFirstGrassPosition(_nc[4]->m_grass,grassTmp,0.5f);
      if (SharedData::m_enableAjustmentHeight2D5) 
   	grassCourbure._pos1.z=Max(grassCourbure._pos1.z,heightMin);
      vitre.draw(_nc[4]->m_position,grassTmp._pos0,
		 grassCourbure,
		 _nc[4]->m_grass._norm0z,_nc[4]->m_grass._norm1z,
		 grassTmp._norm0z,grassTmp._norm1z,
		 polygonsPerVitre, 
		 CoordsTex[2],
		 CoordsTex[1]);
      grassCourbure.MakeAtFirstGrassPosition(grassTmp,_nc[8]->m_grass,0.5f);
      if (SharedData::m_enableAjustmentHeight2D5) 
   	grassCourbure._pos1.z=Max(grassCourbure._pos1.z,heightMin);
      vitre.draw(grassTmp._pos0,_nc[8]->m_position,
		 grassCourbure,
		 grassTmp._norm0z,grassTmp._norm1z,
		 _nc[8]->m_grass._norm0z,_nc[8]->m_grass._norm1z,
		 polygonsPerVitre, 
		 CoordsTex[1],
		 CoordsTex[0]);

      grassTmp.Make(_nc[1]->m_grass,_nc[5]->m_grass,0.5f);
      grassCourbure.MakeAtFirstGrassPosition(_nc[2]->m_grass,grassTmp,0.5f);
      if (SharedData::m_enableAjustmentHeight2D5) 
   	grassCourbure._pos1.z=Max(grassCourbure._pos1.z,heightMin);
      vitre.draw(_nc[2]->m_position,grassTmp._pos0,
		 grassCourbure,
		 _nc[2]->m_grass._norm0z,_nc[2]->m_grass._norm1z,
		 grassTmp._norm0z,grassTmp._norm1z,
		 polygonsPerVitre, 
		 CoordsTex[4],
		 CoordsTex[3]);
      grassCourbure.MakeAtFirstGrassPosition(grassTmp,_nc[4]->m_grass,0.5f);
      if (SharedData::m_enableAjustmentHeight2D5) 
   	grassCourbure._pos1.z=Max(grassCourbure._pos1.z,heightMin);
      vitre.draw(grassTmp._pos0,_nc[4]->m_position,
		 grassCourbure,
		 grassTmp._norm0z,grassTmp._norm1z,
		 _nc[4]->m_grass._norm0z,_nc[4]->m_grass._norm1z,
		 polygonsPerVitre, 
		 CoordsTex[3],
		 CoordsTex[2]);

      grassTmp.Make(_nc[3]->m_grass,_nc[7]->m_grass,0.5f);
      grassCourbure.MakeAtFirstGrassPosition(_nc[4]->m_grass,grassTmp,0.5f);
      if (SharedData::m_enableAjustmentHeight2D5) 
   	grassCourbure._pos1.z=Max(grassCourbure._pos1.z,heightMin);
      vitre.draw(_nc[4]->m_position,grassTmp._pos0,
		 grassCourbure,
		 _nc[4]->m_grass._norm0z,_nc[4]->m_grass._norm1z,
		 grassTmp._norm0z,grassTmp._norm1z,
		 polygonsPerVitre, 
		 CoordsTex[2],
		 CoordsTex[1]);
      grassCourbure.MakeAtFirstGrassPosition(grassTmp,_nc[6]->m_grass,0.5f);
      if (SharedData::m_enableAjustmentHeight2D5) 
   	grassCourbure._pos1.z=Max(grassCourbure._pos1.z,heightMin);
      vitre.draw(grassTmp._pos0,_nc[6]->m_position,
		 grassCourbure,
		 grassTmp._norm0z,grassTmp._norm1z,
		 _nc[6]->m_grass._norm0z,_nc[6]->m_grass._norm1z,
		 polygonsPerVitre, 
		 CoordsTex[1],
		 CoordsTex[0]);
      return 16*polygonsPerVitre;
      }

   grassCourbure.MakeAtFirstGrassPosition(_n00->m_grass,_n11->m_grass,0.5f);
   if (SharedData::m_enableAjustmentHeight2D5) 
   	grassCourbure._pos1.z=Max(grassCourbure._pos1.z,heightMin);
   vitre.draw(_n00->m_position,_n11->m_position,
	      grassCourbure,
	      _n00->m_grass._norm0z,_n00->m_grass._norm1z,
	      _n11->m_grass._norm0z, _n11->m_grass._norm1z,
	      polygonsPerVitre, 
	      m_density-GRASS_NUMBER_PATCHE_TYPE_1+aleaTexCoord,
	      m_density-aleaTexCoord);

   grassCourbure.MakeAtFirstGrassPosition(_n10->m_grass,_n01->m_grass,0.5f);
   if (SharedData::m_enableAjustmentHeight2D5) 
   	grassCourbure._pos1.z=Max(grassCourbure._pos1.z,heightMin);
   vitre.draw(_n10->m_position,_n01->m_position,
	      grassCourbure,
	      _n10->m_grass._norm0z,_n10->m_grass._norm1z,
	      _n01->m_grass._norm0z,_n01->m_grass._norm1z, 
	      polygonsPerVitre, 
	      m_density-GRASS_NUMBER_PATCHE_TYPE_1+aleaTexCoord,
	      m_density-aleaTexCoord);
   //printf("carre_herbe : densite %f\n",m_density);
   return 4*polygonsPerVitre;
}



int Carre_Herbe::draw3D(const short& polygonsPerGrass) const
{
SPatchesCoords coords;
static std::vector<SPatchesCoords> vp;
vp.clear();vp.reserve(SharedData::m_numberMaxGrassesPerPatche);

short i;
Herbe herbe;
short nbGrasses=static_cast<short>(SharedData::m_numberMaxGrassesPerPatche*m_density);;

//calcul des points
GRandSeed(m_seedRandom);  
for (i=nbGrasses;i!=0;i--)
	{
	//generation position
	GRand(coords.m_x);
	GRand(coords.m_y);
	vp.push_back(coords);
	}

//classement par profondeur
//std::sort (vp.begin(), vp.end(), CompPatchesCoord_xIncrease());


bool crushing=false;
for (i=0;i<9;++i) if (_nc[i]->m_isCrushed){crushing=true;break;}
if (crushing) 
	{
	//construction des nodesCrushing
       _nc[0]->Make(_n00);
       _nc[2]->Make(_n10);
       _nc[6]->Make(_n01);
       _nc[8]->Make(_n11);	
       _nc[1]->Make(_n00,_n10);
       _nc[3]->Make(_n00,_n01);
       _nc[5]->Make(_n10,_n11);
       _nc[7]->Make(_n01,_n11);
       _nc[4]->Make(_n00,_n10,_n01,_n11);	

       for (i=0;i<nbGrasses;i++)
	     {
	     if (vp[i].m_x<0.5f)
		  {
		  if (vp[i].m_y<0.5f)
		  herbe.MakeWithNoise(_nc[0]->m_grass,_nc[1]->m_grass,
				      _nc[3]->m_grass,_nc[4]->m_grass,
				      vp[i].m_x*2.0f,vp[i].m_y*2.0f);
		  else
		  herbe.MakeWithNoise(_nc[3]->m_grass,_nc[4]->m_grass,
				      _nc[6]->m_grass,_nc[7]->m_grass,
				      vp[i].m_x*2.0f,(vp[i].m_y-0.5f)*2.0f);
		  }
	     else
		  {
		  if (vp[i].m_y<0.5f)
		  herbe.MakeWithNoise(_nc[1]->m_grass,_nc[2]->m_grass,
				      _nc[4]->m_grass,_nc[5]->m_grass,
				      (vp[i].m_x-0.5f)*2.0f,vp[i].m_y*2.0f);
		  else
		  herbe.MakeWithNoise(_nc[4]->m_grass,_nc[5]->m_grass,
				      _nc[7]->m_grass,_nc[8]->m_grass,
				      (vp[i].m_x-0.5f)*2.0f,(vp[i].m_y-0.5f)*2.0f);
		  }
	     herbe.Draw(polygonsPerGrass);
	     }	
	return 2*polygonsPerGrass*nbGrasses;
	}

//dessin des herbes
for (i=0;i<nbGrasses;i++)
	{
	herbe.MakeWithNoise(_n00->m_grass,_n10->m_grass,
			    _n01->m_grass,_n11->m_grass,
			    vp[i].m_x,vp[i].m_y);
	herbe.Draw(polygonsPerGrass);
	}	

return 2*polygonsPerGrass*nbGrasses;
}






















