#include "GrassEngine.h"
#include "GrassDefines.h"
#include "GrassRandom.h"

#include "TextureGrass.h"
#include "Vitre.hpp"

#include "GrassRandom.h"
#include "GrassInterface.h"

#include <iostream>
#include <stdio.h>
//#include "GroundInterface.h"
//--------------------------------------
//----------variables globales----------
//--------------------------------------

extern short g_drawOption;
extern int   g_numberDrawingPG;
//--


GLfloat materialAmbientGrass[]   = {0.0f,0.05f,0.0f,1.0f};
GLfloat materialDiffuseGrass[]   = {0.08f,0.6f,0.0f,1.0f};
GLfloat materialSpecularGrass[]  = {0.8f, 0.8f, 0.8f, 1.0f} ;
GLfloat materialShininessGrass[] = {5.0f};
GLfloat materialAmbientGrassWithTexture[]   = {0.1f,0.1f,0.1f,1.0f};
GLfloat materialDiffuseGrassWithTexture[]   = {1.0f,1.0f,1.0f,1.0f};
GLfloat materialSpecularGrassWithTexture[]  = {0.8f, 0.8f, 0.8f, 1.0f} ;
GLfloat materialShininessGrassWithTexture[] = {5.0f};


TextureGrass GrassEngine::ms_texture2D;
TextureGrass GrassEngine::ms_texture2D5;
TextureGrass GrassEngine::ms_textureOnGrass;


GrassEngine::GrassEngine()
{
  GRandInit();
  
  m_pElements=NULL;
  m_pNoeuds=NULL;
  m_pNodesCrushing=NULL;
  m_numberOfNoeuds=0;
  m_numberOfElements=0;
  
  m_numberOfPatchesInLength=1;
  m_numberOfPatchesInWidth=1;
  
  m_fileDensityMap[0]=0;
  m_fileTextureOnGrass[0]=0;
   
  m_initDisplay=false;
  m_textureOnGrass=false;
  
  m_graineTexture2D5=0;
  m_graineTexture2D=0;
  m_antiAliasingTexture3D=0.5;
  m_antiAliasingTexture2D5=0.5;
  m_antiAliasingTexture2D=0.5;
  m_Texture2D5SizeX=512;
  m_Texture2D5SizeY=64;
}

GrassEngine::~GrassEngine()
{
  short i;	
  if ( m_pElements!=NULL ) 
       {
       for (i=0;i<m_numberOfPatchesInLength;i++) delete[] m_pElements[i];
       delete[] m_pElements;
       m_pElements=NULL;
       }
  if ( m_pNoeuds!=NULL ) 
       {
       for (i=0;i<m_numberOfPatchesInLength+1;i++) delete[] m_pNoeuds[i];
       delete[] m_pNoeuds;
       m_pNoeuds=NULL;
       }
  if ( m_pNodesCrushing!=NULL ) 
       {
       for (i=0;i<m_numberOfPatchesInLength*2+1;i++) delete[] m_pNodesCrushing[i];
       delete[] m_pNodesCrushing;
       m_pNodesCrushing=NULL;
       }
  ms_texture2D.unloadGLTexture();
  ms_texture2D5.unloadGLTexture();
}


void GrassEngine::init(const float area[4],const short& numberOfPatchesInLength,const short& numberOfPatchesInWidth,char* fileDensityMap)
{
 short i,j;
  Point3 position;

  //initialisation donnees
  if ( m_pElements!=NULL ) 
	  {
	  for (i=0;i<m_numberOfPatchesInLength;i++) delete[] m_pElements[i];
	  delete[] m_pElements;
	  m_pElements=NULL;
	  }
  if ( m_pNoeuds!=NULL ) 
	  {
	  for (i=0;i<m_numberOfPatchesInLength+1;i++) delete[] m_pNoeuds[i];
	  delete[] m_pNoeuds;
	  m_pNoeuds=NULL;
	  }
  if ( m_pNodesCrushing!=NULL ) 
	 {
	 for (i=0;i<m_numberOfPatchesInLength*2+1;i++) delete[] m_pNodesCrushing[i];
	 delete[] m_pNodesCrushing;
	 m_pNodesCrushing=NULL;
	 }
  
  if (fileDensityMap==NULL) m_fileDensityMap[0]=0;
  else strcpy(m_fileDensityMap,fileDensityMap);

  m_area[0]=area[0];m_area[1]=area[1];
  m_area[2]=area[2];m_area[3]=area[3];
  if (m_area[2]-m_area[0]<1.0) m_area[2]=m_area[0]+1.0;
  if (m_area[3]-m_area[1]<1.0) m_area[3]=m_area[1]+1.0; 
  m_areaLength=m_area[2]-m_area[0];
  m_areaWidth=m_area[3]-m_area[1];
  m_numberOfPatchesInLength=numberOfPatchesInLength;
  if (m_numberOfPatchesInLength<1) m_numberOfPatchesInLength=1;
  m_numberOfPatchesInWidth=numberOfPatchesInWidth;
  if (m_numberOfPatchesInWidth<1) m_numberOfPatchesInWidth=1;

  m_patchesLength=m_areaLength/m_numberOfPatchesInLength;
  m_patchesWidth=m_areaWidth/m_numberOfPatchesInWidth;
  m_numberOfNoeuds=(m_numberOfPatchesInLength+1)*(m_numberOfPatchesInWidth+1);
  m_numberOfElements=m_numberOfPatchesInLength*m_numberOfPatchesInWidth;
 
  m_pNoeuds=new Noeud*[m_numberOfPatchesInLength+1];
  for (i=0;i<m_numberOfPatchesInLength+1;i++)
	  m_pNoeuds[i]=new Noeud[numberOfPatchesInWidth+1];
  m_pElements=new Carre_Herbe*[m_numberOfPatchesInLength];
  for (i=0;i<m_numberOfPatchesInLength;i++)
	  m_pElements[i]=new Carre_Herbe[numberOfPatchesInWidth];

  m_pNodesCrushing =new NodeCrushing*[m_numberOfPatchesInLength*2+1];
  for (i=0;i<m_numberOfPatchesInLength*2+1;i++)
	  m_pNodesCrushing[i]=new NodeCrushing[numberOfPatchesInWidth*2+1];
  
  //noeuds : position
  for (i=0;i<m_numberOfPatchesInLength+1;i++)
  for (j=0;j<m_numberOfPatchesInWidth+1;j++)
	  {	
	  position.x=m_area[0] + i*m_patchesLength;
	  position.y=m_area[1] + j*m_patchesWidth;
	  position.z=grassGetHeightAtPosition(position.x,position.y);
	  m_pNoeuds[i][j].setPosition(position);
	  m_pNoeuds[i][j].SetGrassHeight(Herbe::ms_height);
	  //_vecteurNormal
	  }
  for (i=0;i<m_numberOfPatchesInLength*2+1;i++)
  for (j=0;j<m_numberOfPatchesInWidth*2+1;j++)
	  {	
	  position.x=m_area[0] + i*m_patchesLength*0.5;
	  position.y=m_area[1] + j*m_patchesWidth*0.5;
	  position.z=grassGetHeightAtPosition(position.x,position.y);
	  m_pNodesCrushing[i][j].setPosition(position);
	  m_pNodesCrushing[i][j].m_isActive=true;
	  }
  


  //noeud : densite
  TextureGrass textureForDensityMap;
  unsigned char* densityMap=NULL;
  int densityMapCols=0;
  int densityMapRows=0;
  if (fileDensityMap!=NULL)
          {
          textureForDensityMap.loadMap(fileDensityMap);
          textureForDensityMap.getMap(&densityMap,&densityMapCols,&densityMapRows);
          }
  for (i=0;i<m_numberOfPatchesInLength+1;i++)
  for (j=0;j<m_numberOfPatchesInWidth+1;j++)
	  {	
	  m_pNoeuds[i][j].m_grassDensity=
		  getDensityMapAtPosition(m_pNoeuds[i][j].m_position.x,
	 				  m_pNoeuds[i][j].m_position.y,
		 		          densityMap,densityMapCols,densityMapRows);
	  if (m_pNoeuds[i][j].m_grassDensity<0.15) m_pNoeuds[i][j].m_grassDensity=0.0;
	  }
  textureForDensityMap.unloadMap();

  //construction des elements et calcul si les noeuds sont actifs
  for (i=0;i<m_numberOfPatchesInLength;i++)
  for (j=0;j<m_numberOfPatchesInWidth;j++)
	  {
	  m_pElements[i][j].setNoeuds(&m_pNoeuds[i][j],
				      &m_pNoeuds[i+1][j],
				      &m_pNoeuds[i][j+1],
				      &m_pNoeuds[i+1][j+1]);
	  m_pElements[i][j].setNodesCrushing(
				      &m_pNodesCrushing[i*2][j*2],
				      &m_pNodesCrushing[i*2+1][j*2],
				      &m_pNodesCrushing[i*2+2][j*2],
				      &m_pNodesCrushing[i*2][j*2+1],
				      &m_pNodesCrushing[i*2+1][j*2+1],
				      &m_pNodesCrushing[i*2+2][j*2+1],
				      &m_pNodesCrushing[i*2][j*2+2],
				      &m_pNodesCrushing[i*2+1][j*2+2],
				      &m_pNodesCrushing[i*2+2][j*2+2]);
	  GReal densiteElement =(m_pNoeuds[i][j].m_grassDensity
				+m_pNoeuds[i+1][j].m_grassDensity
				+m_pNoeuds[i][j+1].m_grassDensity
				+m_pNoeuds[i+1][j+1].m_grassDensity)
				*0.25f;
	  if (densiteElement>GRASS_NUMBER_PATCHE_TYPE_1)
		  {
		  m_pNoeuds[i][j].m_isActive=true;
		  m_pNoeuds[i+1][j].m_isActive=true;
		  m_pNoeuds[i][j+1].m_isActive=true;
		  m_pNoeuds[i+1][j+1].m_isActive=true;
		  m_pElements[i][j].m_isActive=true;
		  //TODO -> ameliorer ca
		  m_pElements[i][j].m_density=densiteElement;
		  }
	  }
  
  //calcul height max per patches
  for (i=0;i<m_numberOfPatchesInLength;i++)
  for (j=0;j<m_numberOfPatchesInWidth;j++)
	  {
	  GReal tmpHeight, tmpHeightMax=0.0;
	  GReal xmin=m_pNoeuds[i][j].m_position[0];
	  GReal xmax=m_pNoeuds[i+1][j+1].m_position[0];
	  GReal ymin=m_pNoeuds[i][j].m_position[1];
	  GReal ymax=m_pNoeuds[i+1][j+1].m_position[1];
	  while (xmin<xmax)
		  {
		  while (ymin<ymax)
			  {
			  tmpHeight=grassGetHeightAtPosition(xmin,ymin);
			  if (tmpHeightMax<tmpHeight) tmpHeightMax=tmpHeight;
			  ymin+=m_patchesWidth*0.2;
			  }
		  ymin=m_pNoeuds[i][j].m_position[1];
		  xmin+=m_patchesLength*0.2;
		  }

	  m_pNoeuds[i][j].setTex2DHeight(tmpHeightMax);
	  m_pNoeuds[i+1][j].setTex2DHeight(tmpHeightMax);
	  m_pNoeuds[i][j+1].setTex2DHeight(tmpHeightMax);
	  m_pNoeuds[i+1][j+1].setTex2DHeight(tmpHeightMax);
	  }
	  
  //recalcul de la densite	  
  SharedData::setNumberMaxGrassesPerPatche(
	  short(SharedData::m_numberGrassesPerSquareMeters
	  	*m_patchesLength*m_patchesWidth*0.1f));	
  if (m_initDisplay)
		{
		makeTexture2D();
		makeTexture2D5();
		}
}

 
void GrassEngine::update(GReal dt,
			 GrassTrajectory* pTrajectories,
	    		 const short& numberOfTrajectories)
{
  short i,j;
  //mise a jour ecrasement
  for (i=m_numberOfPatchesInLength*2;i>=0;--i)
  for (j=m_numberOfPatchesInWidth*2;j>=0;--j)
	  m_pNodesCrushing[i][j].UpdateCrushing(dt);
  //calcul influence de la trajectoire
  for (i=0;i<numberOfTrajectories;i++)
	  UpdateInfluenceTrajectoire(&pTrajectories[i]);
}



void GrassEngine::predraw(const Point3& positionCamera)
{
  short i, j;
  GReal imprecision=sqrt(m_patchesLength*m_patchesLength
  			 +m_patchesWidth*m_patchesWidth);
  
  //mise a jour de la camera.
  SharedData::updateCamera(positionCamera);

  //mise a jour des noeuds, calcul visibilite, forme herbe au vent...
  for (i=m_numberOfPatchesInLength;i>=0;--i)
  for (j=m_numberOfPatchesInWidth;j>=0;--j)
       {
       if (m_pNoeuds[i][j].m_isActive)
	  {
	  m_pNoeuds[i][j].UpdateVisibilite(imprecision);
	  if (m_pNoeuds[i][j].m_mustBeUpdated)
	  	m_pNoeuds[i][j].UpdatePreDraw();
	  }
       } 

  //mise a jour des patches
  for (i=m_numberOfPatchesInLength-1;i>=0;--i)
  for (j=m_numberOfPatchesInWidth-1;j>=0;--j)
	  m_pElements[i][j].update();
}

void GrassEngine::drawInWire()
{
  short i,j;
  short nbPolygons;
 
  //affichage en mode wire
  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);
  glColor3f(0.0f,0.0f,1.0f);
  if (SharedData::m_distance2D>SharedData::m_distance2D5)
  for (i=0;i<m_numberOfPatchesInLength;i++)
  for (j=0;j<m_numberOfPatchesInWidth;j++)
     {
     if (m_pElements[i][j].m_typeOfDrawing==DRAWGRASS_2D)
	     {
	     m_pElements[i][j].draw2D();
	     g_numberDrawingPG+=2;
	     }
     }
  //affichage 2D5
  glColor3f(1.0f,0.0f,1.0f);
  if (SharedData::m_distance2D5>SharedData::m_distance3D)
  {
  for (i=0;i<m_numberOfPatchesInLength;i++)
  for (j=0;j<m_numberOfPatchesInWidth;j++)
     {
     if (m_pElements[i][j].m_typeOfDrawing==DRAWGRASS_2D5)
	  {
	  nbPolygons=1+short(SharedData::m_numberPG2D5
		  *(1.0f-(m_pElements[i][j].m_distanceToCamera-SharedData::m_distance3D)
		  *SharedData::m_distance2D5_1)); 
	  g_numberDrawingPG+=m_pElements[i][j].draw2D5(nbPolygons);
	  }
     }
  }
  //affichage 3D
  glColor3f(0.0f,1.0f,0.2f);
  if (SharedData::m_distance3D>0.0f)
  {
  for (i=0;i<m_numberOfPatchesInLength;i++)
  for (j=0;j<m_numberOfPatchesInWidth;j++)
     {
     if (m_pElements[i][j].m_typeOfDrawing==DRAWGRASS_3D)
	     {
	     nbPolygons=SharedData::m_numberPG2D5+short((SharedData::m_numberPG3D-SharedData::m_numberPG2D5)
		*(1.0f-m_pElements[i][j].m_distanceToCamera*SharedData::m_distance3D_1));
	     g_numberDrawingPG+=m_pElements[i][j].draw3D(nbPolygons);
	     }
     }
  }
  glEnable(GL_LIGHTING);
  }


void GrassEngine::draw()
  {
  short i, j, indice1, indice2, propagation1=0, propagation2=0, nbPolygons;
  bool propagationOnX, loop;

  //verification que les textures sont correctement initialise
  if (!m_initDisplay) 
	  {
	  makeTexture2D();
	  makeTexture2D5();
	  m_initDisplay=true;
	  }

  if (g_drawOption==DRAWOPTION_WIRE) 
	  {
	  drawInWire();
	  return;
	  }

  //affichage par ordre de profondeur
  if (SharedData::m_cameraBillboard.x>0.0)
     {	
     if (SharedData::m_cameraBillboard.y>0.0)
	   {
	   //on part d'en haut a gauche
	   indice1 = 0;
	   indice2 = m_numberOfPatchesInWidth-1;
	   if (Abs(SharedData::m_cameraBillboard.x)>Abs(SharedData::m_cameraBillboard.y)) 
      	     {
	     propagationOnX=true;
	     propagation1=1;
	     }		
	   else 
      	     {
	     propagationOnX=false;
	     propagation2=-1;
	     }	
	   }
     else
	   {
	   //on part d'en haut a droite
	   indice1 = m_numberOfPatchesInLength-1;
	   indice2 = m_numberOfPatchesInWidth-1;
	   if (Abs(SharedData::m_cameraBillboard.x)>Abs(SharedData::m_cameraBillboard.y)) 
      	     {
	     propagationOnX=true;
	     propagation1=-1;
	     }		
	   else 
      	     {
	     propagationOnX=false;
	     propagation2=-1;
	     }	
	   }
     }
  else 
     {
     if (SharedData::m_cameraBillboard.y>0.0)
	   {
	   //on part d'en bas a gauche
	   indice1 = 0;
	   indice2 = 0;
	   if (Abs(SharedData::m_cameraBillboard.x)>Abs(SharedData::m_cameraBillboard.y)) 
      	     {
	     propagationOnX=true;
	     propagation1=1;
	     }		
	   else 
      	     {
	     propagationOnX=false;
	     propagation2=1;
	     }	
	   }
     else
	   {
	   //on part d'en bas a droite
	   indice1 = m_numberOfPatchesInLength-1;
	   indice2 = 0;
	   if (Abs(SharedData::m_cameraBillboard.x)>Abs(SharedData::m_cameraBillboard.y)) 
      	     {
	     propagationOnX=true;
	     propagation1=-1;
	     }		
	   else 
      	     {
	     propagationOnX=false;
	     propagation2=1;
	     }	
	   }
     }
  if (propagationOnX) {if (indice2==0) propagation2=1;else propagation2=-1;}
  else	{if (indice1==0) propagation1=1; else propagation1=-1;}	 
  //fin classement par profondeur

  //material
  if (m_textureOnGrass)
  {
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT,materialAmbientGrassWithTexture);
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, materialDiffuseGrassWithTexture);
  glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, materialSpecularGrassWithTexture);
  glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, materialShininessGrassWithTexture);
  }
  else
  {
  glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT, materialAmbientGrass);
  glMaterialfv(GL_FRONT_AND_BACK, GL_DIFFUSE, materialDiffuseGrass);
  glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, materialSpecularGrass);
  glMaterialfv(GL_FRONT_AND_BACK, GL_SHININESS, materialShininessGrass);
  }
  
  //transparence...
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  //alpha test permet de supprimer element tres transparent : evite le probleme des vitres 
  //se chevauchant (sans perte vitesse).
  glEnable(GL_ALPHA_TEST);
  glAlphaFunc(GL_GREATER,0.05);

  //---------------------------------------------------------------------------
  //----------------------------affichage 2D-----------------------------------
  //---------------------------------------------------------------------------

  //texture
  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D,ms_texture2D.getGLTextureId());
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  loop=true;
  i=indice1;
  j=indice2;
  if (SharedData::m_distance2D>SharedData::m_distance2D5)
  while (loop)
	  {
	  if (m_pElements[i][j].m_typeOfDrawing==DRAWGRASS_2D)
		  {
		  m_pElements[i][j].draw2D();
		  g_numberDrawingPG+=2;
		  }
	  if (propagationOnX)
		  {
		  i+=propagation1;
		  if (i<0)
			  {
			  i=m_numberOfPatchesInLength-1;
			  j+=propagation2;
			  loop=(j>=0 && j<m_numberOfPatchesInWidth);
			  }
		  else if (i>=m_numberOfPatchesInLength) 
			  {i=0;
			  j+=propagation2;
			  loop=(j>=0 && j<m_numberOfPatchesInWidth);
			  }
		  }
	  else
		  {
		  j+=propagation2;
		  if (j<0)
			  {
			  j=m_numberOfPatchesInWidth-1;
			  i+=propagation1;
			  loop=(i>=0 && i<m_numberOfPatchesInLength);
			  }
		  else if (j>=m_numberOfPatchesInWidth) 
			  {j=0;
			  i+=propagation1;
			  loop=(i>=0 && i<m_numberOfPatchesInLength);
			  }
		  }
	  }

  //---------------------------------------------------------------------------
  //----------------------------affichage 2D5----------------------------------
  //---------------------------------------------------------------------------

  glBindTexture(GL_TEXTURE_2D,ms_texture2D5.getGLTextureId());
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  loop=true;
  i=indice1;
  j=indice2;
  if (SharedData::m_distance2D5>SharedData::m_distance3D)
  {
  while (loop)
	  {
	  if (m_pElements[i][j].m_typeOfDrawing==DRAWGRASS_2D5)
		  {
		  nbPolygons=1+short(SharedData::m_numberPG2D5
			  *(1.0f-(m_pElements[i][j].m_distanceToCamera-SharedData::m_distance3D)
			  *SharedData::m_distance2D5_1)); 
		  g_numberDrawingPG+=m_pElements[i][j].draw2D5(nbPolygons);
		  }
	  if (propagationOnX)
		  {
		  i+=propagation1;
		  if (i<0)
			  {
			  i=m_numberOfPatchesInLength-1;
			  j+=propagation2;
			  loop=(j>=0 && j<m_numberOfPatchesInWidth);
			  }
		  else if (i>=m_numberOfPatchesInLength) 
			  {
			  i=0;
			  j+=propagation2;
			  loop=(j>=0 && j<m_numberOfPatchesInWidth);
			  }
		  }
	  else
		  {
		  j+=propagation2;
		  if (j<0)
			  {
			  j=m_numberOfPatchesInWidth-1;
			  i+=propagation1;
			  loop=(i>=0 && i<m_numberOfPatchesInLength);
			  }
		  else if (j>=m_numberOfPatchesInWidth) 
			  {j=0;
			  i+=propagation1;
			  loop=(i>=0 && i<m_numberOfPatchesInLength);
			  }
		  }
	  }
  }

  //---------------------------------------------------------------------------
  //----------------------------affichage 3D-----------------------------------
  //---------------------------------------------------------------------------

  if (!m_textureOnGrass)
  	{
	glDisable(GL_TEXTURE_2D);
  	glDisable(GL_BLEND);
	glDisable(GL_ALPHA_TEST);
	}
  else
  	{
	glDisable(GL_ALPHA_TEST);
	glBindTexture(GL_TEXTURE_2D,ms_textureOnGrass.getGLTextureId());
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	}
  loop=true;
  i=indice1;
  j=indice2;
  if (SharedData::m_distance3D>0.0f)
  {
  while (loop)
	  {
	  if (m_pElements[i][j].m_typeOfDrawing==DRAWGRASS_3D)
		  {
		  nbPolygons=SharedData::m_numberPG2D5+1
			    +short((SharedData::m_numberPG3D-SharedData::m_numberPG2D5)
			    *(1.0f-m_pElements[i][j].m_distanceToCamera*SharedData::m_distance3D_1));   
		  g_numberDrawingPG+=m_pElements[i][j].draw3D(nbPolygons);
		  }
	  else if (m_pElements[i][j].m_typeOfDrawing==DRAWGRASS_TRANSITION_3D_2D5)
		  {
		  nbPolygons=SharedData::m_numberPG2D5+1
			    +short((SharedData::m_numberPG3D-SharedData::m_numberPG2D5)
			    *(1.0f-m_pElements[i][j].m_distanceToCamera*SharedData::m_distance3D_1));   
		  g_numberDrawingPG+=
		  	m_pElements[i][j].drawTransition3D_2D5(nbPolygons,0);
		  }
	  if (propagationOnX)
		  {
		  i+=propagation1;
		  if (i<0)
			  {
			  i=m_numberOfPatchesInLength-1;
			  j+=propagation2;
			  loop=(j>=0 && j<m_numberOfPatchesInWidth);
			  }
		  else if (i>=m_numberOfPatchesInLength) 
			  {i=0;
			  j+=propagation2;
			  loop=(j>=0 && j<m_numberOfPatchesInWidth);
			  }
		  }
	  else
		  {
		  j+=propagation2;
		  if (j<0)
			  {
			  j=m_numberOfPatchesInWidth-1;
			  i+=propagation1;
			  loop=(i>=0 && i<m_numberOfPatchesInLength);
			  }
		  else if (j>=m_numberOfPatchesInWidth) 
			  {j=0;
			  i+=propagation1;
			  loop=(i>=0 && i<m_numberOfPatchesInLength);
			  }
		  }
	  }
  }
  glDisable(GL_TEXTURE_2D);
  glDisable(GL_BLEND);
}


void GrassEngine::drawNoeuds() const
{
  short i,j;
  glPushAttrib(GL_ENABLE_BIT);
  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);
  glColor3f(1.0f,0.0f,0.0f);
  for (i=0;i<m_numberOfPatchesInLength+1;i++)
  for (j=0;j<m_numberOfPatchesInWidth+1;j++)
	  {
	  if (m_pNoeuds[i][j].m_isActive && m_pNoeuds[i][j].m_isVisible)
		  m_pNoeuds[i][j].m_grass.Draw(5);
	  }

  glColor3f(1.0f,0.8f,0.0f);
  for (i=0;i<m_numberOfPatchesInLength*2+1;i++)
  for (j=0;j<m_numberOfPatchesInWidth*2+1;j++)
	  {
	  if (m_pNodesCrushing[i][j].m_crushingCurrentPower>0.0f)
	  m_pNodesCrushing[i][j].m_grass.Draw(5);
	  }
  glPopAttrib();
}

void GrassEngine::drawTrajectory() const
{
  /*short i,j;
  glPushAttrib(GL_ENABLE_BIT);
  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);
  for (i=0;i<m_numberOfPatchesInLength;i++)
  for (j=0;j<m_numberOfPatchesInWidth;j++)
	  m_pElements[i][j].AfficheInfluenceOnNodes();
  glPopAttrib();*/
}

void GrassEngine::drawDensity() const
{
  short i,j;
  glPushAttrib(GL_ENABLE_BIT);
  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);
  for (i=0;i<m_numberOfPatchesInLength;i++)
  for (j=0;j<m_numberOfPatchesInWidth;j++)
	  m_pElements[i][j].AfficheInformationDensite();
  glPopAttrib();
}

void GrassEngine::drawCrushingVector() const
{
  /*short i,j;
  glPushAttrib(GL_ENABLE_BIT);
  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);
  glColor3f(0.0,0.0,1.0);
  for (i=0;i<m_numberOfPatchesInLength+1;i++)
  for (j=0;j<m_numberOfPatchesInWidth+1;j++)
	  m_pNoeuds[i][j].DrawCrushingVector();
  glPopAttrib();*/
}

void GrassEngine::drawTexture2D() const
{
  glPushAttrib(GL_ENABLE_BIT);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  glOrtho(0.0,1.0,0.0,1.0,-1.0,1.0);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glLoadIdentity();
  glDisable(GL_DEPTH_TEST); 
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  glDisable(GL_LIGHTING);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D,ms_textureOnGrass.getGLTextureId());
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
  glColor3f(1.0f,1.0f,1.0f);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f,0.0f);glVertex2f(0.1f,0.0f);
  glTexCoord2f(0.0f,1.0f);glVertex2f(0.1f,0.5f);
  glTexCoord2f(1.0f,1.0f);glVertex2f(0.6f,0.5f);
  glTexCoord2f(1.0f,0.0f);glVertex2f(0.6f,0.0f);
  glEnd();

  glDisable(GL_LIGHTING);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  glEnable(GL_TEXTURE_2D);
  glBindTexture(GL_TEXTURE_2D,ms_texture2D.getGLTextureId());
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);
  glColor3f(1.0f,1.0f,1.0f);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f,0.0f);glVertex2f(0.5f,0.5f);
  glTexCoord2f(0.0f,1.0f);glVertex2f(0.5f,1.0f);
  glTexCoord2f(1.0f,1.0f);glVertex2f(1.0f,1.0f);
  glTexCoord2f(1.0f,0.0f);glVertex2f(1.0f,0.5f);
  glEnd();

  glDisable(GL_BLEND);
  glDisable(GL_TEXTURE_2D);
  glColor3f(1.0f,0.0f,0.0f);
  glBegin(GL_LINES);
  glVertex2f(0.1f,0.0f);
  glVertex2f(0.1f,0.5f);
  glVertex2f(0.6f,0.0f);
  glVertex2f(0.6f,0.5f);
  glEnd();

  glBegin(GL_LINES);
  for (short i=1;i<GRASS_NUMBER_PATCHE_TYPE;i++)
	  {
	  glVertex2f(0.5f+i*GRASS_NUMBER_PATCHE_TYPE_1*0.5f,0.5f);
	  glVertex2f(0.5f+i*GRASS_NUMBER_PATCHE_TYPE_1*0.5f,1.0f);
	  }
  glEnd();

  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();
  glPopAttrib();
}

void GrassEngine::drawTexture2D5() const
{
  glPushAttrib(GL_ENABLE_BIT);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix();
  glLoadIdentity();
  glOrtho(0.0,1.0,0.0,1.0,-1.0,1.0);
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix();
  glLoadIdentity();
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   
  glDisable(GL_DEPTH_TEST); 
  glEnable(GL_TEXTURE_2D); 
  glDisable(GL_BLEND);
  glDisable(GL_BLEND);
  glBindTexture(GL_TEXTURE_2D,ms_texture2D5.getGLTextureId());
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  
  glColor3f(1.0f,1.0f,1.0f);
  glBegin(GL_QUADS);
  glTexCoord2f(0.0f,0.0f);glVertex2f(0.0f,0.0f);
  glTexCoord2f(0.0f,1.0f);glVertex2f(0.0f,1.0f);
  glTexCoord2f(1.0f,1.0f);glVertex2f(1.0f,1.0f);
  glTexCoord2f(1.0f,0.0f);glVertex2f(1.0f,0.0f);
  glEnd();
	
  glDisable(GL_BLEND);
  glDisable(GL_TEXTURE_2D);
  glColor3f(1.0f,0.0f,0.0f);
  glBegin(GL_LINES);
  for (short i=1;i<GRASS_NUMBER_PATCHE_TYPE;i++)
	  {
	  glVertex2f(i*GRASS_NUMBER_PATCHE_TYPE_1,0.0f);
	  glVertex2f(i*GRASS_NUMBER_PATCHE_TYPE_1,1.0f);
	  }
  glEnd();

  glMatrixMode(GL_PROJECTION);
  glPopMatrix();
  glMatrixMode(GL_MODELVIEW);
  glPopMatrix();
  glPopAttrib();
}

void GrassEngine::initCreateTexture()
{
  if (m_textureOnGrass)
  {
  glPushAttrib(GL_ENABLE_BIT | GL_HINT_BIT | GL_COLOR_BUFFER_BIT); 
  glDisable(GL_BLEND);
  glDisable(GL_LIGHTING);
  glEnable(GL_TEXTURE_2D);
  //ne marche pas sur ma TNT ???
  	//glEnable(GL_POLYGON_SMOOTH);	
  	//glHint(GL_POLYGON_SMOOTH_HINT,GL_NICEST);
  glClearColor(0.0,0.0,0.0,0.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glBindTexture(GL_TEXTURE_2D,ms_textureOnGrass.getGLTextureId());
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);	
  }
  else
  {
  glPushAttrib(GL_ENABLE_BIT | GL_HINT_BIT | GL_COLOR_BUFFER_BIT); 
  glDisable(GL_BLEND);
  glDisable(GL_LIGHTING);
  glDisable(GL_TEXTURE_2D);
  //ne marche pas sur ma TNT ???
  	//glEnable(GL_POLYGON_SMOOTH);	
  	//glHint(GL_POLYGON_SMOOTH_HINT,GL_NICEST);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glClearColor(0.0,0.0,0.0,0.0);
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  }
}

void GrassEngine::endCreateTexture()
{
  glPopAttrib();
  if (m_textureOnGrass)
  {
  glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);	
  }
}

void GrassEngine::makeTexture2D()
{
  initCreateTexture();
  
//  GRandRealRandomSeed(m_graineTexture2D);
  
  ms_texture2D.unloadGLTexture();
  ms_texture2D.loadMapGrassTex2D(GRASS_TEXTURE2D_SIZE_X,GRASS_TEXTURE2D_SIZE_Y,
   SharedData::m_numberMaxGrassesPerPatche,
   1.0f/sqrt(m_patchesLength*m_patchesLength+m_patchesWidth*m_patchesWidth));

  short antiAliasing=(short)(m_antiAliasingTexture2D*10);
  antiAliasing=10-antiAliasing;
  ms_texture2D5.filteringChannelOnMap(3,antiAliasing);
  
  ms_texture2D.loadGLTexture(GL_RGBA,true);
  ms_texture2D.unloadMap(); 
   
  endCreateTexture();
}

void GrassEngine::makeTexture2D5()
{
  initCreateTexture();
  
//  GRandRealRandomSeed(m_graineTexture2D5);  
  ms_texture2D5.unloadGLTexture();
  ms_texture2D5.loadMapGrassTex2D5(m_Texture2D5SizeX,m_Texture2D5SizeY,
  SharedData::m_numberMaxGrassesPerPatche/2,
  1.0f/sqrt(m_patchesLength*m_patchesLength+m_patchesWidth*m_patchesWidth));
  //TODO -> demander a Fabrice quelques explications sur le mipmap
  //     ->taille de la texture pas forcement necessaire d'etre si grande
  //	 si au premier niveau d'affichage le mipmap est deja active...
  //     ->peut etre ce serai bien de faire une texture grande et
  //       faire une texture plus petite manuellement.
  //pas forcement necessaire
  //ms_texture2D5.filteringOnMap(3,1);
  
  //modif color : pour eviter l'effet d'assombrissement de la texture
  //lors de l'utilisation des mipmaps : peut etre existe t-il une
  //technique connu mais je n'ai pas trouve...
  //TODO -> demander a Fabrice.
  ms_texture2D5.extendColorOnMap(ms_texture2D5.getCols()/20);
  short antiAliasing=(short)(m_antiAliasingTexture2D5*10);
  if (antiAliasing!=0)
  	{
	ms_texture2D5.filteringChannelOnMap(3,6-((short)(m_antiAliasingTexture2D5*10))/2);
  	}
  if (antiAliasing>5)
  	{
  	ms_texture2D5.filteringChannelOnMap(3,11-(short)(m_antiAliasingTexture2D5*10));
  	}
	
  ms_texture2D5.loadGLTexture(GL_RGBA,true);
  ms_texture2D5.unloadMap();
  
  endCreateTexture();
} 

void GrassEngine::regenerateTexture2D5()
{
//  GRandRealRandomSeed(m_graineTexture2D5);
  m_graineTexture2D5=int(GRandRealRandom()*1000);
  makeTexture2D5();	
}

void GrassEngine::setAntiAliasingTexture2D5(GReal r)
{
  m_antiAliasingTexture2D5=r;
  makeTexture2D5();	
}

void GrassEngine::setTextureOnGrass(bool b)
{
  m_textureOnGrass=b;
  makeTexture2D();makeTexture2D5();
}

void GrassEngine::setAntiAliasingTextureOnGrass(GReal r)
{
  m_antiAliasingTexture3D=r;
  setFileTextureOnGrass(m_fileTextureOnGrass);	
}	

void GrassEngine::setFileTextureOnGrass(const char* file)
{
  strcpy(m_fileTextureOnGrass,file);
  ms_textureOnGrass.unloadGLTexture();
  if (!ms_textureOnGrass.loadMap(file)) return;
  ms_textureOnGrass.addAlphaChannel(255);
  ms_textureOnGrass.decreaseOpacityOnVBorder(m_antiAliasingTexture3D);
  ms_textureOnGrass.loadGLTexture(GL_RGBA,true);
  ms_textureOnGrass.unloadMap();
  makeTexture2D();makeTexture2D5();
}
  



GReal GrassEngine::getDensityAtPosition(const GReal& x, const GReal& y)
{
  GReal moyDensite;
  short ix,iy;
  ix= short(((x-m_area[0])*m_numberOfPatchesInLength)/m_areaLength);
  iy= short(((y-m_area[1])*m_numberOfPatchesInWidth)/m_areaWidth);
  if (ix<0 || ix>=m_numberOfPatchesInLength) return 0.0;
  if (iy<0 || iy>=m_numberOfPatchesInWidth) return 0.0;
  moyDensite=m_pNoeuds[ix][iy].m_grassDensity
	    +m_pNoeuds[ix+1][iy].m_grassDensity
	    +m_pNoeuds[ix][iy+1].m_grassDensity
	    +m_pNoeuds[ix+1][iy+1].m_grassDensity;
  moyDensite*=0.25;

  return (moyDensite*SharedData::m_numberMaxGrassesPerPatche);
}



GReal GrassEngine::getDensityMapAtPosition(const GReal& x, const GReal& 
y,const unsigned char* densityMap,const int densityMapCols,const int densityMapRows) const
{
  int indice;
  GReal rValue;
  GReal gValue;
  GReal bValue;
  if (densityMap==NULL) return 1.0;
  if (densityMapCols==0 && densityMapRows==0) return 1.0;
  indice=int(((x-m_area[0])/m_areaLength)*(densityMapCols-1))*3 + 
	 int(((y-m_area[1])/m_areaWidth)*(densityMapRows-1))*densityMapCols*3;
  rValue=GReal(densityMap[indice]);
  gValue=GReal(densityMap[indice+1]);
  bValue=GReal(densityMap[indice+2]);
  return (rValue+gValue+bValue)*(1.0/765); 
}



