#include "GrassInterface.h"
#include "GeometrieBase.hpp"
#include "GrassEngine.h"
#include "VolumeVision.hpp"

#include "GrassDefines.h"
#include <iostream>
#include <stdio.h>


//--------------------------------------
//----------variables globales----------
//--------------------------------------

short g_drawOption=DRAWOPTION_NONE;
int   g_numberDrawingPG;

//--------------------------------------
//--------------------------------------


GrassEngine grassEngine;

//-----------------------------------------------------------------------------
//----------------------------fonctions principales----------------------------
//-----------------------------------------------------------------------------

void grassInit(const float area[4],
               const short& numPatchesInLength,
	       const short& numPatchesInWidth,
	       const char* fileDensityMap)
{
//tmp
char lfileDensityMap[256];
strcpy(lfileDensityMap,fileDensityMap);
grassEngine.init(area,numPatchesInLength,numPatchesInWidth,lfileDensityMap);
}

void grassUpdate(float dt,
	         GrassTrajectory* pTrajectories,
	         const short& numberOfTrajectories)
{
grassEngine.update(dt, pTrajectories, numberOfTrajectories);
}

void grassPreDraw(float cameraPosition[3])
{
grassEngine.predraw(Point3(cameraPosition[0],cameraPosition[1],cameraPosition[2]));
}

void grassDraw()
{
g_numberDrawingPG=0;
grassEngine.draw();
}


//-----------------------------------------------------------------------------
//----------------------------fonctions secondaires----------------------------
//-----------------------------------------------------------------------------

void grassSetHeight(const float& d)
{
grassEngine.setGrassHeight(d);
}

void grassSetWidth(const float& d)
{
grassEngine.setGrassWidth(d);
}
void grassSetNoisePositions(const float& d)
{
grassEngine.setNoisePositions(d);
}
void grassSetNoiseNormals(const float& d)
{
grassEngine.setNoiseNormals(d);
}
void grassSetNumberPerSquareMeters(const short& n)
{
grassEngine.setNumberPerSquareMeters(n);
}
void grassSetTextureOnGrass(bool b)
{
grassEngine.setTextureOnGrass(b);
}
void grassSetFileTextureOnGrass(const char* file)
{
grassEngine.setFileTextureOnGrass(file);
}
void grassSetAntiAliasingTextureOnGrass(float d)
{
grassEngine.setAntiAliasingTextureOnGrass(d);
}
void grassRegenerateTexture2D5()
{
grassEngine.regenerateTexture2D5();
}
void grassSetAntiAliasingTexture2D5(float d)
{
grassEngine.setAntiAliasingTexture2D5(d);
}
void grassSetSizeTexture2D5(int x, int y)
{
grassEngine.setSizeTexture2D5(x,y);
}
void grassSetGraineTexture2D5(int i)
{
grassEngine.setGraineTexture2D5(i);
}
//CRUSHING BEHAVIOR
void grassSetCrushingMaxTime(const float& d)
{
grassEngine.setCrushingMaxTime(d);
}

void grassSetCrushingDamping(const float& d)
{
grassEngine.setCrushingDamping(d);
}


//LOD
void grassSetDistance3D(const float& d)
{
grassEngine.setDistance3D(d);
}

void grassSetDistance2D5(const float& d)
{
grassEngine.setDistance2D5(d);
}

void grassSetDistance2D(const float& d)
{
grassEngine.setDistance2D(d);
}

void grassSetPG3DGrass(const short& n)
{
grassEngine.setNumberPG3D(n);
}

void grassSetPG2D5Grass(const short& n)
{
grassEngine.setNumberPG2D5(n);
}



void grassSetAjustmentHeight2D5(bool b)
{
grassEngine.setAjustmentHeight2D5(b);
}

//RETURN INFOS
int grassGetPolygonsDrawedPerFrame()
{
return g_numberDrawingPG;
}
float grassGetDensityPerSquareMeterAtPosition(const float& x, const float& y)
{
return grassEngine.getDensityAtPosition(x,y);
}



//RETURN PARAM
float grassGetAreaXMin()
{
return grassEngine.getAreaXMin();
}
float grassGetAreaXMax()
{
return grassEngine.getAreaXMax();
}
float grassGetAreaYMin()
{
return grassEngine.getAreaYMin();
}
float grassGetAreaYMax()
{
return grassEngine.getAreaYMax();
}
float grassGetAreaLength()
{
return grassEngine.getAreaLength();
}
float grassGetAreaWidth()
{
return grassEngine.getAreaWidth();
}

short grassGetNumberPatchesInLength()
{
return grassEngine.getNumberOfPatchesInLength();
}
short grassGetNumberPatchesInWidth()
{
return grassEngine.getNumberOfPatchesInWidth();
}
const char* grassGetFileDensityMap()
{
return grassEngine.getFileDensityMap();
}
bool grassIsTextureOnGrass()
{
return grassEngine.isTextureOnGrass();
}
const char* grassGetFileTextureOnGrass()
{
return grassEngine.getFileTextureOnGrass();
}
float grassGetAntiAliasingTextureOnGrass()
{
return grassEngine.getAntiAliasingTextureOnGrass();
}
float grassGetAntiAliasingTexture2D5()
{
return grassEngine.getAntiAliasingTexture2D5();
}
int grassGetGraineTexture2D5()
{
return grassEngine.getGraineTexture2D5();
}
void grassGetSizeTexture2D5(int& x, int &y)
{
grassEngine.getSizeTexture2D5(x,y);
}
float grassGetHeight()
{
return grassEngine.getGrassHeight();
}
float grassGetWidth()
{
return grassEngine.getGrassWidth();
}
float grassGetNoisePositions()
{
return grassEngine.getNoisePositions();
}
float grassGetNoiseNormals()
{
return grassEngine.getNoiseNormals();
}
short grassGetNumberPerSquareMeters()
{
return grassEngine.getNumberPerSquareMeters();
}
bool grassGetAjustmentHeight2D5()
{
return grassEngine.getAjustmentHeight2D5();
}
float grassGetCrushingMaxTime()
{
return grassEngine.getCrushingMaxTime();
}
float grassGetCrushingDamping()
{
return grassEngine.getCrushingDamping();
}
float grassGetDistance3D()
{
return grassEngine.getDistance3D();
}
float grassGetDistance2D5()
{
return grassEngine.getDistance2D5();
}
float grassGetDistance2D()
{
return grassEngine.getDistance2D();
}
short grassGetPG3DGrass()
{
return grassEngine.getNumberPG3D();
}
short grassGetPG2D5Grass()
{
return grassEngine.getNumberPG2D5();
}



//OPTION DRAW
void grassDrawDensity()
{
grassEngine.drawDensity();
}

void grassDrawTrajectory()
{
grassEngine.drawTrajectory();
}

void grassDrawCrushingVector()
{
grassEngine.drawCrushingVector();
}

void grassDrawInWireMode()
{
g_numberDrawingPG=0;
g_drawOption=DRAWOPTION_WIRE;
grassEngine.draw();
g_drawOption=DRAWOPTION_NONE;
}

void grassDrawNoeuds()
{
grassEngine.drawNoeuds();
}
void grassDrawTexture2D()
{
grassEngine.drawTexture2D();
}
void grassDrawTexture2D5()
{
grassEngine.drawTexture2D5();
}

