#include "Noeud.hpp"

#include "GrassInterface.h"
#include "GrassDefines.h"

//---------------------------------------------------------------------------------
//----------------------------------Node-------------------------------------------
//---------------------------------------------------------------------------------


Noeud::Noeud()
{
m_isActive = false;
m_initGrassCurve[0]=GRandRealRandom()*1.0-0.5;
m_initGrassCurve[1]=GRandRealRandom()*1.0-0.5;

m_heightGrass=1.5;
m_heightGrassDraw=m_heightGrass;

m_heightTex2D=0.0;
m_typeOfDrawing=DRAWGRASS_NONE;
}

void Noeud::setPosition(const Point3& position)
{
m_position=position;
//construction de l'herbe
//donnees constantes
m_grass._pos0[0] = m_position[0];
m_grass._pos0[1] = m_position[1];
m_grass._pos0[2] = m_position[2];
}

void Noeud::setTex2DHeight(GReal height)
{
if (height>m_heightTex2D) m_heightTex2D=height;
}

void Noeud::SetGrassHeight(const GReal& hauteur)
{
m_heightGrass = hauteur;
m_heightGrassDraw=m_heightGrass;
}


//---------------------------------------------------------------------------------
//-------------------------------NodeCrushing-----------------------------------------
//---------------------------------------------------------------------------------


GReal NodeCrushing::ms_crushingMaxTime=20.0;
GReal NodeCrushing::ms_crushingDamping=2.0;

NodeCrushing::NodeCrushing()
{
m_isActive = false;
m_isCrushed = false;
m_crushingCurrentPower=0.0f;
m_crushingCurrentTime=0.0f;
m_crushingMaxPower=0.0f;
m_crushingMaxTime=0.0f;
}

void NodeCrushing::setPosition(const Point3& position)
{
m_position=position;
}
	
/*	
/// fonction de verification	
/// dessine tangeantes a l'herbe
void DrawTangeantes() const;
///fonction de verification	
/// dessine vecteurs d'ecrasement
void DrawCrushingVector() const;
void Noeud::DrawTangeantes() const
		{
		glDisable(GL_LIGHTING);
		glColor3f(1.0,0.0,0.0);
		glBegin(GL_LINES);
			glVertex3f(m_grass._pos0[0],
					   m_grass._pos0[1],
					   m_grass._pos0[2]);
			glVertex3f(m_grass._pos0[0]+m_grass._tan0[0],
					   m_grass._pos0[1]+m_grass._tan0[1],
					   m_grass._pos0[2]+m_grass._tan0[2]);
			
			glVertex3f(m_grass._pos1[0],
					   m_grass._pos1[1],
					   m_grass._pos1[2]);
			glVertex3f(m_grass._pos1[0]+m_grass._tan1[0],
					   m_grass._pos1[1]+m_grass._tan1[1],
					   m_grass._pos1[2]+m_grass._tan1[2]);
		glEnd();
		glEnable(GL_LIGHTING);
		}	
void Noeud::DrawCrushingVector() const
		{
		if (m_crushingCurrentPower==0.0) return;
		glBegin(GL_TRIANGLES);
		glVertex3f(m_position[0]+0.04,m_position[1],m_position[2]);
		glVertex3f(m_position[0]-0.04,m_position[1],m_position[2]);
		glVertex3f(m_position[0]+m_crushingDirection[0],
			   m_position[1]+m_crushingDirection[1],
			   m_position[2]+m_crushingCurrentPower*0.001);
		glEnd();
		}
*/
