#ifndef _grass_shared_data_
#define _grass_shared_data_

#include "GrassDefines.h"
#include "GeometrieBase.hpp"
#include "VolumeVision.hpp"

struct SharedData
  {
  //flag
  static bool m_enableAjustmentHeight2D5;
  static bool m_enableCrushingHighPrecision;
  
  static void setAjustmentHeight2D5(bool b);
  static void setCrushingHighPrecision(bool b);
  
  //lod
  static GReal m_distance3D;
  static GReal m_distance3D_1;
  static GReal m_distance2D5;
  static GReal m_distance2D5_1;
  static GReal m_distance2D;
  static GReal m_distance2D_1;
  
  static GReal m_distanceTransition3D_2D5;
  static GReal m_distanceTransition3D_2D5_1;
  
  static short m_numberPG3D;
  static short m_numberPG2D5;

  static void setDistance3D(GReal d);
  static void setDistance2D5(GReal d);
  static void setDistance2D(GReal d);
  static void setNumberPG3D(short n);
  static void setNumberPG2D5(short n);
  
  //attributes
  static short m_numberGrassesPerSquareMeters;
  static short m_numberMaxGrassesPerPatche;
  
  static void setNumberGrassesPerSquareMeters(short n);
  static void setNumberMaxGrassesPerPatche(short n);
  
  //camera
  static 	Point3 	m_cameraPosition;
  static 	  Vec3 	m_cameraBillboard;
  static 	  Vec2 	m_cameraDirection;
  static  VolumeVision 	m_cameraVolumeVision;
  
  static void updateCamera(const Point3& cameraPosition);
  };

#endif
