

#ifndef _textureGrass_
#define _textureGrass_

#include "GrassDefines.h"
#include <GL/gl.h>
#include <GL/glu.h>
#include <stdio.h>

/** \class TextureGrass
\brief permet la construction d'une texture openGL
ou la recuperation d'une image
format supporte : BMP, PPM.
permet de plus la construction de map d'herbes

*/
class TextureGrass
{
public:
TextureGrass();
~TextureGrass();

bool loadMap(const char * filename);
bool loadMapGrassTex2D5(int size_x, int size_y, int nb_grasses, 
			  GReal coef_GrassWidth);
bool loadMapGrassTex2D(int size_x, int size_y, int nb_grasses, 
		       GReal coef_GrassWidth);
bool addAlphaChannel(GLubyte defaultValue);
bool decreaseOpacityOnVBorder(float coef);
bool filteringChannelOnMap(short channel, short coefLastValue=1);
bool extendColorOnMap(short nbpixels);
bool concatMap(const GLubyte* map, int rows, int cols, bool alphaChannel); 
bool concatMap(const TextureGrass& textureGrass);
void unloadMap();

void loadGLTexture(GLint internalFormat, bool mipmap=false);
void unloadGLTexture();

bool haveMap() {return (_map!=NULL);}
bool haveAlphaChannel() {return _alphaChannel;}
int getCols() {return _cols;}
int getRows() {return _rows;}
void getMap(unsigned char** map, int* cols, int* rows) 
	      {*map=(unsigned char*)_map; *cols=_cols; *rows=_rows;}
bool haveGLTexture() {return (_textureId!=0);}
GLuint getGLTextureId() {return _textureId;}

private:
int _cols,_rows;
bool _alphaChannel;
GLuint  _textureId;
GLubyte* _map;

private:
void make_with_PPM(const char*);
void make_with_BMP(const char*);
void make_with_TGA(const char*);
char pm_getc(FILE* file);
int pm_getint( FILE* file);
int pm_getrawbyte(FILE* file);
GLubyte Max(GLubyte a, GLubyte b) {if (a>b) return a; return b;}

void glPushAttribAndMatrix();
void glPopAttribAndMatrix();
};


#endif /* _textureGrass_ */
