
#include "GroundInterface.h"
#include "Ground.h"

Terrain ground;

void groundInit(const float area[4],const float& maxHeight,
                int numberOfQuadsMax, const char* fileHeightMap,
	        const char* fileTexture, const float& repeatTexture)
{
printf("Creation du terrain.\n");
if (fileHeightMap!=NULL) printf("  heightmap : %s\n",fileHeightMap);
if (fileTexture!=NULL) printf("  texture : %s\n",fileTexture);
ground.init(area, maxHeight, numberOfQuadsMax,
	    fileHeightMap, fileTexture, repeatTexture);
}		

void groundQuit()
{
//rien pour l'instant...
}

void groundDraw()
{
ground.draw();
}

const float* groundGetArea()
{
return ground.getArea();
}

float groundGetXMin()
{
return ground.getXMin();
}

float groundGetYMin()
{
return ground.getYMin();
}

float groundGetXMax()
{
return ground.getXMax();
}

float groundGetYMax()
{
return ground.getYMax();
}

float groundGetLength()
{
return (ground.getLength());
}

float groundGetWidth()
{
return (ground.getWidth());
}

float groundGetMaxHeight()
{
return (ground.getMaxHeight());
}

const char* groundGetFileHeightMap()
{
return (ground.getFileHeightMap());
}

const char* groundGetFileTexture()
{
return (ground.getFileTexture());
}

int groundGetNumberOfQuadsMax()
{
return (ground.getNumberOfQuadsMax());
}

float groundGetRepeatTexture()
{
return (ground.getRepeatTexture());
}

bool groundIsPositionInside(const float& x, const float& y)
{
return (ground.isPositionOk(x,y));
}

float groundGetHeightAtPosition(const float& x, const float& y)
{
return (ground.getHeightAtPosition(x,y));
}

void groundGetNormalAtPosition(const float& x, const float& y, float normal[3])
{
Vec3 vec3Normal=ground.getNormalAtPosition(x, y);
normal[0]=vec3Normal[0];
normal[1]=vec3Normal[1];
normal[2]=vec3Normal[2];
}



