#ifndef _ground_interface_h_
#define _ground_interface_h_

#include <libxml/parser.h>

//FCTS PRINCIPALE
void groundInit(const float area[4],const float& maxHeight,
                int numberOfQuadsMax,const char* fileHeightMap,
	        const char* fileTexture, const float& repeatTexture);		
void groundQuit();
void groundDraw();

//GET INFO
bool groundIsPositionInside(const float& x, const float& y);
float groundGetHeightAtPosition(const float& x, const float& y);
void groundGetNormalAtPosition(const float& x, const float& y, float normal[3]);

//GET PARAM
const float* groundGetArea();
float groundGetXMin();
float groundGetYMin();
float groundGetXMax();
float groundGetYMax();
float groundGetLength();
float groundGetWidth();
float groundGetMaxHeight();

const char* groundGetFileHeightMap();
const char* groundGetFileTexture();
float groundGetRepeatTexture();
int groundGetNumberOfQuadsMax();

//XML
bool groundLoadXML(const char* filename);
bool groundLoadXML(xmlNodePtr nodePrairie);
void groundSaveXML(xmlNodePtr p_nodePrairie);

#endif
