

#ifndef _image_
#define _image_

#include <GL/gl.h>
#include <GL/glu.h>
#include <stdio.h>

/** \class Image
\brief permet la construction d'une texture openGL
ou la recuperation d'une image
format supporte : BMP, PPM.


*/
class Image
{
public:
Image();
~Image();

bool loadMap(const char * filename);
void unloadMap();

void loadGLTexture(bool mipmap=true);
void unloadGLTexture();

bool haveMap() {return (_map!=NULL);}
void getMap(unsigned char** map, int* cols, int* rows) 
		      {*map=(unsigned char*)_map; *cols=_cols; *rows=_rows;}

bool haveGLTexture() {return (_textureId!=0);}
GLuint getGLTextureId() {return _textureId;}

private:
int _cols,_rows;
GLuint  _textureId;
GLubyte* _map;

private:
int swapInt(int i);
void make_with_PPM(const char*);
void make_with_BMP(const char*);
char pm_getc(FILE* file);
int pm_getint( FILE* file);
int pm_getrawbyte(FILE* file);
};


#endif /* _image_ */
