// ****************************************************************************
// * NAME:  WindInterface.h
// * GROUP: 
// * --------------------------------------------------------------------------
// * PURPOSE: interface de la librairie : permet la gestion du vent 
// * 
// *	      
// * --------------------------------------------------------------------------
// * RELEASE: 
// * AUTHOR: Sylvain Guerraz 
// * COPYRIGHT: 
// ****************************************************************************

#ifndef __WIND_INTERFACE_H__
#define __WIND_INTERFACE_H__

#include <libxml/parser.h>
#include "InformationPrimitive.hpp"
//-----
void windInit (const float area[4], const float heightForDrawingWind);
void windQuit();
void windUpdate(const float& dt);
InformationVent windGetBreeze(const float& x, const float& y);
void windAddGust(const float& length, const float& width);
void windAddBlast(const float& rayon);
void windGetLocalInfluence(const float& x, const float& y,
			   const float& windInitPower,
			   const float& windInitDirX,
			   const float& windInitDirY,
			   float& windPower, 
			   float& windDirX,
			   float& windDirY);
void windGetLocalInfluence(const short& numberDtPrecedent, 
			   const float& x, const float& y,
			   float& windPower, 
			   float& windDirX,
			   float& windDirY);

//-----
void windSetBreezePower(const float& power);
float windGetBreezePower();

void windSetBreezeSpeed(const float& speed);
float windGetBreezeSpeed();

void windSetGustPower(const float& power);
float windGetGustPower();

void windSetBlastPower(const float& power);
float windGetBlastPower();

void windSetGustSpeed(const float& speed);
float windGetGustSpeed();

void windSetBlastParam(const float& param);
float windGetBlastParam();

void windDrawGusts();
//-----

			

//-----XML
bool windLoadXML(const char* filename);
bool windLoadXML(xmlNodePtr nodePrairie);
void windSaveXML(xmlNodePtr p_nodePrairie);



#endif
