/* 
		alea_2d_float_field: specification

		Author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _alea_2d_float_field_
#define _alea_2d_float_field_

#include <iostream>
#include "float_field.h"
#include "geometrie.h"
#include "ressource.h"


//! Class alea_2d_float_field
/*!
MORE COMMENT ABOUT THE CLASS
*/

class alea_2d_float_field: public float_field
{
private:

	/////////////////////////////////
	// atributs of the class:

	//! pointer to an volume_vector in ressource:
	ressource::ty_volume_float* pt_vol;
	
	//! decalage of the x index for abssis of point2d
	int a_dec_x;
	//! decalage of the y index for abssis of point2d
	int a_dec_y;
	//! decalage of the t index for abssis of point2d
	int a_dec_t;
	
	//! decalage of the x index for ordinate of point2d
	int b_dec_x;
	//! decalage of the y index for ordinate of point2d
	int b_dec_y;
	//! decalage of the t index for ordinate of point2d
	int b_dec_t;
	
	//! optimize the field for x in [0,coef_x]
	float coef_x;	
	//! optimize the field for y in [0,coef_y]
	float coef_y;	
	//! optimize the field for t in [0,coef_t]
	float coef_t;
	
	// end of atributs of the class.
	/////////////////////////////////
	
public:

	/////////////////////////////////
	// methods of the class

	//! get the 2d value of the function
	geometrie::point2d get_value(float x,float y, float t);
	
	//! the default constructor
	/*! 
	*/
	alea_2d_float_field(ressource::ty_volume_float* pt,float cx=10.0,float cy=10.0,float ct=10.0);
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	alea_2d_float_field(const alea_2d_float_field& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	alea_2d_float_field& operator=(const alea_2d_float_field& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	~alea_2d_float_field();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const alea_2d_float_field& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _alea_2d_float_field_ */
