/* 
		birth: specification

		Author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _birth_
#define _birth_

#include <iostream>
#include "slice_of_life.h"
#include <typeinfo>

//! Class birth
/*!
MORE COMMENT ABOUT THE CLASS
*/

template<class T>
class birth: public slice_of_life<T>
{
public:

	/////////////////////////////////
	// atributs of the class:


	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	//! make the primitive born
	virtual void action();

	//! make the slice of life active
	virtual void activate();
	
	//! make the slice of life dead
	virtual void deactivate();
	
	//! print the object
	virtual void print(std::ostream& os) const { os<<*this;};		

	//! the default constructor
	/*! 
	*/
	birth(T* pt,date s,date e);
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	birth(const birth& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	birth& operator=(const birth& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~birth();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	inline friend std::ostream& operator<<(std::ostream& os, const birth<T>& obj)
	{
		debug_frank::process_tab();
		os<<debug_frank::tab<<typeid(obj).name()<<" from "<<obj.start<<" to "<<obj.end<<std::endl;
		debug_frank::unprocess_tab();
		return os;
	};


	// end of methods of the class
	/////////////////////////////////
};

#include "birth.inl"

#endif /* _birth_ */
