/* 
		blast_of_air: corps de la classe

		Author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "blast_of_air.h"

#include "debug.h"

	
// the default constructor
blast_of_air::blast_of_air(circle* f,birth<blast_of_air>* b,death<blast_of_air>* d)
:wind_primitive(f,b->start,d->end,200.0),my_life(new life<blast_of_air>(b,d))
{
	b->pt_prim=this;
	d->pt_prim=this;
}

// the copy constructor
blast_of_air::blast_of_air(const blast_of_air& obj)
:wind_primitive(obj)
{
	debug_frank::error("No copy constructor implemented in the class blast_of_air.\n",1);
}

// the assignement constructor:
blast_of_air& blast_of_air::operator=(const blast_of_air& obj)
{
	if (this != &obj)
	{
		debug_frank::error("No assignement implemented in the class blast_of_air.\n",1);
	}
	return *this;
}

// the destructor: 
blast_of_air::~blast_of_air()
{
	delete my_life;
}
