/* 
		bounding_box2d: specification

		Author: Frank Perbet

		Versions:
 			- 2001/07/26

*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _bounding_box2d_
#define _bounding_box2d_

#include <iostream>
#include "debug.h"
#include "math_perso.h"
#include "geometrie.h"

//! Class bounding_box2d
/*!
MORE COMMENT ABOUT THE CLASS
*/

class bounding_box2d
{
public:

	/////////////////////////////////
	// atributs of the class:

	float max_x;
	float min_x;
	float max_y;
	float min_y;

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	
	geometrie::point2d alea(int i)
	{
		geometrie::point2d res;
		float tmp=math_perso::random();
//		std::cerr<<tmp<<"\n";
		switch (i)
		{
			case 0:
			{
				res=geometrie::point2d(min_x,tmp*min_y+(1-tmp)*max_y);
				break;
			}
			case 1:
			{
				res=geometrie::point2d(max_x,tmp*min_y+(1-tmp)*max_y);
				break;
			}
			case 2:
			{
				res=geometrie::point2d(tmp*min_x+(1-tmp)*max_x,min_y);	
				break;
			}
			case 3:
			{
				res=geometrie::point2d(tmp*min_x+(1-tmp)*max_x,max_y);	
				break;
			}
			default :
			{
				assert(false);
				break;
			}
		}
		return res;
	}
	
	//! the constructor
	/*! 
	*/
	bounding_box2d(float mi_x,float ma_x,float mi_y,float ma_y):
		max_x(ma_x),min_x(mi_x),max_y(ma_y),min_y(mi_y)
		{assert( (min_x<max_x)& (min_y<max_y));};	
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const bounding_box2d& obj)
	{
		os<<debug_frank::tab<<"min_x="<<obj.min_x<<"max_x="<<obj.max_x;
		os<<debug_frank::tab<<"min_y="<<obj.min_y<<"min_y="<<obj.max_y;
		return os;
	}

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _bounding_box2d_ */
