/* 
		breeze: corps de la classe

		author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "breeze.h"

#include "debug.h"

	
// the default constructor
breeze::breeze(figure2d* f,birth<breeze>* b,death<breeze>* d)
:wind_primitive(f,b->start,d->end,50.0),my_life(new life<breeze>(b,d))
{
	b->pt_prim=this;
	d->pt_prim=this;
}

// the copy constructor
breeze::breeze(const breeze& obj)
:wind_primitive(obj)
{
	debug_frank::error("No copy constructor implemented in the class breeze.\n",1);
}

// the assignement constructor:
breeze& breeze::operator=(const breeze& obj)
{
	if (this != &obj)
	{
		debug_frank::error("No assignement implemented in the class breeze.\n",1);
	}
	return *this;
}

// the destructor: 
breeze::~breeze()
{
	delete my_life;
}
