/* 
		circle: corps de la classe

		Author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "circle.h"

#include "debug.h"

//! give the bounding box of the circle
bounding_box2d circle::give_bounding_box() const
{
	assert(false);
	return bounding_box2d(0,0,0,0);
}

//! test if p is inside the figure
float circle::is_point2d_inside(const geometrie::point2d &p) const
{
	float tmp=radius-(p-r.origin).norme();
	tmp=tmp>0?tmp/radius:0.0;
	return tmp;
}

//! test if the figure intersect the rectangle r
bool circle::intersection_with_bounding_box(const bounding_box2d r) const
{
	assert(false);
	return false;
}

// the default constructor
circle::circle(geometrie::point2d c,float r) throw(std::invalid_argument)
:figure2d(geometrie::repere2d(c,0)), radius(r)
{
	if((radius<0))
	{
		throw std::invalid_argument("circle.cpp:circle: radius<0");
	}
}

// the copy constructor
circle::circle(const circle& obj)
:figure2d(obj)
{
	this->radius=obj.radius;
}

// the assignement constructor:
circle& circle::operator=(const circle& obj)
{
	if (this != &obj)
	{
		this->figure2d::operator=(obj);
		this->radius=obj.radius;
	}
	return *this;
}

// the destructor: 
circle::~circle()
{}

// display
std::ostream& operator<<(std::ostream& os, const circle& obj)
{
	os<<"circle: center="<<obj.r.origin<<"  radius="<<obj.radius<<"\n";
	return os;
}
