/* 
		circle: specification

		Author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _circle_
#define _circle_

#include <iostream>
#include <stdexcept>
#include "figure2d.h"
#include "rectangle.h"
#include "geometrie.h"
#include "ogl_primitive.h"

extern float g_heightForDrawingWind;

//! Class circle
/*!
MORE COMMENT ABOUT THE CLASS
*/

class circle: public figure2d
{
public:

	/////////////////////////////////
	// atributs of the class:
	
	//! radius of the circle
	float radius;

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	//! test if the figure intersect the rectangle r
	virtual void ogl_draw() const
	{
		glPushAttrib(GL_LINE_BIT);
		glPushAttrib(GL_POLYGON_BIT);
	
		glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
		
		glPushMatrix();
		glTranslatef(r.origin.x,r.origin.y,g_heightForDrawingWind);
		glRotatef(r.angle*math_perso::CONV_rad_to_degree,0,0,1);

		glPushMatrix();
		glScalef(radius,radius,1.0);
		ogl::draw_disc();
		glPopMatrix();
		
		glLineWidth(2.0);
		glBegin(GL_LINES);
			glVertex3f(radius,0,0);
			glVertex3f(radius+radius/4,0,0);
		glEnd();

		glPopMatrix();

		glPopAttrib();
		glPopAttrib();
	}

	//! give the bounding box of the circle
	virtual bounding_box2d give_bounding_box() const;

	//! test if p is inside the figure
	virtual float is_point2d_inside(const geometrie::point2d &p) const;
	
	//! test if the figure intersect the rectangle r
	virtual bool intersection_with_bounding_box(const bounding_box2d b) const;
	
	//! the default constructor
	/*! 
	*/
	circle(geometrie::point2d c,float r) throw(std::invalid_argument);

	//! the default constructor
	/*! 
	*/
	circle(float r) throw(std::invalid_argument)
	:figure2d(geometrie::repere2d(geometrie::point2d(0,0),0)), radius(r) {}
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	circle(const circle& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	circle& operator=(const circle& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~circle();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const circle& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _circle_ */
