/* 
		date: specification

		Auteur: Frank Perbet

		Version:
 			- 21/04/2000 (version initiale) 
*/


/* 
	COMMENTAIRES:
		C'est l'heure!
		L'heure aurait pu etre considere comme un entier,
		mais peut-etre y aurait-il eu un pb qd on arrive
		a l'entier maximum...?

*/

/*************************************************************************/

#ifndef _date_bis_
#define _date_bis_

#include <iostream>

class date
{
protected:

	/////////////////////////////////
	// atributs de la classe:

	//! date:
	double t;
	
	//! value of the increment:
	static double delta_t;
	
	// fin atributs de la classe:
	/////////////////////////////////
	

public:
	
	/////////////////////////////////
	// fonction membre:

	//! set the date to tt:
	inline void set_date(double tt=0) { t=tt;};

	//! increment the date:	
	inline void increment_date() { t+=delta_t;};

	//! get the date value:	
	inline double get_date() const { return t; };

	//! set delta_t:	
	inline static void set_delta(double tt=0.04) { delta_t=tt;};
	
	//! set delta_t:	
	inline static double get_delta(double tt=0.04) {return delta_t; };

	//! set the barycenter distance;		
	inline float ratio(date a,date b) const
		{ return (this->t-a.t)/(b.t-a.t); };

	//! set the date to tt:	static double get_delta();	
	inline bool operator<(date d) const { return this->t<d.t;};
	
	//! set the date to tt:	static double get_delta();	
	inline bool operator>(date d) const { return this->t>d.t;};
	
	//! set the date to tt:	static double get_delta();	
	inline bool operator<=(date d) const { return this->t<=d.t;};
	
	//! set the date to tt:	static double get_delta();	
	inline bool operator>=(date d) const { return this->t>=d.t;};

	//! set the date to tt:	static double get_delta();	
	inline date& operator+=(double d) { t+=d; return *this;};
	
	//! set the date to tt:	static double get_delta();	
	inline date& operator-=(double d) { t-=d; return *this;};
	
	//! set the date to tt:	static double get_delta();	
	inline date operator+(date d) { return date(this->t+d.t);};
	
	//! set the date to tt:	static double get_delta();	
	inline date operator-(date d) { return date(this->t-d.t);};

	// contructeur:
	inline date(double tt=0): t(tt) {};
	
	// destructeur: 
	inline ~date() {};
	
	// constructeur par copie:
	inline date(const date& obj, double add=0)
		{t=obj.t+add;};
	
	// assignement:
	inline date& operator=(const date& obj)
		{ if (this != &obj) t=obj.t;return *this;}
	
		//! return the distance between the 2 dates.		
	inline friend float date_distance(date a,date b)
		{return ((b.t-a.t)>0) ? (b.t-a.t) :(a.t-b.t) ;};

	//! return the distance between the 2 dates.		
	inline friend float difference(date a,date b)
		{return (b.t-a.t);};

	// affichage
	inline friend std::ostream& operator<<(std::ostream& os, const date& obj)
		{ os<<"date="<<obj.t; return os;};
	
	// fin fonction membre.
	/////////////////////////////////

	static date horloge;
};

#endif /* _date_bis_ */
