/* 
		death: corps de la classe

		Author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "debug.h"

//! make the primitive follow the path
template<class T> void death<T>::action()
{
	this->pt_prim->power_coef=1.0-date::horloge.ratio(this->start,this->end);
}

//! make the slice of life active
template<class T> void death<T>::activate()
{
}

//! make the slice of life dead
template<class T> void death<T>::deactivate()
{
	this->pt_prim->am_i_dead=true;
}


// the default constructor
template<class T> death<T>::death(T* pt,date s,date e)
:slice_of_life<T>(pt,s,e)
{
}

// the copy constructor
template<class T> death<T>::death(const death<T>& obj)
:slice_of_life<T>(obj.pt_prim,obj.start,obj.end)
{
	debug_frank::error("No copy constructor implemented in the class death.\n",1);
}

// the assignement constructor:
template<class T> death<T>& death<T>::operator=(const death<T>& obj)
{
	if (this != &obj)
	{
		debug_frank::error("No assignement implemented in the class death.\n",1);
	}
	return *this;
}

// the destructor: 
template<class T> death<T>::~death()
{
}
