/* 
		camera: specification

		Author: Frank Perbet

		Versions:
 			- 2001/05/02
*/


/* 
	Comments: debug class

*/

/*************************************************************************/
#ifndef _debug_frank_
#define _debug_frank_

#include <iostream>
#include <string>
#include <assert.h>

typedef std::string string;

namespace debug_frank
{
	//! warning debug function
	void warning(char * text,int level=1);

	//! error debug function
	void error(char * text,int level=1);

	class global_blank
	{
	private:
		static int num_space;
		static int num_space_for_tab;
	public:
		static void process_tab() { num_space+=num_space_for_tab; };
		static void unprocess_tab() { num_space-=num_space_for_tab; assert(num_space>=0);};
		static void set_num_space_for_tab(int n) {assert(n>=0); num_space_for_tab=n;};
		static ::std::ostream& print(::std::ostream& os) {os<<::std::string(global_blank::num_space,' '); return os;}
	};

	inline void process_tab() { global_blank::process_tab(); }
	inline void unprocess_tab() { global_blank::unprocess_tab(); }
	inline std::ostream& tab(std::ostream& os) { return global_blank::print(os); };
	inline std::ostream& blank(std::ostream& os,int i) { return os<<::std::string(i,' '); };
}

#endif /* _debug_frank_ */
