/* 
		father_primitive: specification

		Author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _father_primitive_
#define _father_primitive_

#include <iostream>
#include <list>
#include "geometrie.h"
//#include <windows.h>

//! Class father_primitive
/*!
MORE COMMENT ABOUT THE CLASS
*/

template<class T>
class father_primitive
{
private:

	/////////////////////////////////
	// atributs of the class:

	//! list of primitive which are not born
	std::list<T*> not_born_primitive;
	
	//! list of primitive which are not born
	std::list<T*> alive_primitive;
	
	//! list of primitive which are not born
	std::list<T*> dead_primitive;

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class


	//! add a primitive in the not_born_primitive list
	void add_not_born_primitive(T* p);
	
	//! add a primitive in the alive_primitive list
	void add_alive_primitive(T* p);
	
	//! add a primitive in the dead_primitive list
	void add_dead_primitive(T* p);
	

public:

	//! update primitive
	void ogl_draw()
	{
	typename std::list<T*>::iterator it=alive_primitive.begin();
	typename std::list<T*>::iterator end=alive_primitive.end();	
		while (it!=end)
		{
			(*it)->ogl_draw();
			it++;
		}
	}
	
	//! clean
	void clean_all();
	
	//! update primitive
	void clean_dead_primitive();
	
	//! update primitive
	void add_primitive(T* p);
	
	//! type of information emitted by T
	typedef typename T::info ty_info;

	//! return the information to the point2d
	ty_info give_info(geometrie::point2d p,ty_info res_inf=ty_info());

	//! update primitive
	void up_to_date();
	
	//! update primitive
	std::ostream& display(std::ostream&) const;
	
	//! the default constructor
	/*! 
	*/
	father_primitive();
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	father_primitive(const father_primitive& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	father_primitive& operator=(const father_primitive& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	~father_primitive();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const father_primitive& obj)
		{ return obj.display(os); }

	// end of methods of the class
	/////////////////////////////////
};

#include "father_primitive.inl"

#endif /* _father_primitive_ */
