/* 
		figure2d: specification

		Author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _figure2d_
#define _figure2d_

#include <iostream>
#include "geometrie.h"
#include <assert.h>
#include "bounding_box2d.h"

//! Class figure2d
/*!
MORE COMMENT ABOUT THE CLASS
*/

class figure2d
{
public:

	/////////////////////////////////
	// atributs of the class:

	//! repere of the figure
	geometrie::repere2d r;

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	//! give the bounding box of the circle
	virtual bounding_box2d give_bounding_box() const = 0;

	//! test if p is inside the figure
	virtual float is_point2d_inside(const geometrie::point2d &p) const = 0;
	
	//! test if the figure intersect the rectangle r
	virtual bool intersection_with_bounding_box(const bounding_box2d b) const = 0;

	//! test if the figure intersect the rectangle r
	virtual void ogl_draw() const =0;

	//! the default constructor
	/*! 
	*/
	figure2d(geometrie::repere2d rr);
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	figure2d(const figure2d& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	figure2d& operator=(const figure2d& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~figure2d();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const figure2d& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _figure2d_ */
