/* 
		follow_the_path: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _follow_the_path_
#define _follow_the_path_

#include <iostream>
#include "slice_of_life.h"
#include "path.h"

//! Class follow_the_path
/*!
MORE COMMENT ABOUT THE CLASS
*/

template<class T>
class follow_the_path: public slice_of_life<T>
{
public:

	/////////////////////////////////
	// atributs of the class:

	//! pointer to the path
	path* my_way;

	//! speed
	float speed;

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	//! make the primitive follow the path
	virtual void action();

	//! make the slice of life active
	virtual void activate();
	
	//! make the slice of life dead
	virtual void deactivate();

	//! print the object
	virtual void print(std::ostream& os) const { os<<*this; }	
	
	//! the default constructor
	/*! 
	*/
	follow_the_path(path*,T*,date s,date e,float sspeed);
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	follow_the_path(const follow_the_path& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	follow_the_path& operator=(const follow_the_path& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~follow_the_path();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	inline friend std::ostream& operator<<(std::ostream& os, const follow_the_path<T>& obj)
	{
		debug_frank::process_tab();
		os<<debug_frank::tab<<typeid(obj).name()<<" from "<<obj.start<<" to "<<obj.end<<std::endl;
		os<<*obj.my_way;
		debug_frank::unprocess_tab();
		return os;
	};


	// end of methods of the class
	/////////////////////////////////
};

#include "follow_the_path.inl"

#endif /* _follow_the_path_ */
