/* 
		follow_the_path: corps de la classe

		Author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "debug.h"

//! make the primitive follow the path
template<class T> void follow_the_path<T>::action()
{
	double s=(date::horloge-(this->start)).get_date()*speed;
	this->pt_prim->pt_fig->r=geometrie::repere2d(my_way->give_position(s),my_way->give_tangent_vector_angle(s));
//	std::cerr<<"follow: "<<date::horloge<<" - "<<start<<"="<<s<<"\n";
}

//! make the slice of life active
template<class T> void follow_the_path<T>::activate()
{
}

//! make the slice of life dead
template<class T> void follow_the_path<T>::deactivate()
{
}

// the default constructor
template<class T> follow_the_path<T>::follow_the_path(path* p,T* pt,date s,date e,float sspeed)
:slice_of_life<T>(pt,s,e), my_way(p), speed(sspeed)
{
	assert(speed>0);
}

// the copy constructor
template<class T> follow_the_path<T>::follow_the_path(const follow_the_path<T>& obj)
:slice_of_life<T>(obj.pt_prim,obj.start,obj.end)
{
	debug_frank::error("No copy constructor implemented in the class follow_the_path.\n",1);
}

// the assignement constructor:
template<class T> follow_the_path<T>& follow_the_path<T>::operator=(const follow_the_path<T>& obj)
{
	if (this != &obj)
	{
		debug_frank::error("No assignement implemented in the class follow_the_path.\n",1);
	}
	return *this;
}

// the destructor: 
template<class T> follow_the_path<T>::~follow_the_path()
{
	delete my_way;
}
