/* 
		geometrie:: corps de la classe

		Auteur: Frank Perbet

		Version:
 			- 29/03/2000 (version initiale) 
*/

/*************************************************************************/
#include "geometrie.h"

using namespace geometrie;

// class point2d:

// constructeur par rotation:
point2d::point2d(const point2d& obj,float teta)
{
	float x_aux=obj.x;
	this->x=math_perso::cos(teta)*obj.x+math_perso::sin(teta)*obj.y;
	this->y=math_perso::cos(teta)*obj.y-math_perso::sin(teta)*x_aux; 
}

point2d& point2d::rotation(float teta)
{
	float x_aux=x;
	x=math_perso::cos(teta)*x+math_perso::sin(teta)*y;
	y=math_perso::cos(teta)*y-math_perso::sin(teta)*x_aux;
	return *this;
}


// class point3d:

// norme:
float point3d::norme()
{
	return math_perso::sqrt(x*x+y*y+z*z);
}

// norme_carre:
float point3d::norme_carre()
{
	return x*x+y*y+z*z;
}

// constructeur par copie:
point3d::point3d(const point3d& obj)
{
	this->x=obj.x;
	this->y=obj.y;
	this->z=obj.z;
}
	
// operateur de copie:
point3d& point3d::operator=(const point3d& obj)
{
	if (this != &obj)
	{
		this->x=obj.x;
		this->y=obj.y;
		this->z=obj.z;
	}
	return *this;
}

// class point4d

// constructeur par copie:
point4d::point4d(const point4d& obj)
{
	this->a=obj.a;
	this->b=obj.b;
	this->c=obj.c;
	this->d=obj.d;
}
	
// operateur de copie:
point4d& point4d::operator=(const point4d& obj)
{
	if (this != &obj)
	{
		this->a=obj.a;
		this->b=obj.b;
		this->c=obj.c;
		this->d=obj.d;
	}
	return *this;
}

// test l'appartenance d'un point a un demi-plan:
bool geometrie::appartient(point2d a,point2d b,point2d c)
{
	return ( b.x*(c.x-a.x) + b.y*(c.y-a.y) )>0;
}

bool geometrie::appartient(point3d a,point2d b,point3d c)
{
	return ( b.x*(c.x-a.x) + b.y*(c.y-a.y) )>0;
}

