/* 
		god_of_primitives: corps de la classe

		author: Frank Perbet

		Versions:
 			- 2001/05/30
: (initial version) 
*/

/*************************************************************************/
#include "god_of_gusts.h"

#include "debug.h"
#include "rectangle.h"
#include "circle.h"
#include "straight_path.h"

#include "birth.h"
#include "death.h"
#include "follow_the_path.h"
#include "nothing.h"

#include "gust_of_wind.h"
#include "breeze.h"
#include "blast_of_air.h"

#include "geometrie.h"
#include "trace.h"

extern float g_heightForDrawingWind;

//! update primitive
void god_of_gusts::up_to_date()
{
	wind_father.up_to_date();
}

//! update primitive
void god_of_gusts::add_gust_of_wind(float from,bounding_box2d b2d,
					 float speed, float length, float width)
{
	assert(from>0);
	
//	std::cerr<<"a\n";
	
	static float length_of_birth=1.5;
	static float length_of_death=1.5;
srand(static_cast<long>(date::horloge.get_date()));//pour initialiser sur n importe quel rand le mathperso random
	int i1=static_cast<int>(4.0*math_perso::random());
	int i2=static_cast<int>(3.0*math_perso::random()+i1);
	i2=i2<4?i2:i2-4;
	
	geometrie::point2d dep=b2d.alea(i1);
	geometrie::point2d ari=b2d.alea(i2);
	geometrie::point2d dir=(ari-dep).normalize();
	float angle=dir.give_angle();
	dep=dep-2*length*dir;
	ari=ari+2*length*dir;
	
	float distance_parcours=(ari-dep).norme();
	float life_time=distance_parcours/speed;
//	std::cerr<<"life_time: "<<life_time<<"\n";
	life_time = (life_time>(length_of_birth+length_of_death)) ? (life_time):(length_of_birth+length_of_death+1.0);
//	std::cerr<<"life_time: "<<life_time<<"\n";
	
	rectangle* r=
		new rectangle(length,width);
		
	birth<gust_of_wind>* b=
		new birth<gust_of_wind>(
			static_cast<gust_of_wind*>(0),
			date(date::horloge,from),
			date(date::horloge,from+length_of_birth));
	
	death<gust_of_wind>* d=
		new death<gust_of_wind>(
			static_cast<gust_of_wind*>(0),
			date(date::horloge,from+life_time-length_of_death),
			date(date::horloge,from+life_time));
	
	gust_of_wind* g=
		new gust_of_wind(r,b,d);
		
	path* p=
		new straight_path(dep,angle);

	follow_the_path<gust_of_wind>* f=
		new follow_the_path<gust_of_wind>(
			p,g,
			date(date::horloge,from),
			date(date::horloge,from+life_time),speed);
//	life<gust_of_wind>* l=
//		new life<gust_of_wind>(b,d);

	g->add_slice_of_life(f);
	wind_father.add_primitive(g);

}

void god_of_gusts::add_blast_of_air(float from,bounding_box2d b2d,
					 float speed, float rayon)
{
	assert(from>0);
	
//	std::cerr<<"a\n";
	
	static float length_of_birth=1.5;
	static float length_of_death=1.5;
srand(static_cast<long>(2.0*date::horloge.get_date()));//pour initialiser sur n importe quel rand le mathperso random
	int i1=static_cast<int>(4.0*math_perso::random());
	int i2=static_cast<int>(3.0*math_perso::random()+i1);
	i2=i2<4?i2:i2-4;
	
	geometrie::point2d dep=b2d.alea(i1);
	geometrie::point2d ari=b2d.alea(i2);
	geometrie::point2d dir=(ari-dep).normalize();
	float angle=dir.give_angle();
	dep=dep-2*rayon*dir;
	ari=ari+2*rayon*dir;
	float distance_parcours=(ari-dep).norme();
	float life_time=distance_parcours/speed;
//	std::cerr<<"life_time: "<<life_time<<"\n";
	life_time = (life_time>(length_of_birth+length_of_death)) ? (life_time):(length_of_birth+length_of_death+1.0);
//	std::cerr<<"life_time: "<<life_time<<"\n";
	
	circle* r=
		new circle(dep,rayon);
		
	birth<blast_of_air>* b=
		new birth<blast_of_air>(
			static_cast<blast_of_air*>(0),
			date(date::horloge,from),
			date(date::horloge,from+length_of_birth));
	
	death<blast_of_air>* d=
		new death<blast_of_air>(
			static_cast<blast_of_air*>(0),
			date(date::horloge,from+life_time-length_of_death),
			date(date::horloge,from+life_time));
	
	blast_of_air* g=
		new blast_of_air(r,b,d);
		
	path* p=
		new straight_path(dep,angle);

	follow_the_path<blast_of_air>* f=
		new follow_the_path<blast_of_air>(
			p,g,
			date(date::horloge,from),
			date(date::horloge,from+life_time),speed);
//	life<gust_of_wind>* l=
//		new life<gust_of_wind>(b,d);

	g->add_slice_of_life(f);
	wind_father.add_primitive(g);

}

// the default constructor
god_of_gusts::god_of_gusts()
:wind_father()
{
}

// the copy constructor
god_of_gusts::god_of_gusts(const god_of_gusts& obj)
{
	debug_frank::error("No copy constructor implemented in the class god_of_gusts.\n",1);
}

// the assignement constructor:
god_of_gusts& god_of_gusts::operator=(const god_of_gusts& obj)
{
	if (this != &obj)
	{
		debug_frank::error("No assignement implemented in the class god_of_gusts.\n",1);
	}
	return *this;
}

// the destructor: 
god_of_gusts::~god_of_gusts()
{
}

// display
std::ostream& operator<<(std::ostream& os, const god_of_gusts& obj)
{
	debug_frank::process_tab();
	os<<debug_frank::tab<<"Overbooker god of primitive:\n";
	os<<obj.wind_father;
	debug_frank::unprocess_tab();
	return os;
}
