/* 
		god_of_primitives: specification

		author: Frank Perbet

		Versions:
 			- 2001/05/30

*/


/* 
	Comments: modif Sylvain Guerraz 06/06/2002

*/

/*************************************************************************/

#ifndef _god_of_gusts_
#define _god_of_gusts_

#include <iostream>
#include "father_primitive.h"
#include "wind_primitive.h"
#include "light_primitive.h"
#include "bounding_box2d.h"

//! Class god_of_gusts
/*!
MORE COMMENT ABOUT THE CLASS
*/

class god_of_gusts
{
public:

	/////////////////////////////////
	// atributs of the class:

	father_primitive<wind_primitive> wind_father;

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class
	
	//! update primitive
	void add_gust_of_wind(float from, bounding_box2d b2d,
			      float speed,float length, float width);
	void add_blast_of_air(float from,bounding_box2d b2d,
					 float speed, float rayon);

	//! update primitive
	void up_to_date();
	
	//! the default constructor
	/*! 
	*/
	god_of_gusts();
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	god_of_gusts(const god_of_gusts& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	god_of_gusts& operator=(const god_of_gusts& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	~god_of_gusts();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const god_of_gusts& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _god_of_gusts_ */
