/* 
		gust_field: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _gust_field_
#define _gust_field_

#include <iostream>
#include <vector>
#include <stdexcept>
#include "float_field.h"

//! Class gust_field
/*!
MORE COMMENT ABOUT THE CLASS
*/

class gust_field: public float_field
{
private:

	/////////////////////////////////
	// atributs of the class:

	std::vector<float> vector_of_values;

	// end of atributs of the class.
	/////////////////////////////////
	
public:

	/////////////////////////////////
	// methods of the class

	//! retun the value of the function (f between 0 and 1)
	float operator[](float f) const;
	
	//! constructor
	/*! 
	*/
	gust_field(float nb_oscillation=3,float attenuation=10,int nb_discretiation=1000)
	throw(std::invalid_argument);
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	gust_field(const gust_field& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	gust_field& operator=(const gust_field& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	~gust_field();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const gust_field& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _gust_field_ */
