/* 
		gust_of_wind: corps de la classe

		author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "gust_of_wind.h"

#include "debug.h"
#include "gust_field.h"

extern float g_gustPower;

//! add a slice of life
void gust_of_wind::add_slice_of_life(slice_of_life<gust_of_wind>* s)
{
	this->my_life->add_slice_of_life(s);
}

//! make the primitive live
bool gust_of_wind::up_to_date()
{
	my_life->up_to_date();
	my_life->action();
	return !am_i_dead;
}

//! retun the information emitted to the point p
wind_primitive::info gust_of_wind::give_info(geometrie::point2d p)
{
	rectangle& r = static_cast<rectangle&>(*pt_fig);
	geometrie::point2d pp= p-r.r.origin;
	double angle_rectangle =r.r.angle;
	double cos_angle_rectangle = cos(angle_rectangle);
	double sin_angle_rectangle = sin(angle_rectangle);
	double d1 = pp.x*cos_angle_rectangle+pp.y*sin_angle_rectangle;
	double d2 = -pp.x*sin_angle_rectangle+pp.y*cos_angle_rectangle;
	
	if( (fabs(d1)>r.size_x) || (fabs(d2)>r.size_y))
		return info();
		
//	srand(static_cast<long>(p.y*3476+p.x));
	double t = date::horloge.get_date();
	double dec_angle=0.4*(2.0*(double(rand()) / RAND_MAX)-1.0);
	
	/*double oscillation,oscillation2;
	if (fabs(cos_angle_rectangle)>fabs(sin_angle_rectangle))
		{
		oscillation=-0.8*fabs(cos(t*(0.2*drand48()+0.2)))*cos_angle_rectangle;
		oscillation2=0.0;
		}
	else
		{
		oscillation=0.0;
		oscillation2=-0.8*fabs(cos(t*(0.2*drand48()+0.2)))*sin_angle_rectangle;
		}*/
	
	double marge = r.size_x/3.0;
	double amplitude;
	if(d1>(r.size_x-marge))
	{
		double coef = (d1-(r.size_x-marge))/marge;
//			std::cerr<<"marge:"<<d1<<" "<<r.size_x<<" "<<coef<<std::endl;
		amplitude=1.0-coef*coef*coef;
	}
	else
	{
		double coef = (r.size_x+d1)/(2*r.size_x-marge);
//			std::cerr<<"nomarge:"<<d1<<" "<<r.size_x<<" "<<coef<<std::endl;
//			amplitude=cos( coef/r.size_x*6.28*nb_oscillation)*coef*coef;
		amplitude=coef*coef;
	}

	double marge2 = r.size_y/3.0;
	if( d2 < (-r.size_y+marge2) ) amplitude=amplitude*(d2+r.size_y)/marge2;
	if( d2 > (+r.size_y-marge2) ) amplitude=amplitude*(r.size_y-d2)/marge2;

	//modif sly-> commentaire
	//amplitude*=dec_amplitude;
	//fin modif
	amplitude=(amplitude>1.0)?1.0:amplitude;
	amplitude=(amplitude<0.0)?0.0:amplitude;
	amplitude*=amplitude;    
//	g_gustPower=float(date::horloge_gustpower.get_date());
	return wind_primitive::info(
		g_gustPower*power_coef*amplitude,
		cos(angle_rectangle+dec_angle)/*+oscillation*amplitude*/,
		sin(angle_rectangle+dec_angle)/*+oscillation2*amplitude*/);
	
}

// the default constructor
gust_of_wind::gust_of_wind(rectangle* r,birth<gust_of_wind>* b,death<gust_of_wind>* d)
:wind_primitive(r,b->start,d->end,100.0),my_life(new life<gust_of_wind>(b,d))
{
	b->pt_prim=this;
	d->pt_prim=this;
}

// the copy constructor
gust_of_wind::gust_of_wind(const gust_of_wind& obj)
:wind_primitive(obj)
{
	debug_frank::error("No copy constructor implemented in the class gust_of_wind.\n",1);
}

// the assignement constructor:
gust_of_wind& gust_of_wind::operator=(const gust_of_wind& obj)
{
	if (this != &obj)
	{
		debug_frank::error("No assignement implemented in the class gust_of_wind.\n",1);
	}
	return *this;
}

// the destructor: 
gust_of_wind::~gust_of_wind()
{
	delete my_life;
}
