/* 
		gust_of_wind: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _gust_of_wind_
#define _gust_of_wind_

#include <iostream>
#include "debug.h"
#include "wind_primitive.h"
#include "rectangle.h"
#include "geometrie.h"
#include "life.h"
#include "GL/glut.h"

//! Class gust_of_wind
/*!
MORE COMMENT ABOUT THE CLASS
*/

class gust_of_wind : public wind_primitive
{
private:

	/////////////////////////////////
	// atributs of the class:

	//! life of the gust of wind prim
	life<gust_of_wind>* my_life;

	// end of atributs of the class.
	/////////////////////////////////
	
public:

	/////////////////////////////////
	// methods of the class
	
	virtual void ogl_draw() const
	{
		glPushAttrib(GL_LIGHTING_BIT);
		glPushAttrib(GL_TEXTURE_BIT);
		
		glDisable(GL_LIGHTING);
		glDisable(GL_TEXTURE_2D);
		
		glColor3f(0.3*power_coef,0.3*power_coef,0.8*power_coef);
		pt_fig->ogl_draw();
		
		glPopAttrib();
		glPopAttrib();
	}
	
	//! add a slice of life
	void add_slice_of_life(slice_of_life<gust_of_wind>* s);

	//! make the primitive live
	virtual bool up_to_date();

	//! retun the information emitted to the point p
	virtual info give_info(geometrie::point2d p);

	//! the constructor
	/*! 
	*/
	gust_of_wind(rectangle* r,birth<gust_of_wind>* b,death<gust_of_wind>* d);
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	gust_of_wind(const gust_of_wind& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	gust_of_wind& operator=(const gust_of_wind& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	~gust_of_wind();

	std::ostream& write(std::ostream& os) const
	{
		os<<debug_frank::tab<<"gust_of_wind:\n";
		my_life->print(os);
		os<<std::endl;
		return os;
	}	

	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const gust_of_wind& obj)
	{
		debug_frank::process_tab();
		obj.primitive::write(os);
		obj.wind_primitive::write(os);
		obj.gust_of_wind::write(os);
		debug_frank::unprocess_tab();
		return os;
	}

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _gust_of_wind_ */
