/* 
		life: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _life_
#define _life_

#include <iostream>
#include <list>
#include <stdexcept>
#include "date.h"
#include "birth.h"
#include "death.h"
#include "slice_of_life.h"

//! Class life
/*!
MORE COMMENT ABOUT THE CLASS
*/

template<class T>
class life
{
private:
	/////////////////////////////////
	// atributs of the class:

	//! list of slice_of_life sorted by start date
	std::list< slice_of_life<T> * > list_of_events;
	
	//! Fucking Compiler bug
	typedef slice_of_life<T> sol;
	typedef std::list< slice_of_life<T> *> ty_list_sol;
	typedef typename ty_list_sol::iterator ty_list_iterator;
	typedef typename ty_list_sol::const_iterator ty_list_const_iterator;
	
	//! iterator on the next events to happen;
	ty_list_iterator next_event;
	
	//! list of c sorted by end date (inverse order)
	std::list< slice_of_life<T> * > list_of_active_events;

	// end of atributs of the class.
	/////////////////////////////////

	//! add a slice of life to life
	void add_active_event(slice_of_life<T>* sol) throw(std::invalid_argument);

public:

	/////////////////////////////////
	// methods of the class
	
	//! add a slice of life to life
	void add_slice_of_life(slice_of_life<T>* sol) throw(std::invalid_argument);
	
	//! add a slice of life to life
	void up_to_date() throw(std::runtime_error);
	
	//! action on
	void action();	
	
	//! print the object
	void print(std::ostream& os) const
	{
		debug_frank::process_tab();
		os<<debug_frank::tab<<"Life of a "<<typeid(T).name()<<":\n";
		os<<debug_frank::tab<<"Chronologie:\n";

		ty_list_const_iterator it=list_of_events.begin();
		ty_list_const_iterator en=list_of_events.end();
		while(it!=en)
		{
			(*it)->print(os); it++;
		}

		os<<debug_frank::tab<<"active life:\n";
		it=list_of_active_events.begin();
		en=list_of_active_events.end();
		while(it!=en)
		{
			os<<(*(*it)); it++;
		}
		debug_frank::unprocess_tab();
	}
	
	//! the default constructor
	/*! 
	*/
	life(birth<T>* b,death<T>* d);
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	life(const life& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	life& operator=(const life& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	~life();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	inline friend std::ostream& operator<<(std::ostream& os, const life<T>& obj)
	{
		obj.print(os);
		return os;
	};
	
	// end of methods of the class
	/////////////////////////////////
};

#include "life.inl"

#endif /* _life_ */
