/* 
		light_primitive: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _light_primitive_
#define _light_primitive_

#include <iostream>
#include "primitive.h"
#include "geometrie.h"
#include "figure2d.h"

//! Class light_primitive
/*!
MORE COMMENT ABOUT THE CLASS
*/

class light_primitive: public primitive
{
public:

	/////////////////////////////////
	// atributs of the class:

	//! info type
	class info
	{
		float r;
		float g;
		float b;
	};
	
	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	//! retun the information emitted to the point p
	virtual info give_info(geometrie::point2d p)=0;
	
	//! the default constructor
	/*! 
	*/
	light_primitive(figure2d* f,date dob,date dod);
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	light_primitive(const light_primitive& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	light_primitive& operator=(const light_primitive& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~light_primitive();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const light_primitive& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _light_primitive_ */
