/* 
		math_perso: specification

		author: Frank Perbet

		Versions:
 			- 2001/05/09
*/


/* 
	Comments: inline namespace of mathematical function

*/

/*************************************************************************/

#ifndef _math_perso_
#define _math_perso_

#include <iostream>
#include <math.h>

//! Class math_perso
/*!
MORE COMMENT ABOUT THE CLASS
*/

namespace math_perso
{
	const double PI=3.14159265358979323846;
	const double CONV_rad_to_degree=1.0/2.0/PI*360.0;
	const double CONV_degree_to_rad=2.0*PI/360.0;

	template<class T>
	inline T min(T a,T b) {return a<b?a:b;};
	
	template<class T>
	inline T max(T a,T b) {return a>b?a:b;};
	
	//! return a uniform random double in [0,1]
	inline double random()
	{
	//	static int sead_for_rand=1;
//		sead_for_rand++;
//		::srand(sead_for_rand);		//::srand48(sead_for_rand);
//		std::cerr<<sead_for_rand<<"\n";
		float tmp=(double(::rand()) / RAND_MAX);		//float tmp=::drand48();
//		sead_for_rand=((int) (tmp*1000.0));
		return tmp;
	};	

	//! return the int lower to a
	inline int floor(float a)
	{
		return (int) ::floor(a);
	};
	
	//! return the absolute value of a
	inline float fabs(float a)
	{
		return ::fabs(a);
	};
	
	//! return sqrt(a)
	inline float sqrt(float a)
	{
		return ::sqrtf(a);
	};
	
	//! return acos(a)
	inline float acos(float a)
	{
		return ::acos(a);
	};
	
	//! return asin(a)
	inline float asin(float a)
	{
		return ::asin(a);
	};
	
	//! return cos(a)
	inline float cos(float a)
	{
		return ::cos(a);
	};
	
	//! return sin(a)
	inline float sin(float a)
	{
		return ::sin(a);
	};
	
	//! return modulo(a,b)>0
	inline float modulo(float a,float b)
	{
		float tmp=::fmodf(a,b);
		return tmp>0?tmp:tmp+b;
	};
	
	//! linear interpolation
	inline float linear_interpolation8(float a,float b,float c,float d,float e,float f,float g,float h,
	float cx,float cy,float cz)
	{
		float A=a*cx+e*(1-cx);
		float B=b*cx+f*(1-cx);
		float C=c*cx+g*(1-cx);
		float D=d*cx+h*(1-cx);
		
		float Y1=C*cy+A*(1-cy);
		float Y2=D*cy+B*(1-cy);
		
		return Y2*cz+Y1*(1-cz);
	};
};

#endif /* _math_perso_ */
