/* 
		nothing: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _nothing_
#define _nothing_

#include <iostream>
#include "slice_of_life.h"
#include <typeinfo>

//! Class nothing
/*!
MORE COMMENT ABOUT THE CLASS
*/

template<class T>
class nothing: public slice_of_life<T>
{
public:

	/////////////////////////////////
	// atributs of the class:


	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	//! make the primitive born
	virtual void action() {};

	//! make the slice of life active
	virtual void activate() {};
	
	//! make the slice of life dead
	virtual void deactivate() {};
	
	//! print the object
	virtual void print(std::ostream& os) const { os<<*this;};		

	//! the default constructor
	/*! 
	*/
	nothing(T* pt,date s,date e):slice_of_life<T>(pt,s,e) {};
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	nothing(const nothing& obj) {assert(false); };
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	nothing& operator=(const nothing& obj) {assert(false); };
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~nothing() {};
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	inline friend std::ostream& operator<<(std::ostream& os, const nothing<T>& obj)
	{
		debug_frank::process_tab();
		os<<debug_frank::tab<<typeid(obj).name()<<" from "<<obj.start<<" to "<<obj.end<<std::endl;
		debug_frank::unprocess_tab();
		return os;
	};


	// end of methods of the class
	/////////////////////////////////
};

#endif /* _nothing_ */
