/* 
		ogl_primitive: specification

		author: Frank Perbet

		Versions:
 			- 2001/07/26

*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _ogl_primitive_
#define _ogl_primitive_

#include <iostream>
#include <GL/glut.h>

//! Class ogl_primitive
/*!
MORE COMMENT ABOUT THE CLASS
*/

namespace ogl
{
	inline void draw_disc()
	{
		static bool disc_list_ok=false;
		static GLuint disc_list;
		static const int nb_faces=20;
		
		if (!disc_list_ok)
		{
			disc_list = glGenLists(1);
			glNewList(disc_list, GL_COMPILE);
			
			for (float i=0.0;i<nb_faces;i=i+1)
			{
				glBegin(GL_TRIANGLES);
					glVertex3f(0.0,0.0,0.0);
					glVertex3f(
						math_perso::cos(2.0*math_perso::PI*i/nb_faces),
						math_perso::sin(2.0*math_perso::PI*i/nb_faces),
						0.0);
					glVertex3f(
						math_perso::cos(2.0*math_perso::PI*(i+1)/nb_faces),
						math_perso::sin(2.0*math_perso::PI*(i+1)/nb_faces),
						0.0);
				glEnd();
			}
			
			glEndList();
			
			disc_list_ok=true;
		}

		glCallList(disc_list);
	
	}
	
	inline void draw_axes()
	{
		static bool axes_list_ok=false;
		static GLuint axes_list;
		
		if (!axes_list_ok)
		{
			axes_list = glGenLists(1);
			glNewList(axes_list, GL_COMPILE);
			glPushAttrib(GL_POLYGON_BIT);
			glPushAttrib(GL_LINE_BIT);

			glPolygonMode(GL_FRONT, GL_FILL);
			glLineWidth(3.0);

			glColor3f(0.0, 1.0, 1.0);
			glBegin(GL_LINES);
			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(1.0, 0.0, 0.0);

			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(0.0, 1.0, 0.0);

			glVertex3f(0.0, 0.0, 0.0);
			glVertex3f(0.0, 0.0, 1.0);
			glEnd();

			glColor3f(1.0, 1.0, 0.0);
			glutSolidCube(0.075);

			glPushMatrix();
				glTranslatef(1.0, 0.0, 0.0);
				glColor3f(1.0, 0.0, 0.0);
				glutSolidCube(0.075);
			glPopMatrix();

			glPushMatrix();
				glTranslatef(0.0, 1.0, 0.0);
				glColor3f(0.0, 1.0, 0.0);
				glutSolidCube(0.075);
			glPopMatrix();

			glPushMatrix();
				glTranslatef(0.0, 0.0, 1.0);
				glColor3f(0.0, 0.0, 1.0);
				glutSolidCube(0.075);
			glPopMatrix();

			glPopAttrib();
			glPopAttrib();
			glEndList();
			
			axes_list_ok=true;
		}

		glCallList(axes_list);
	
	}
}

#endif /* _ogl_primitive_ */
