/* 
		path: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _path_
#define _path_

#include <iostream>
#include "geometrie.h"

//! Class path
/*!
2d curve parametered by a float (arc length).
*/

class path
{
public:

	/////////////////////////////////
	// atributs of the class:

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	//! give the tangent vector of the path at the f parameter.
	virtual geometrie::point2d give_tangent_vector(float f) const=0;

	//! give the tangent vector of the path at the f parameter.
	virtual float give_tangent_vector_angle(float f) const=0;
	
	//! give the normal vector of the path at the f parameter.
	virtual geometrie::point2d give_normal_vector(float f) const=0;
	
	//! give the tangent vector of the path at the f parameter.
	virtual geometrie::point2d give_position(float f) const=0;
	
	//! the default constructor
	/*! 
	*/
	path();
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	path(const path& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	path& operator=(const path& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~path();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const path& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _path_ */
