/* 
		primitive: corps de la classe

		author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "primitive.h"
#include "debug.h"
#include "wind_primitive.h"
#include "light_primitive.h"
#include <stdexcept>

	
// the default constructor
primitive::primitive(figure2d* f,date dob,date dod)
:pt_fig(f),am_i_dead(false),have_i_born(false)
,date_of_birth(dob),date_of_death(dod)
{
}

// the copy constructor
primitive::primitive(const primitive& obj)
{
	debug_frank::error("No copy constructor implemented in the class primitive.\n",1);
}

// the assignement constructor:
primitive& primitive::operator=(const primitive& obj)
{
	if (this != &obj)
	{
		debug_frank::error("No assignement implemented in the class primitive.\n",1);
	}
	return *this;
}

// the destructor: 
primitive::~primitive()
{
	delete pt_fig;
}

// display
std::ostream& operator<<(std::ostream& os, const primitive& obj)
{
	try
	{
		const wind_primitive& ref_wind=dynamic_cast<const wind_primitive&>(obj);
		os<<ref_wind;
		return os;
	}
	catch(...){}
	
	try
	{
		const light_primitive& ref_light=dynamic_cast<const light_primitive&>(obj);
		os<<ref_light;
		return os;
	}
	catch(...) {}
	
	assert(false);
	return os;
}
