/* 
		primitive: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _primitive_
#define _primitive_

#include <iostream>
#include "debug.h"
#include "date.h"
#include "geometrie.h"
#include "figure2d.h"

//! Class primitive
/*!
MORE COMMENT ABOUT THE CLASS
*/

class primitive
{
public:

	/////////////////////////////////
	// atributs of the class:

	//! mask of the primitive
	figure2d* pt_fig;

	//! true if the primitive is dead
	bool am_i_dead;
	
	//! true if the primitive is born
	bool have_i_born;
	
	//! date of birth
	date date_of_birth;
	
	//! date of death
	date date_of_death;
	
	//! power coefficient (between 0 and 1)
	float power_coef;
	
	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	virtual void ogl_draw() const=0;

	//! make the primitive live
	virtual bool up_to_date()=0;
	
	//! test wether the primitive influence the point or not
	//! 0-> no influence 1-> maximum influence
	virtual float influence(geometrie::point2d p)
	{
		return pt_fig->is_point2d_inside(p);
	}
	
	//! the default constructor
	/*! 
	*/
	primitive(figure2d* f,date dob,date dod);
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	primitive(const primitive& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	primitive& operator=(const primitive& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~primitive();


	std::ostream& write(std::ostream& os) const
	{
		os<<debug_frank::tab<<"primitive:\n";
		os<<debug_frank::tab<<*pt_fig;
		os<<debug_frank::tab<<( am_i_dead ? "I'm dead" : "I'm not dead" )<<"\n";
		os<<debug_frank::tab<<( have_i_born ? "I'm born" : "I'm not born" )<<"\n";
		return os;
	}

	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const primitive& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _primitive_ */
