/* 
		rectangle: corps de la classe

		author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "rectangle.h"

#include "debug.h"
#include "math_perso.h"
#include <GL/glut.h>
#include "date.h"
extern float g_heightForDrawingWind;

//! give the bounding box of the circle
bounding_box2d rectangle::give_bounding_box() const
{
	assert(false);
	return bounding_box2d(0,0,0,0);
}

//! test if p is inside the figure
float rectangle::is_point2d_inside(const geometrie::point2d &p) const
{
	geometrie::point2d tmp=r.to_this_repere(p);
	float x=size_x-math_perso::fabs(tmp.x);
	x=x>0?x/size_x:0.0;
	float y=size_y-math_perso::fabs(tmp.y);
	y=y>0?y/size_y:0.0;
	return x*y;
}

//! test if the figure intersect the rectangle r
bool rectangle::intersection_with_bounding_box(const bounding_box2d b) const
{
	debug_frank::error("intersection_with_rectangle not implemented");
	return false;
}

void rectangle::ogl_draw() const
{
//	g_heightForDrawingWind=float(date::horloge_height.get_date());
  glPushAttrib(GL_POLYGON_BIT);
	glPushAttrib(GL_LINE_BIT);
	
	glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
	
	glPushMatrix();
	glTranslatef(r.origin.x,r.origin.y,0.1);
	glRotatef(r.angle*math_perso::CONV_rad_to_degree,0,0,1);

	glBegin(GL_LINES);
		glVertex3f(size_x,size_y,g_heightForDrawingWind);
		glVertex3f(size_x,-size_y,g_heightForDrawingWind);
		
		glVertex3f(size_x,-size_y,g_heightForDrawingWind);
		glVertex3f(-size_x,-size_y,g_heightForDrawingWind);
		
		glVertex3f(-size_x,-size_y,g_heightForDrawingWind);
		glVertex3f(-size_x,size_y,g_heightForDrawingWind);
		
		glVertex3f(-size_x,size_y,g_heightForDrawingWind);
		glVertex3f(size_x,size_y,g_heightForDrawingWind);
	glEnd();
	
	glLineWidth(2.0);
	glBegin(GL_LINES);
		glVertex3f(size_x,0,g_heightForDrawingWind);
		glVertex3f(size_x+size_x/4,0,g_heightForDrawingWind);
	glEnd();
	
	glPopMatrix();
	
	glPopAttrib();
	glPopAttrib();
}

// the default constructor
rectangle::rectangle(geometrie::repere2d r,float sx,float sy) throw(std::invalid_argument)
:figure2d(r), size_x(sx), size_y(sy)
{
	if((size_x<0)||(size_y<0))
	{
		throw std::invalid_argument("rectangle.cpp:rectangle: min>max");
	}
}

// the copy constructor
rectangle::rectangle(const rectangle& obj)
:figure2d(obj)
{
	this->size_x=obj.size_x;
	this->size_y=obj.size_y;
}

// the assignement constructor:
rectangle& rectangle::operator=(const rectangle& obj)
{
	if (this != &obj)
	{
		this->figure2d::operator=(obj);
		this->size_x=obj.size_x;
		this->size_y=obj.size_y;
	}
	return *this;
}

// the destructor: 
rectangle::~rectangle()
{
}

// display
std::ostream& operator<<(std::ostream& os, const rectangle& obj)
{
	os<<"No display implemented in the class rectangle.\n";
	return os;
}
