/* 
		rectangle: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments: rectangle

*/

/*************************************************************************/

#ifndef _rectangle_
#define _rectangle_

#include <iostream>
#include <stdexcept>
#include "figure2d.h"
#include "geometrie.h"

//! Class rectangle
/*!
MORE COMMENT ABOUT THE CLASS
*/

class rectangle: public figure2d
{
public:

	/////////////////////////////////
	// atributs of the class:

	//! x abssis of the left edge
	float size_x;
	
	//! y abssis of the right edge
	float size_y;

	//! repere du rectangle

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	//! give the bounding box of the circle
	virtual bounding_box2d give_bounding_box() const;

	//! test if p is inside the figure
	virtual float is_point2d_inside(const geometrie::point2d &p) const;
	
	//! test if the figure intersect the rectangle r
	virtual bool intersection_with_bounding_box(const bounding_box2d b) const;

	//! opengl command
	virtual void ogl_draw() const;
	
	//! the default constructor
	/*! 
	*/
	rectangle(geometrie::repere2d r,float sx,float sy)
	throw(std::invalid_argument);
	
	//! the default constructor
	/*! 
	*/
	rectangle(float sx,float sy)
	throw(std::invalid_argument)
	:figure2d(geometrie::repere2d()), size_x(sx), size_y(sy)
	{
		if((size_x<0)||(size_y<0))
		{
			throw std::invalid_argument("rectangle.cpp:rectangle: min>max");
		}
	}
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	rectangle(const rectangle& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	rectangle& operator=(const rectangle& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~rectangle();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const rectangle& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _rectangle_ */
