/* 
		ressource: corps de la classe

		author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "ressource.h"

#include "debug.h"
#include "math_perso.h"

//! built a new random vector
int ressource::add_alea_vector(int size)
{
	std::vector<float> tmp;
	tmp.reserve(size);
	int i;
	for(i=0;i<size;i++)
	{
		tmp.push_back(math_perso::random());
	}
	
	vector_of_rand_vector.push_back(tmp);
	return vector_of_rand_vector.size()-1;
}

//! built a new random vector
int ressource::add_alea_array(int size_x,int size_y)
{
	std::vector< std::vector<float> > tmp1;
	tmp1.reserve(size_x);
	int i,j;
	for(i=0;i<size_x;i++)
	{
		std::vector<float> tmp2;
		tmp2.reserve(size_y);
		for (j=0;j<size_y;j++)
		{
			tmp2.push_back(math_perso::random());
		}
		tmp1.push_back(tmp2);
	}
	
	array_of_rand_vector.push_back(tmp1);
	return array_of_rand_vector.size()-1;
}

//! built a new random vector
int ressource::add_alea_volume(int size_x,int size_y,int size_z)
{
	std::vector< std::vector< std::vector<float> > > tmp1;
	tmp1.reserve(size_x);
	int i,j,k;
	for(i=0;i<size_x;i++)
	{
		std::vector< std::vector<float> > tmp2;
		tmp2.reserve(size_y);
		for (j=0;j<size_y;j++)
		{
			std::vector<float> tmp3;
			tmp3.reserve(size_z);
			for (k=0;k<size_z;k++)
			{
				tmp3.push_back(math_perso::random());
			}
			tmp2.push_back(tmp3);
		}
		tmp1.push_back(tmp2);
	}
	
	volume_of_rand_vector.push_back(tmp1);
	return volume_of_rand_vector.size()-1;
}
	
// the default constructor
ressource::ressource()
{
	debug_frank::error("No default constructor implemented in the class ressource.\n",1);
}

// the copy constructor
ressource::ressource(const ressource& obj)
{
	debug_frank::error("No copy constructor implemented in the class ressource.\n",1);
}

// the assignement constructor:
ressource& ressource::operator=(const ressource& obj)
{
	if (this != &obj)
	{
		debug_frank::error("No assignement implemented in the class ressource.\n",1);
	}
	return *this;
}

// the destructor: 
ressource::~ressource()
{
	debug_frank::error("No destructor implemented in the class ressource.\n",1);
}

// display
std::ostream& operator<<(std::ostream& os, const ressource& obj)
{
	os<<"No display implemented in the class ressource.\n";
	return os;
}
