/* 
		ressource: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _ressource_
#define _ressource_

#include <iostream>
#include <vector>

//! Class ressource
/*!
MORE COMMENT ABOUT THE CLASS
*/

class ressource
{
public:

	/////////////////////////////////
	// atributs of the class:
	
	//! type of vector of uniform random float:
	typedef std::vector<float> ty_vector_float;
	
	//! type of array of uniform random float:
	typedef std::vector< std::vector<float> > ty_array_float;
	
	//! type of volume of uniform random float:
	typedef std::vector< std::vector< std::vector<float> > > ty_volume_float;

	//! vectors of uniform random float:
	std::vector< ty_vector_float > vector_of_rand_vector;
	
	//! arrays of uniform random float:
	std::vector< ty_array_float > array_of_rand_vector;
	
	//! volumes of uniform random float:
	std::vector< ty_volume_float > volume_of_rand_vector;

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	//! built a new random vector
	int add_alea_vector(int size=100);
	
	//! built a new random vector
	int add_alea_array(int size_x=50,int size_y=50);
	
	//! built a new random vector
	int add_alea_volume(int size_x=20,int size_y=20,int size_z=20);
	
	//! the default constructor
	/*! 
	*/
	ressource();
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	ressource(const ressource& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	ressource& operator=(const ressource& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	~ressource();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const ressource& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _ressource_ */
