/* 
		slice_of_life: specification

		Author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _slice_of_life_
#define _slice_of_life_

#include <iostream>
#include <stdexcept>
#include "date.h"

//! Class slice_of_life
/*!
MORE COMMENT ABOUT THE CLASS
*/

template<class T>
class slice_of_life
{
public:

	/////////////////////////////////
	// atributs of the class:

	//! Pointer to the primitive
	T* pt_prim;
	
	//!  start of the slice of life
	date start;
	
	//!  end of the slice of life
	date end;

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class throw(std::invalid_argument);

	//! make the slice of life act on pt_prim
	virtual void action()=0;
	
	//! make the slice of life active
	virtual void activate()=0;
	
	//! make the slice of life dead
	virtual void deactivate()=0;
	
	//! print the object
	virtual void print(std::ostream& os) const=0;
	
	//! a constructor
	/*!
	\param pt: pointer to the concerned
	\param s: begin of the slice of life
	\param d: end of the slice of life
	*/
	slice_of_life(T* pt,date s,date e) throw(std::invalid_argument);
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	slice_of_life(const slice_of_life& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	slice_of_life& operator=(const slice_of_life& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~slice_of_life();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	inline friend std::ostream& operator<<(std::ostream& os, const slice_of_life<T>& obj)
	{
		obj.print(os);
		return os;
	};
	
//	friend std::ostream& operator<<(std::ostream& os, const slice_of_life<T>& obj);
	// end of methods of the class
	/////////////////////////////////
};

#include"slice_of_life.inl"

#endif /* _slice_of_life_ */
