/* 
		slice_of_life: corps de la classe

		Author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "debug.h"
	
// the default constructor
template<class T> slice_of_life<T>::slice_of_life(T* pt,date s,date e) throw(std::invalid_argument)
:pt_prim(pt), start(s), end(e) 
{
	if(start>end)
	{
		throw std::invalid_argument("slice_of_life.cpp:slice_of_life: start>end");
	}
}

// the copy constructor
template<class T> slice_of_life<T>::slice_of_life(const slice_of_life& obj)
:pt_prim(obj.pt_prim), start(obj.start), end(obj.end) 
{
	debug_frank::error("No copy constructor implemented in the class slice_of_life.\n",1);
}

// the assignement constructor:
template<class T> slice_of_life<T>& slice_of_life<T>::operator=(const slice_of_life& obj)
{
	if (this != &obj)
	{
		this->pt_prim=obj.pt_prim;
		this->start=obj.start;
		this->end=obj.end;
	}
	return *this;
}

// the destructor: 
template<class T> slice_of_life<T>::~slice_of_life()
{
}
