/* 
		static_path: corps de la classe

		author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "static_path.h"

#include "debug.h"

//! give the tangent vector of the path at the f parameter.
float static_path::give_tangent_vector_angle(float f) const
{
	return geometrie::give_angle(tangent);
}

//! give the tangent vector of the path at the f parameter.
geometrie::point2d static_path::give_tangent_vector(float f) const
{
	return tangent;
}

//! give the tangent vector of the path at the f parameter.
geometrie::point2d static_path::give_normal_vector(float f) const
{
	return normal;
}

//! give the tangent vector of the path at the f parameter.
geometrie::point2d static_path::give_position(float f) const
{
	return position;
}

// the default constructor
static_path::static_path(
				geometrie::point2d pos,
				geometrie::point2d t,
				geometrie::point2d n)
:position(pos), tangent(t), normal(n)
{}

// the copy constructor
static_path::static_path(const static_path& obj)
{
	this->position=obj.position;
	this->tangent=obj.tangent;
	this->normal=obj.normal;
}

// the assignement constructor:
static_path& static_path::operator=(const static_path& obj)
{
	if (this != &obj)
	{
		this->position=obj.position;
		this->tangent=obj.tangent;
		this->normal=obj.normal;
	}
	return *this;
}

// the destructor: 
static_path::~static_path()
{}

// display
std::ostream& operator<<(std::ostream& os, const static_path& obj)
{
	debug_frank::process_tab();
	os<<debug_frank::tab<<"static_path: origin="<<obj.position<<std::endl;
	debug_frank::unprocess_tab();
	return os;
}
