/* 
		static_path: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _static_path_
#define _static_path_

#include <iostream>
#include "geometrie.h"

//! Class static_path
/*!
MORE COMMENT ABOUT THE CLASS
*/

class static_path
{
public:

	/////////////////////////////////
	// atributs of the class:

	//! position of the static path.
	geometrie::point2d position;
	
	//! the tangent is define. In fact, a static path is also
	//! a 2d repere.
	geometrie::point2d tangent;
	
	//! the normal is define. In fact, a static path is also
	//! a 2d repere.
	geometrie::point2d normal;

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	//! give the tangent vector of the path at the f parameter.
	virtual float give_tangent_vector_angle(float f) const;
	
	//! give the tangent vector of the path at the f parameter.
	virtual geometrie::point2d give_tangent_vector(float f) const;
	
	//! give the tangent vector of the path at the f parameter.
	virtual geometrie::point2d give_normal_vector(float f) const;
	
	//! give the tangent vector of the path at the f parameter.
	virtual geometrie::point2d give_position(float f) const;
	
	//! the default constructor
	/*! 
	*/
	static_path(geometrie::point2d pos,
				geometrie::point2d t=geometrie::point2d(1,0),
				geometrie::point2d n=geometrie::point2d(0,1));
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	static_path(const static_path& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	static_path& operator=(const static_path& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~static_path();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const static_path& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _static_path_ */
