/* 
		straight_path: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _straight_path_
#define _straight_path_

#include <iostream>
#include "path.h"
#include "geometrie.h"

//! Class straight_path
/*!
MORE COMMENT ABOUT THE CLASS
*/

class straight_path: public path
{
public:

	/////////////////////////////////
	// atributs of the class:

	//! beginnig of the path
	geometrie::point2d start;

	//! normalized vector of direction
	geometrie::point2d direction;

	//! angle between ex and direction
	float angle;

public:	

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	//! give the tangent vector of the path at the f parameter.
	virtual float give_tangent_vector_angle(float f) const;

	//! give the tangent vector of the path at the f parameter.
	virtual geometrie::point2d give_tangent_vector(float f) const;
	
	//! give the tangent vector of the path at the f parameter.
	virtual geometrie::point2d give_normal_vector(float f) const;
	
	//! give the tangent vector of the path at the f parameter.
	virtual geometrie::point2d give_position(float f) const;
		
	//! the default constructor
	/*! 
	*/
	straight_path(geometrie::point2d s,geometrie::point2d d);
	
	//! the default constructor
	/*! 
	*/
	straight_path(geometrie::point2d s,float aangle);
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	straight_path(const straight_path& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	straight_path& operator=(const straight_path& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~straight_path();
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const straight_path& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _straight_path_ */
