/* 
		wind_anihilator: corps de la classe

		author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "wind_anihilator.h"

#include "debug.h"

//! make the primitive live
bool wind_anihilator::up_to_date()
{
	return !am_i_dead;
}

//! return the information emitted to the point p
wind_primitive::info wind_anihilator::give_info(geometrie::point2d p)
{
	return info();
}
	
// the default constructor
wind_anihilator::wind_anihilator(circle* c,birth<wind_anihilator>* b,death<wind_anihilator>* d)
:wind_primitive(c,b->start,d->end,1000.0)
{
	debug_frank::error("No default constructor implemented in the class wind_anihilator.\n",1);
}

// the copy constructor
wind_anihilator::wind_anihilator(const wind_anihilator& obj)
:wind_primitive(obj)
{
	debug_frank::error("No copy constructor implemented in the class wind_anihilator.\n",1);
}

// the assignement constructor:
wind_anihilator& wind_anihilator::operator=(const wind_anihilator& obj)
{
	if (this != &obj)
	{
		debug_frank::error("No assignement implemented in the class wind_anihilator.\n",1);
	}
	return *this;
}

// the destructor: 
wind_anihilator::~wind_anihilator()
{
	debug_frank::error("No destructor implemented in the class wind_anihilator.\n",1);
}

// display
std::ostream& operator<<(std::ostream& os, const wind_anihilator& obj)
{
	os<<"No display implemented in the class wind_anihilator.\n";
	return os;
}
