/* 
		wind_primitive: corps de la classe

		author: Frank Perbet

		Versions:
 			- [DATE]: (initial version) 
*/

/*************************************************************************/
#include "wind_primitive.h"

#include "debug.h"
#include "gust_of_wind.h"
#include "breeze.h"
#include "wind_anihilator.h"
#include "blast_of_air.h"

// the default constructor
wind_primitive::wind_primitive(figure2d* f,date dob,date dod,float wwind_coef)
:primitive(f,dob,dod),wind_coef(wwind_coef)
{
}

// the copy constructor
wind_primitive::wind_primitive(const wind_primitive& obj)
:primitive(obj)
{
	debug_frank::error("No copy constructor implemented in the class wind_primitive.\n",1);
}

// the assignement constructor:
wind_primitive& wind_primitive::operator=(const wind_primitive& obj)
{
	if (this != &obj)
	{
		debug_frank::error("No assignement implemented in the class wind_primitive.\n",1);
	}
	return *this;
}

// the destructor: 
wind_primitive::~wind_primitive()
{
}

// display
std::ostream& operator<<(std::ostream& os, const wind_primitive& obj)
{
	try
	{
		const wind_anihilator& ref_wa=dynamic_cast<const wind_anihilator&>(obj);
		os<<ref_wa;
		return os;
	}
	catch(std::bad_cast) {}
	
	try
	{
		const gust_of_wind& ref_gow=dynamic_cast<const gust_of_wind&>(obj);
		os<<ref_gow;
		return os;
	}
	catch(std::bad_cast) {}
	
	try
	{
		const breeze& ref_b=dynamic_cast<const breeze&>(obj);
		os<<ref_b;	
		return os;
	}
	catch(std::bad_cast) {}
	
	try
	{
		const blast_of_air& ref_b=dynamic_cast<const blast_of_air&>(obj);
		os<<ref_b;	
		return os;
	}
	catch(std::bad_cast) {}
	
	assert(false);
	return os;
}
