/* 
		wind_primitive: specification

		author: Frank Perbet

		Versions:
 			- 
*/


/* 
	Comments:

*/

/*************************************************************************/

#ifndef _wind_primitive_
#define _wind_primitive_

#include <iostream>
#include "debug.h"
#include "primitive.h"
#include "geometrie.h"
#include "figure2d.h"
#include "InformationPrimitive.hpp"

//! Class wind_primitive
/*!
MORE COMMENT ABOUT THE CLASS
*/

class wind_primitive: public primitive
{
public:

	/////////////////////////////////
	// atributs of the class:

	//! info type
	typedef ::wind_info info;

	//! base wind power (between 0 and 1000000...)
	float wind_coef;

	// end of atributs of the class.
	/////////////////////////////////
	
	
	/////////////////////////////////
	// methods of the class

	//! retun the information emitted to the point p
	virtual info give_info(geometrie::point2d p)=0;	

	//! the default constructor
	/*! 
	*/
	wind_primitive(figure2d* f,date dob,date dod,float wwind_coef);
	
	//! the copy constructor
	/*! 
	\param obj Object you want to copy.
	*/
	wind_primitive(const wind_primitive& obj);
	
	//! the assignement constructor
	/*! 
	\param obj Object you want to assign.
	*/
	wind_primitive& operator=(const wind_primitive& obj);
	
	//! the destructor
	/*! 
	destroy all the object attributs.
	*/
	virtual ~wind_primitive();

	std::ostream& write(std::ostream& os) const
	{
		os<<debug_frank::tab<<"wind_primitive:\n";
		os<<debug_frank::tab<<"power = "<<power_coef<<"\n";
		return os;
	}
	
	//! feed the given stream with the caracteristic of the object (value of attributs).
	/*!
	\param os Stream you want to feed.
	\param obj Object you want to display.
	\example cout<<obj;
	*/
	friend std::ostream& operator<<(std::ostream& os, const wind_primitive& obj);

	// end of methods of the class
	/////////////////////////////////
};

#endif /* _wind_primitive_ */
