#ifndef _PRAIRIE_H_BASE
#define _PRAIRIE_H_BASE


void prairieInit();
void prairieDraw(float* cameraPosition, float* cameraVecteurZ);
void prairieSetWindowSize(int w, int h);
void prairieQuit();

//anim
void prairieSetAnim(bool b);
void prairieSetAnimDT(float f);
void prairieSetUpdateGrassDrawing(bool b);

bool prairieGetAnim();
float prairieGetAnimDT();
bool prairieGetUpdateGrassDrawing();

//draw options
void prairieSetGroundDraw(bool b);
void prairieSetTreesDraw(bool b);
void prairieSetGrassDraw(bool b);
void prairieSetGrassDrawNodes(bool b);
void prairieSetGrassDensityDraw(bool b) ;
void prairieSetSkyDraw(bool b);
void prairieSetGustDraw(bool b);
void prairieSetTexture2DDraw(bool b);
void prairieSetTexture2D5Draw(bool b);
void prairieSetWireDraw(bool b);

bool prairieGetGroundDraw();
bool prairieGetTreesDraw();
bool prairieGetGrassDraw();
bool prairieGetGrassDrawNodes();
bool prairieGetGrassDensityDraw() ;
bool prairieGetSkyDraw();
bool prairieGetGustDraw();
bool prairieSetTexture2DDraw();
bool prairieSetTexture2D5Draw();
bool prairieGetWireDraw();

//rock
void prairieSetRockPosition(const float position[3]);
void prairieDirectTheRock(bool b);
void prairieSetRockBound(bool b);
void prairieDirectTheRockUp();
void prairieDirectTheRockDown();
void prairieDirectTheRockLeft();
void prairieDirectTheRockRight();
void prairieSetRockSpeed(float f);
void prairieSetRockSize(float f);
void prairieSetRockCrushingPower(float f);
void prairieSetRockCrushingPowerExp(float f);
void prairieSetRockCrushingMysteryParameter(float f);
void prairieSetRockCrushingPropagation(float f);

void prairieGetRockPosition(float position[3]);
bool prairieIsDirectTheRock();
bool prairieGetRockBound();
float prairieGetRockSpeed();
float prairieGetRockSize();
float prairieGetRockCrushingPower();
float prairieGetRockCrushingPowerExp();
float prairieGetRockCrushingMysteryParameter();
float prairieGetRockCrushingPropagation();

//return infos
int prairieGetNbPolygonsDrawedPerFrame();
int prairieGetNbPolygonsDrawedPerFrameForTrees();
int prairieGetNbPolygonsDrawedPerFrameForGrass();
void prairieGetInfosOnCalculations(char str[64]);


#endif
