#include "MyPrairieQTDriver.h"
#include "MyPrairie.h"
#include "MyPrairieXML.h"
#include "PrairieDefaultDirectoriesAndFiles.h"

#include <qapplication.h>
#include <qfiledialog.h>

#define COEF_QT_ANIM_DT 0.001
#define COEF_QT_ROCK_SPEED 0.01
#define COEF_QT_ROCK_SIZE 0.01
#define COEF_QT_ROCK_CRUSHING_POWER 1.0
#define COEF_QT_ROCK_CRUSHING_POWER_EXP 0.01
#define COEF_QT_ROCK_CRUSHING_PROPAGATION 0.001
#define COEF_QT_ROCK_CRUSHING_MYSTERY_PARAMETER 0.001


MyPrairieQTDriver::MyPrairieQTDriver() : PrairieQTDriver() {}

MyPrairieQTDriver::~MyPrairieQTDriver(){}


//--------------------------------------------------------------
//------------------------MYPRAIRIE-----------------------------
//--------------------------------------------------------------
//-----------------------------------------
//-------------------------parametres scene
//----------------------------------------- 
void MyPrairieQTDriver::loadScene()
{
QString fn;
fn = QFileDialog::getOpenFileName(this, "select doc xml", SCENE_DEFAULT_DIRECTORY, "doc XML (*.xml)"); // pour QT4
//fn = Q3FileDialog::getOpenFileName(SCENE_DEFAULT_DIRECTORY,"doc XML (*.xml)");//QT3
if ( fn.isEmpty() ) {return;}
loadSceneXML(fn.toAscii()); // au lieu de loadSceneXML(fn.ascii()); // pour QT3
loadQTInterface();
} 
void MyPrairieQTDriver::saveScene()
{
QString fn;
fn = QFileDialog::getSaveFileName(this, "select doc xml", SCENE_DEFAULT_DIRECTORY, "doc XML (*.xml)"); // pour QT4
//fn = Q3FileDialog::getSaveFileName(SCENE_DEFAULT_DIRECTORY,"doc XML (*.xml)");// QT3
if ( fn.isEmpty() ) {return;}
if (!fn.contains(QString(".xml"))) fn=fn+QString(".xml");
saveSceneXML(fn.toAscii()); // au lieu de fn.ascii pour QT3
} 


void MyPrairieQTDriver::setAnim(bool b)
{
prairieSetAnim(b);
} 
void MyPrairieQTDriver::setAnimDT(int i)
{
prairieSetAnimDT(float(i)*COEF_QT_ANIM_DT);
}
void MyPrairieQTDriver::setUpdateGrassDrawing(bool b)
{
prairieSetUpdateGrassDrawing(b);
}


void MyPrairieQTDriver::setGroundDraw(bool b)
{
prairieSetGroundDraw(b);
} 
void MyPrairieQTDriver::setTreesDraw(bool b)
{
prairieSetTreesDraw(b);
} 
void MyPrairieQTDriver::setGrassDraw(bool b)
{
prairieSetGrassDraw(b);
}
void MyPrairieQTDriver::setSkyDraw(bool b)
{
prairieSetSkyDraw(b);
}
void MyPrairieQTDriver::setGrassNodesDraw(bool b)
{
prairieSetGrassDrawNodes(b);
}
void MyPrairieQTDriver::setGustDraw(bool b)
{
prairieSetGustDraw(b);
} 
void MyPrairieQTDriver::setGrassTrajectoryDraw(bool b)
{
printf("TODO -> setGrassTrajectoryDraw\n");
}
void MyPrairieQTDriver::setGrassDensityDraw(bool b)
{
prairieSetGrassDensityDraw(b);
}
void MyPrairieQTDriver::setWireDraw(bool b)
{
prairieSetWireDraw(b);
}


void MyPrairieQTDriver::setRockSpeed(int i)
{
prairieSetRockSpeed(float(i)*COEF_QT_ROCK_SPEED);
}
void MyPrairieQTDriver::setRockSize(int i)
{
prairieSetRockSize(float(i)*COEF_QT_ROCK_SIZE);
}
void MyPrairieQTDriver::setRockMvtAuto(bool b)
{
prairieDirectTheRock(!b);
}
void MyPrairieQTDriver::setRockBound(bool b)
{
prairieSetRockBound(b);
}
void MyPrairieQTDriver::setRockCrushingPower(int i)
{
prairieSetRockCrushingPower(float(i)*COEF_QT_ROCK_CRUSHING_POWER);
}
void MyPrairieQTDriver::setRockCrushingPowerExp(int i)
{
prairieSetRockCrushingPowerExp(float(i)*COEF_QT_ROCK_CRUSHING_POWER_EXP);
}
void MyPrairieQTDriver::setRockCrushingMysteryParameter(int i)
{
prairieSetRockCrushingMysteryParameter(float(i)*COEF_QT_ROCK_CRUSHING_MYSTERY_PARAMETER);
}
void MyPrairieQTDriver::setRockCrushingPropagation(int i)
{
prairieSetRockCrushingPropagation(float(i)*COEF_QT_ROCK_CRUSHING_PROPAGATION);
} 
 

void MyPrairieQTDriver::loadQTInterface()
{
PrairieQTDriver::loadQTInterface();

//----scene
setQTAnim(prairieGetAnim()); 
setQTAnimDT(int(prairieGetAnimDT()/COEF_QT_ANIM_DT));
setQTUpdateGrassDrawing(prairieGetUpdateGrassDrawing());

setQTGroundDraw(prairieGetGroundDraw());
setQTTreesDraw(prairieGetTreesDraw());
setQTGrassDraw(prairieGetGrassDraw());
setQTGustDraw(prairieGetGustDraw());
setQTSkyDraw(prairieGetSkyDraw());
//setQTGrassTrajectoryDraw(prairieGetGrassTrajectoryDraw());
setQTGrassDensityDraw(prairieGetGrassDensityDraw()) ;
setQTGrassNodesDraw(prairieGetGrassDrawNodes());
setQTWireDraw(prairieGetWireDraw());

setQTRockSpeed(int(prairieGetRockSpeed()/COEF_QT_ROCK_SPEED));
setQTRockSize(int(prairieGetRockSize()/COEF_QT_ROCK_SIZE));
setQTRockMvtAuto(!prairieIsDirectTheRock());
setQTRockBound(prairieGetRockBound());
setQTRockCrushingPower(int(prairieGetRockCrushingPower()/COEF_QT_ROCK_CRUSHING_POWER));
setQTRockCrushingPowerExp(int(prairieGetRockCrushingPowerExp()/COEF_QT_ROCK_CRUSHING_POWER_EXP));
setQTRockCrushingMysteryParameter(int(prairieGetRockCrushingMysteryParameter()/COEF_QT_ROCK_CRUSHING_MYSTERY_PARAMETER));
setQTRockCrushingPropagation(int(prairieGetRockCrushingPropagation()/COEF_QT_ROCK_CRUSHING_PROPAGATION));
}










