
#include "qglviewer.h"
#include <QMouseEvent>
#include <QKeyEvent>

class Viewer : public QGLViewer
{ 
Q_OBJECT

public :
  Viewer(QWidget* parent=0, const QGLWidget* shareWidget=0, Qt::WFlags flags=0);

  ~Viewer();
 
void setCameraPosition(float x,float y,float z)
  			{camera()->setPosition(qglviewer::Vec(x,y,z));}
void getCameraPosition(float& x,float& y,float& z)
  			{qglviewer::Vec v = camera()->position();
  				x= v.x;
  				y= v.y;
  				z= v.z;
  				}
void setCameraOrientation(float q0,float q1,float q2,float q3)
 			{camera()->setOrientation(qglviewer::Quaternion(q0,q1,q2,q3));}
void getCameraOrientation(float& q0,float& q1,float& q2,float& q3)
			{qglviewer::Quaternion q =(camera()->orientation());
				q0=q[0];
				q1=q[1];
				q2=q[2];
				q3=q[3];
				}

protected :  
  void init();
  void preDraw();
  void draw();
  void resizeGL(int w, int h);
  
  void setDisplayText(bool b)
  	{m_dislpayText=b;}
  void displayText();
  virtual QString helpString() const;
  
  void mousePressEvent (QMouseEvent *e);
  void mouseReleaseEvent (QMouseEvent *e);
  void mouseMoveEvent (QMouseEvent *e);
  void keyPressEvent(QKeyEvent *e);
 // void keyReleaseEvent(QKeyEvent *e);
  
  QTimer* m_pTimerDrawLoop;
  bool m_dislpayText;
  bool m_displayNbPolygonsAndFPS;
  bool m_displayProcessorOccupation;
  bool m_displayHelp;
  bool m_prairieSetTexture2D5Draw;
  bool m_prairieSetTexture2DDraw;
};

 
