
#include "MyPrairieXML.h"
#include "PrairieXML.h"

//xml
#include <libxml/parser.h>
#include <libxml/tree.h>
#include <libxml/parserInternals.h>
#include <string>
#include <vector>

using namespace std;

//for scene parameters
#include "MyPrairie.h"

//for access/change camera position ans orientation
#include "MyPrairieViewer.h"
extern Viewer* myPrairieViewer;

void saveCameraXML(xmlNodePtr p_parametersNode)
{
char value[64];
xmlNodePtr p_cameraNode = NULL;

float position[3];
float orientation[4];
myPrairieViewer->getCameraPosition(position[0],position[1],position[2]);
myPrairieViewer->getCameraOrientation(orientation[0],orientation[1],
			    orientation[2],orientation[3]);

p_cameraNode=xmlNewNode (NULL, (const xmlChar*)"camera");

sprintf(value,"%.4f %.4f %.4f",position[0],position[1],position[2]);
xmlNewProp(p_cameraNode,(const xmlChar*)"position",(const xmlChar*)value);

sprintf(value,"%.4f %.4f %.4f %.4f",orientation[0],orientation[1],orientation[2],orientation[3]);
xmlNewProp(p_cameraNode,(const xmlChar*)"orientation",(const xmlChar*)value);

xmlAddChild(p_parametersNode,p_cameraNode);
}


void saveRockXML(xmlNodePtr p_parametersNode)
{
char value[64];
xmlNodePtr p_rockNode = NULL;
p_rockNode=xmlNewNode (NULL, (const xmlChar*)"rock");

float position[2];prairieGetRockPosition(position);
sprintf(value,"%.4f %.4f",position[0],position[1]);
xmlNewProp(p_rockNode,(const xmlChar*)"position",(const xmlChar*)value);

if (prairieIsDirectTheRock()) 
xmlNewProp(p_rockNode,(const xmlChar*)"direct",(const xmlChar*)"true");
else
xmlNewProp(p_rockNode,(const xmlChar*)"direct",(const xmlChar*)"false");

if (prairieGetRockBound()) 
xmlNewProp(p_rockNode,(const xmlChar*)"bound",(const xmlChar*)"true");
else
xmlNewProp(p_rockNode,(const xmlChar*)"bound",(const xmlChar*)"false");

sprintf(value,"%.4f",prairieGetRockSpeed());
xmlNewProp(p_rockNode,(const xmlChar*)"speed",(const xmlChar*)value);

sprintf(value,"%.4f",prairieGetRockSize());
xmlNewProp(p_rockNode,(const xmlChar*)"size",(const xmlChar*)value);

sprintf(value,"%.4f",prairieGetRockCrushingPower());
xmlNewProp(p_rockNode,(const xmlChar*)"crushing_power",(const xmlChar*)value);

sprintf(value,"%.4f",prairieGetRockCrushingPowerExp());
xmlNewProp(p_rockNode,(const xmlChar*)"crushing_power_exp",(const xmlChar*)value);

sprintf(value,"%.4f",prairieGetRockCrushingMysteryParameter());
xmlNewProp(p_rockNode,(const xmlChar*)"crushing_mystery_parameter",(const xmlChar*)value);

sprintf(value,"%.4f",prairieGetRockCrushingPropagation());
xmlNewProp(p_rockNode,(const xmlChar*)"crushing_propagation",(const xmlChar*)value);

xmlAddChild(p_parametersNode,p_rockNode);
}



void saveParametersXML(xmlNodePtr p_sceneNode)
{
xmlNodePtr p_parametersNode = NULL;
char value[64];

p_parametersNode=xmlNewNode (NULL, (const xmlChar*)"parameters");

if (prairieGetAnim()) 
xmlNewProp(p_parametersNode,(const xmlChar*)"animation",(const xmlChar*)"true");
else
xmlNewProp(p_parametersNode,(const xmlChar*)"animation",(const xmlChar*)"false");

sprintf(value,"%.4f",prairieGetAnimDT());
xmlNewProp(p_parametersNode,(const xmlChar*)"animation_dt",(const xmlChar*)value);

if (prairieGetUpdateGrassDrawing()) 
xmlNewProp(p_parametersNode,(const xmlChar*)"update_grass_drawing",(const xmlChar*)"true");
else
xmlNewProp(p_parametersNode,(const xmlChar*)"update_grass_drawing",(const xmlChar*)"false");

if (prairieGetGroundDraw()) 
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_ground",(const xmlChar*)"true");
else
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_ground",(const xmlChar*)"false");

if (prairieGetGrassDraw()) 
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_grass",(const xmlChar*)"true");
else
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_grass",(const xmlChar*)"false");

if (prairieGetGrassDrawNodes()) 
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_grass_nodes",(const xmlChar*)"true");
else
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_grass_nodes",(const xmlChar*)"false");

if (prairieGetGrassDensityDraw()) 
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_grass_density",(const xmlChar*)"true");
else
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_grass_density",(const xmlChar*)"false");

if (prairieGetTreesDraw()) 
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_trees",(const xmlChar*)"true");
else
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_trees",(const xmlChar*)"false");

if (prairieGetGustDraw()) 
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_gust",(const xmlChar*)"true");
else
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_gust",(const xmlChar*)"false");

if (prairieGetSkyDraw()) 
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_sky",(const xmlChar*)"true");
else
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_sky",(const xmlChar*)"false");

if (prairieGetWireDraw()) 
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_wire",(const xmlChar*)"true");
else
xmlNewProp(p_parametersNode,(const xmlChar*)"draw_wire",(const xmlChar*)"false");

saveCameraXML(p_parametersNode);
saveRockXML(p_parametersNode);

xmlAddChild(p_sceneNode,p_parametersNode);
}











/*
//--------------------------------------------------------------------------
//---------------------------GROUND-----------------------------------------
//--------------------------------------------------------------------------
void makeGround(xmlNodePtr node)
{
//variables en attente d'initialisation
char* HeightMap=NULL;
char* Texture=NULL;
float length=100.0;
float width=100.0;
float maxHeight=10.0;
int numberOfQuadsMax=400;
	 
//parcours	 
xmlAttrPtr attr = node->properties;
while (attr != NULL) 
   {
   string attribute = (const char*) attr->name;
   if (attribute=="height_map")
       {
       HeightMap = (char*) xmlGetProp(node, (const xmlChar *) "height_map");
       }
   if (attribute=="texture")
       {
       Texture = (char*) xmlGetProp(node, (const xmlChar *) "texture");
       }
   if (attribute=="dimension")
       {
       float r[3];
       getFloatArrayXml(node, "dimension", r);
       length=r[0];width=r[1];maxHeight=r[2];
       }
   if (attribute=="quads_number")
       {
       float r[0];
       getFloatArrayXml(node, "quads_number", r);
       numberOfQuadsMax=int(r[0]);
       }
   attr=attr->next;
   }
groundInit(length,width,maxHeight,numberOfQuadsMax,
	   HeightMap,Texture,10.0);
}

//--------------------------------------------------------------------------
//---------------------------GRASSES----------------------------------------
//-------------------------------------------------------------------------- 
void makeGrasses(xmlNodePtr node)
{
//variables en attente d'initialisation
bool draw=false;
bool draw_nodes=false;
bool draw_density=false;
float height=1.0;
float width=0.05;
short patches_number[]={60,60};
short lod_3D_pg=3;
float lod_3D_dist=10.0;
short lod_2D5_pg=1;
float lod_2D5_dist=100.0;
float lod_2D_dist=1000.0;
char* density_map=NULL;
short density_squaremeters=10;
float crushing_time=20.0;
float crushing_damping=2.0;
	
//parcours		 
xmlAttrPtr attr = node->properties;
while (attr != NULL) 
   {
   string attribute = (const char*) attr->name;
   if (attribute=="draw")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar *)"draw")))
	  draw=true;
	else
	  draw=false;
   	}
   if (attribute=="draw_nodes")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar *)"draw_nodes")))
	  draw_nodes=true;
	else
	  draw_nodes=false;
   	}
   if (attribute=="draw_density")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar *)"draw_density")))
	  draw_density=true;
	else
	  draw_density=false;
   	}
   if (attribute=="height")
   	{
   	height = atof((const char*) xmlGetProp(node, (const xmlChar *)"height"));
   	}
   if (attribute=="width")
   	{
   	width = atof((const char*) xmlGetProp(node, (const xmlChar *)"width"));
   	}
   if (attribute=="patches_number")
   	{
	float tmp[2];
	getFloatArrayXml(node, "patches_number", tmp);
   	patches_number[0]=short(tmp[0]);
	patches_number[1]=short(tmp[1]);
   	}
   if (attribute=="lod_3D")
   	{
	float tmp[2];
	getFloatArrayXml(node, "lod_3D", tmp);
   	lod_3D_pg=short(tmp[0]);
	lod_3D_dist=tmp[1];
   	}
   if (attribute=="lod_2D5")
   	{
	float tmp[2];
	getFloatArrayXml(node, "lod_2D5", tmp);
   	lod_2D5_pg=short(tmp[0]);
	lod_2D5_dist=tmp[1];
   	}
   if (attribute=="lod_2D")
   	{
	float tmp[2];
	getFloatArrayXml(node, "lod_2D", tmp);
	lod_2D_dist=tmp[1];
   	}
   if (attribute=="density_map")
   	{
	density_map = (char*) xmlGetProp(node, (const xmlChar *) "density_map");
   	}
   if (attribute=="density_squaremeters")
   	{
	density_squaremeters = atoi((const char*) xmlGetProp(node, (const xmlChar *)"density_squaremeters"));
   	}
   if (attribute=="crushing_time")
   	{
	crushing_time = atof((const char*) xmlGetProp(node, (const xmlChar *)"density_squaremeters"));
   	}
   if (attribute=="crushing_damping")
   	{
	crushing_time = atof((const char*) xmlGetProp(node, (const xmlChar *)"crushing_damping"));
   	}
   attr=attr->next;
   }
   

   
grassInit(groundGetLength(),groundGetWidth(),
	  patches_number[0],patches_number[1],
	  density_map);
grassSetHeight(height);
grassSetWidth(width);
grassSetNumberPerSquareMeter(density_squaremeters);
grassSetCrushingMaxTime(crushing_time);
grassSetCrushingDamping(crushing_damping);
grassSetDistance3D(lod_3D_dist);
grassSetDistance2D5(lod_2D5_dist);
grassSetDistance2D(lod_2D_dist);
grassSetPG3DGrass(lod_3D_pg);
grassSetPG2D5Grass(lod_2D5_pg);
}

//--------------------------------------------------------------------------
//---------------------------WIND-------------------------------------------
//-------------------------------------------------------------------------- 
void makeWind(xmlNodePtr node)
{
//variables en attente d'initialisation
float breeze_speed=1.0;
float breeze_power=25.0;
float gust_speed=1.0;
float gust_power=250.0;
bool gust_draw=false;
			 
xmlAttrPtr attr = node->properties;
while (attr != NULL) 
   {
   string attribute = (const char*) attr->name;
   if (attribute=="gust_draw")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar *)"gust_draw")))
	  gust_draw=true;
	else
	  gust_draw=false;
   	}
  if (attribute=="breeze_speed")
   	{
   	breeze_speed = atof((const char*) xmlGetProp(node, (const xmlChar *)"breeze_speed"));
   	}
  if (attribute=="breeze_power")
   	{
   	breeze_power = atof((const char*) xmlGetProp(node, (const xmlChar *)"breeze_power"));
   	}
  if (attribute=="gust_speed")
   	{
   	gust_speed = atof((const char*) xmlGetProp(node, (const xmlChar *)"gust_speed"));
   	}
   if (attribute=="gust_power")
   	{
   	gust_power = atof((const char*) xmlGetProp(node, (const xmlChar *)"gust_power"));
   	}
   attr=attr->next;
   }
windInit (0.0,groundGetLength(),
	  0.0,groundGetWidth(),
	  groundGetMaxHeight());
windSetBreezePower(breeze_power);
windSetBreezeSpeed(breeze_speed);
windSetGustPower(gust_power);
windSetGustSpeed(gust_speed);   
}


//--------------------------------------------------------------------------
//---------------------------TREES------------------------------------------
//-------------------------------------------------------------------------- 
void makeTrees(xmlNodePtr node)
{
//variables en attente d'initialisation
bool draw=true;
char* file_arb=NULL;
short trees_number=0;
float positionX[256];
float positionY[256];
float positionZ[256];

//parcours		 
xmlAttrPtr attr = node->properties;
while (attr != NULL) 
   {
   string attribute = (const char*) attr->name;
   if (attribute=="draw")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar *)"draw")))
	  draw=true;
	else
	  draw=false;
   	}
   if (attribute=="arb")
   	{
   	file_arb = (char*) xmlGetProp(node, (const xmlChar *) "arb");
   	}
   attr=attr->next;
   }

//parcours position
node = node->children;
while (node!= NULL)
   {
   string name = (const char*) node->name;
   if (name=="position2d")
   	{
	float tmp[2];
	getFloatArrayXml(node, tmp);
	positionX[trees_number]=tmp[0];
	positionY[trees_number]=tmp[1];
	positionZ[trees_number]=groundGetHeightAtPosition(tmp[0],tmp[1]);	
	trees_number++;
	}
   node = node->next;
   }
   
forestLoadARB(file_arb);
forestSetTrees(trees_number,positionX,positionY,positionZ);
}
*/


//--------------------------------------------------------------------------
//---------------------------SCENE------------------------------------------
//--------------------------------------------------------------------------
void tokenize(const string& str,
	      vector<string>& tokens,
	      const string& delimiters) 
{
  string::size_type lastPos = str.find_first_not_of(delimiters, 0);
  string::size_type pos = str.find_first_of(delimiters, lastPos);
  
  while (string::npos != pos || string::npos != lastPos) {
    tokens.push_back(str.substr(lastPos, pos - lastPos));
    lastPos = str.find_first_not_of(delimiters, pos);
    pos = str.find_first_of(delimiters, lastPos);
  }
}

void getFloatArrayXml(xmlNodePtr node, float x[]) 
{
  string text = (const char*) xmlNodeGetContent(node);
  vector<string> tokens;
  tokenize(text, tokens, " ");
  for (int i=0; i<(int)tokens.size(); i++) 
    {
    string test = tokens[i];
    x[i] = atof(test.c_str());
    }
}

void getFloatArrayXml(xmlNodePtr node, char* attribname, float x[]) 
{
  string text = (const char*) xmlGetProp(node, (const xmlChar *) attribname);
  vector<string> tokens;
  tokenize(text, tokens, " ");
  for (int i=0; i<(int)tokens.size(); i++) 
    {
    string test = tokens[i];
    x[i] = atof(test.c_str());
    }
}



bool loadRockXML(xmlNodePtr node)
{
bool direct=prairieIsDirectTheRock();
bool bound=prairieGetRockBound();
float speed=prairieGetRockSpeed();
float size=prairieGetRockSize();
float crushing_power= prairieGetRockCrushingPower();
float crushing_power_exp= prairieGetRockCrushingPowerExp();
float crushing_mystery_parameter=prairieGetRockCrushingMysteryParameter();
float crushing_propagation=prairieGetRockCrushingPropagation();
float position[2];prairieGetRockPosition(position);

xmlAttrPtr attr = node->properties;
while (attr != NULL) 
   {
   string attribute = (const char*) attr->name;
   if (attribute=="direct")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar*)"direct")))
	direct=true;
	else 
	direct=false;
   	}
   if (attribute=="bound")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar*)"bound")))
	bound=true;
	else 
	bound=false;
   	}
    if (attribute=="speed")
   	{
   	speed = atof((const char*) xmlGetProp(node, (const xmlChar *)"speed"));
   	}
   if (attribute=="size")
   	{
   	size = atof((const char*) xmlGetProp(node, (const xmlChar *)"size"));
   	}
   if (attribute=="crushing_power")
   	{
   	crushing_power = atof((const char*) xmlGetProp(node, (const xmlChar *)"crushing_power"));
   	}
   if (attribute=="crushing_power_exp")
   	{
   	crushing_power_exp = 
	atof((const char*) xmlGetProp(node, (const xmlChar*)"crushing_power_exp"));
   	}
   if (attribute=="crushing_mystery_parameter")
   	{
   	crushing_mystery_parameter =
	atof((const char*) xmlGetProp(node, (const xmlChar*)"crushing_mystery_parameter"));
   	}
   if (attribute=="crushing_propagation")
   	{
   	crushing_propagation =
	atof((const char*) xmlGetProp(node, (const xmlChar*)"crushing_propagation"));
   	}
   if (attribute=="position")
   	{
   	getFloatArrayXml(node, "position", position); 
   	}
   attr=attr->next;
   }
prairieDirectTheRock(direct);
prairieSetRockBound(bound);
prairieSetRockSpeed(speed);
prairieSetRockSize(size);
prairieSetRockCrushingPower(crushing_power);
prairieSetRockCrushingPowerExp(crushing_power_exp);
prairieSetRockCrushingMysteryParameter(crushing_mystery_parameter);
prairieSetRockCrushingPropagation(crushing_propagation);
prairieSetRockPosition(position);
return true;
}



bool loadCameraXML(xmlNodePtr node)
{
float orientation[]={0.0,0.0,0.0,0.0};
float position[]={0.0,0.0,0.0};

xmlAttrPtr attr = node->properties;
while (attr != NULL) 
   {
   string attribute = (const char*) attr->name;
   if (attribute=="position")
   	{
	getFloatArrayXml(node, "position", position); 
   	}
   if (attribute=="orientation")
   	{
	getFloatArrayXml(node, "orientation", orientation); 
   	}
   attr=attr->next;
   }
myPrairieViewer->setCameraOrientation(orientation[0],orientation[1],
				      orientation[2],orientation[3]);   
myPrairieViewer->setCameraPosition(position[0],position[1],position[2]);
return true;
}



bool loadParametersXML(xmlNodePtr node)
{
bool animation=prairieGetAnim();
float animation_dt=prairieGetAnimDT();
bool update_grass_drawing=prairieGetUpdateGrassDrawing();

bool draw_ground=prairieGetGroundDraw();
bool draw_grass=prairieGetGrassDraw();
bool draw_grass_nodes=prairieGetGrassDrawNodes();
bool draw_grass_density=prairieGetGrassDensityDraw() ;
bool draw_trees=prairieGetTreesDraw();
bool draw_gust=prairieGetGustDraw();
bool draw_sky=prairieGetSkyDraw();
bool draw_wire=prairieGetWireDraw();

xmlAttrPtr attr = node->properties;
while (attr != NULL) 
   {
   string attribute = (const char*) attr->name;
   if (attribute=="animation")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar*)"animation")))
	animation=true;
	else 
	animation=false;
   	}
   if (attribute=="animation_dt")
   	{
   	animation_dt=atof((const char*) xmlGetProp(node, (const xmlChar *)"animation_dt"));
   	}
   if (attribute=="update_grass_drawing")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar*)"update_grass_drawing")))
	update_grass_drawing=true;
	else 
	update_grass_drawing=false;
   	}
   if (attribute=="draw_grass")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar*)"draw_grass")))
	draw_grass=true;
	else 
	draw_grass=false;
   	}
   if (attribute=="draw_grass_nodes")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar*)"draw_grass_nodes")))
	draw_grass_nodes=true;
	else 
	draw_grass_nodes=false;
   	}
   if (attribute=="draw_grass_density")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar*)"draw_grass_density")))
	draw_grass_density=true;
	else 
	draw_grass_density=false;
   	}
   if (attribute=="draw_trees")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar*)"draw_trees")))
	draw_trees=true;
	else 
	draw_trees=false;
   	}
   if (attribute=="draw_gust")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar*)"draw_gust")))
	draw_gust=true;
	else 
	draw_gust=false;
   	}
   if (attribute=="draw_ground")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar*)"draw_ground")))
	draw_ground=true;
	else 
	draw_ground=false;
   	}
   if (attribute=="draw_sky")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar*)"draw_sky")))
	draw_sky=true;
	else 
	draw_sky=false;
   	}
   if (attribute=="draw_wire")
   	{
   	if (!strcmp("true",(const char*) xmlGetProp(node, (const xmlChar*)"draw_wire")))
	draw_wire=true;
	else 
	draw_wire=false;
   	}
   attr=attr->next;
   }
   
//chargement des sous noeuds   
xmlNodePtr child = node->children;
while (child != NULL) 
   {
   if (child->type == XML_ELEMENT_NODE)
      {   
      string name = (const char*) child->name;
      if (name == "camera")
         {
	 loadCameraXML(child);
	 }
      if (name == "rock")
      	 {
	 loadRockXML(child);
	 }
      }
   child = child->next;
   }

prairieSetAnim(animation);
prairieSetAnimDT(animation_dt);
prairieSetUpdateGrassDrawing(update_grass_drawing);

prairieSetGroundDraw(draw_ground);
prairieSetGrassDraw(draw_grass);
prairieSetGrassDrawNodes(draw_grass_nodes);
prairieSetGrassDensityDraw(draw_grass_density) ;
prairieSetTreesDraw(draw_trees);
prairieSetGustDraw(draw_gust);
prairieSetSkyDraw(draw_sky);
prairieSetWireDraw(draw_wire);   
return true;
}


bool loadSceneParametersXML(xmlNodePtr parentNode)
{
xmlNodePtr child = parentNode->children;
while (child != NULL) 
   {
   if (child->type == XML_ELEMENT_NODE)
      {   
      string name = (const char*) child->name;
      if (name == "parameters")
         {
	 return loadParametersXML(child);
	 }
      }
   child = child->next;
   }
return false;
}




//--------------------------------------------------------------------------
//--------------------------------------------------------------------------
bool loadSceneXML(const char* filename)
{
xmlNodePtr p_node;
xmlDocPtr  p_doc;

//initialisation
if (filename==NULL) return false;
p_doc = xmlParseFile(filename);
if (p_doc == NULL) return false;
p_node = xmlDocGetRootElement(p_doc);

//validation
xmlValidCtxt cvp;
  // print some information
  printf ("chargement de la scene : %s\n", filename);
  if (p_doc->name != NULL) printf("name : %s\n", p_doc->name);
  if (p_doc->compression == -1) printf("     no compression\n");
  else printf("     compression level : %d\n", p_doc->compression);
  printf("     XML version : %s\n", p_doc->version);
  if (p_doc->encoding == NULL) printf("     encoding not specified\n");
  else printf("     encoding : %s\n", p_doc->encoding);  
cvp.userData = stderr;
cvp.error = (xmlValidityErrorFunc) fprintf;
cvp.warning = (xmlValidityWarningFunc) fprintf;  
if (!xmlValidateDocument(&cvp, p_doc)) return false;

bool valid=true;
valid &= loadPrairieXML(p_node);
valid &= loadSceneParametersXML(p_node);
xmlFreeDoc(p_doc);
return valid;
}

void saveSceneXML(const char* filename)
{
xmlDocPtr p_doc = NULL;
xmlNodePtr p_sceneNode = NULL;

//doc
p_doc=xmlNewDoc((const xmlChar*)"1.0");

//root node
p_sceneNode=xmlNewNode (NULL, (const xmlChar*)"scene"); 
p_doc->children=p_sceneNode;

saveParametersXML(p_sceneNode);
savePrairieXML(p_sceneNode);

//internal subset : dtd name and system id
//call after root node creation
xmlCreateIntSubset(p_doc,(const xmlChar*)"scene",
  		   NULL,(const xmlChar*)"scenePrairie.dtd");

xmlSaveFormatFileEnc (filename, p_doc, "UTF-8",1); 
xmlFreeDoc  (p_doc);
}


