#ifndef _PRAIRIE_QT_DRIVER
#define _PRAIRIE_QT_DRIVER

//include QT
#include <qgl.h>

class PrairieQTDriver : public QGLWidget //QObject
{
Q_OBJECT

public:
   PrairieQTDriver();
   ~PrairieQTDriver();

public slots:

  //-----------------------------------------
  //------------------------parametres ground
  //-----------------------------------------	
  void loadGroundHeightMap();
  void loadGroundTexture();
  void setGroundSize(int i);
  void setGroundHeight(int i);
  //-----------------------------------------
  //--------------------------parametres wind
  //----------------------------------------- 
  void setBreezeSpeed(int i);
  void setBreezePower(int i);
  void setGustSpeed(int i);
  void setGustPower(int i);
  void addWindGust();
  void setBlastParam(int i);
  void setBlastPower(int i);
  void addWindBlast();
  //-----------------------------------------
  //-------------------------parametres grass
  //----------------------------------------- 
  void setGrassNbPatches1(int i);
  void setGrassNbPatches2(int i);
  void setGrassNbMaxPerPatche(int i);
  void setGrassWidth(int i);
  void setGrassHeight(int i);
  void setGrassNoisePositions(int i);
  void setGrassNoiseNormals(int i);
  void setGrassRadius3D(int i);
  void setGrassRadius2D5(int i);
  void setGrassRadius2D(int i);
  void setGrassPolyg3D(int i);
  void setGrassPolyg2D5(int i);
  void setGrassAjustment2D5Height(bool b);
  void setGrassCrushingMaxTime(int i);
  void setGrassCrushingDamping(int i);
  void loadGrassDensityMap();
  
  void setGrassTexture3D(bool);
  void loadGrassTexture3D();
  void setGrassAntiAliasingTexture3D(int i);
  void regenerateGrassTexture2D5();
  void setGrassAntiAliasingTexture2D5(int i);
  void setGrassSizeTexture2D5(int i);
  //-----------------------------------------
  //-------------------------parametres trees
  //-----------------------------------------
/*  void setTreesNumber(int i);
  void setTreesNbPolygonsMax(int i);
  void resetTreesPositions();
  void resetTreesForms();
  void loadARB();
  void showTreesInterface(bool b);
*/
signals:
  //-----------------------------------------
  //-------------------------parametres grass
  //----------------------------------------- 
  void setQTGrassNbPatches1(int i);
  void setQTGrassNbPatches2(int i);
  void setQTGrassNbMaxPerPatche(int i);
  void setQTGrassWidth(int i);
  void setQTGrassHeight(int i);
  void setQTGrassNoisePositions(int i);
  void setQTGrassNoiseNormals(int i);
  void setQTGrassRadius3D(int i);
  void setQTGrassRadius2D5(int i);
  void setQTGrassRadius2D(int i);
  void setQTGrassPolyg3D(int i);
  void setQTGrassPolyg2D5(int i);
  void setQTGrassAjustment2D5Height(bool b);
  void setQTGrassCrushingMaxTime(int i);
  void setQTGrassCrushingDamping(int i);
  
  void setQTGrassTexture3D(bool b);
  void setQTGrassAntiAliasingTexture3D(int i);
  void setQTGrassAntiAliasingTexture2D5(int i);
  //-----------------------------------------
  //------------------------parametres ground
  //-----------------------------------------	
  void setQTGroundSize(int i);
  void setQTGroundHeight(int i);
  //-----------------------------------------
  //--------------------------parametres wind
  //----------------------------------------- 
  void setQTBreezeSpeed(int i);
  void setQTBreezePower(int i);
  void setQTGustSpeed(int i);
  void setQTGustPower(int i);
  void setQTBlastParam(int i);
  void setQTBlastPower(int i);
  //-----------------------------------------
  //-------------------------parametres trees
  //-----------------------------------------
//  void setQTTreesNumber(int i);
  
protected:
  void initGrassForestWind();
  virtual void loadQTInterface();
  
};



#endif
