#include <qapplication.h>
#include <qcombobox.h>
#include <iostream>

#include "FormGrass.h"
#include "FormScene.h"
//#include "DialogBox/FormTrees.h"
#include "FormGround.h"
#include "FormWind.h"
#include "MyPrairieViewer.h"
#include "MyPrairieQTDriver.h"

//connection avec myPrairie et lib pour affichage...
Viewer* myPrairieViewer;
//connection avec myPrairie et lib : gestion QT...
MyPrairieQTDriver *myPrairieQTDriver;
//boites de dialogue
FormScene* formScene;
FormGrass* formGrass;
//FormTrees* formTrees;
FormGround* formGround;
FormWind* formWind;


int main( int argc, char* argv[] )
 {      
   QApplication application( argc, argv );
   
   //connection avec myPrairie et lib pour affichage...
   myPrairieViewer=new Viewer();
   //connection avec myPrairie et lib : gestion QT...
   myPrairieQTDriver=new MyPrairieQTDriver();   
   //boites de dialogue
   formScene = new FormScene();
   formGrass = new FormGrass();
//   formTrees = new FormTrees ();
   formGround = new FormGround();
   formWind = new FormWind();


   //----------------------------------------------------------------
   //----------------------------FormScene---------------------------
   //----------------------------------------------------------------
   
 //-----------load/save scene

      QObject::connect((QObject *)(formScene->PushButton_LoadScene),
   		    SIGNAL(clicked()),
                    (QObject *) myPrairieQTDriver,
		    SLOT(loadScene()));
   QObject::connect((QObject *)(formScene->PushButton_SaveScene),
   		    SIGNAL(clicked()),
                    (QObject *) myPrairieQTDriver,
		    SLOT(saveScene()));
   
   //-----------anim	    
   QObject::connect((QObject *)(formScene->PushButton_Start),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setAnim(bool)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTAnim(bool)),
                    (QObject *) formScene->PushButton_Start,
		    SLOT(setOn(bool)));   
   QObject::connect((QObject *)(formScene->Slider_DT),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setAnimDT(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTAnimDT(int)),
                    (QObject *) formScene->Slider_DT,
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formScene->CheckBox_UpdateGrassDrawing),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setUpdateGrassDrawing(bool)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTUpdateGrassDrawing(bool)),
                    (QObject *) formScene->CheckBox_UpdateGrassDrawing,
		    SLOT(setChecked(bool))); 
		    
   //-----------rock		    
   QObject::connect((QObject *)(formScene->Slider_RockSpeed),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setRockSpeed(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTRockSpeed(int)),
                    (QObject *) formScene->Slider_RockSpeed,
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formScene->Slider_RockSize),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setRockSize(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTRockSize(int)),
                    (QObject *) formScene->Slider_RockSize,
		    SLOT(setValue(int)));
   
   //-----------rock mvt  
   QObject::connect((QObject *)(formScene->CheckBox_RockMvtAuto),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setRockMvtAuto(bool)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTRockMvtAuto(bool)),
                    (QObject *) formScene->CheckBox_RockMvtAuto,
		    SLOT(setChecked(bool)));	
   QObject::connect((QObject *)(formScene->CheckBox_RockBound),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setRockBound(bool)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTRockBound(bool)),
                    (QObject *) formScene->CheckBox_RockBound,
		    SLOT(setChecked(bool)));
   
   //-----------rock crushing
   QObject::connect((QObject *)(formScene->Slider_RockCrushingMysteryParam),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setRockCrushingMysteryParameter(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTRockCrushingMysteryParameter(int)),
                    (QObject *) formScene->Slider_RockCrushingMysteryParam,
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formScene->Slider_RockCrushingPropagation),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setRockCrushingPropagation(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTRockCrushingPropagation(int)),
                    (QObject *) formScene->Slider_RockCrushingPropagation,
		    SLOT(setValue(int)));	    
   QObject::connect((QObject *)(formScene->Slider_RockCrushingPower),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setRockCrushingPower(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTRockCrushingPower(int)),
                    (QObject *) formScene->Slider_RockCrushingPower,
		    SLOT(setValue(int)));	
   QObject::connect((QObject *)(formScene->Slider_RockCrushingPowerExp),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setRockCrushingPowerExp(int)));	
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTRockCrushingPowerExp(int)),
                    (QObject *) formScene->Slider_RockCrushingPowerExp,
		    SLOT(setValue(int)));		    
   
   //-----------draw option		        
   QObject::connect((QObject *)(formScene->CheckBox_VisuGusts),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGustDraw(bool)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGustDraw(bool)),
                    (QObject *) formScene->CheckBox_VisuGusts,
		    SLOT(setChecked(bool)));
   QObject::connect((QObject *)(formScene->CheckBox_VisuTrajectory),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassTrajectoryDraw(bool)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassTrajectoryDraw(bool)),
                    (QObject *) formScene->CheckBox_VisuTrajectory,
		    SLOT(setChecked(bool)));		        
   QObject::connect((QObject *)(formScene->CheckBox_VisuGrass),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassDraw(bool)));	    
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassDraw(bool)),
                    (QObject *) formScene->CheckBox_VisuGrass,
		    SLOT(setChecked(bool)));	    
   QObject::connect((QObject *)(formScene->CheckBox_VisuSky),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setSkyDraw(bool)));	    
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTSkyDraw(bool)),
                    (QObject *) formScene->CheckBox_VisuSky,
		    SLOT(setChecked(bool)));	    		    
   QObject::connect((QObject *)(formScene->CheckBox_VisuGrassNodes),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassNodesDraw(bool)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassNodesDraw(bool)),
                    (QObject *) formScene->CheckBox_VisuGrassNodes,
		    SLOT(setChecked(bool)));		    	    
   QObject::connect((QObject *)(formScene->CheckBox_VisuGrassDensity),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassDensityDraw(bool)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassDensityDraw(bool)),
                    (QObject *) formScene->CheckBox_VisuGrassDensity,
		    SLOT(setChecked(bool)));			        
   QObject::connect((QObject *)(formScene ->CheckBox_VisuGround),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGroundDraw(bool)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGroundDraw(bool)),
                    (QObject *) formScene->CheckBox_VisuGround,
		    SLOT(setChecked(bool))); 		    	    
   QObject::connect((QObject *)(formScene->CheckBox_VisuTrees),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setTreesDraw(bool))); 
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTTreesDraw(bool)),
                    (QObject *) formScene->CheckBox_VisuTrees,
		    SLOT(setChecked(bool))); 		    		    
   QObject::connect((QObject *)(formScene->CheckBox_VisuWire),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setWireDraw(bool))); 
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTWireDraw(bool)),
                    (QObject *) formScene->CheckBox_VisuWire,
		    SLOT(setChecked(bool))); 		    
   
   	   
		    
		    		    

   //----------------------------------------------------------------
   //----------------------------FormGrass---------------------------
   //----------------------------------------------------------------
   
   //--------Patches
   QObject::connect((QObject *)(formGrass->SpinBox_NbPatches1),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassNbPatches1(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassNbPatches1(int)),
                    (QObject *) formGrass->SpinBox_NbPatches1,
		    SLOT(setValue(int))); 	
   QObject::connect((QObject *)(formGrass->SpinBox_NbPatches2),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassNbPatches2(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassNbPatches2(int)),
                    (QObject *) formGrass->SpinBox_NbPatches2,
		    SLOT(setValue(int))); 
   
   //--------Density
   QObject::connect((QObject *)(formGrass->PushButton_GrassDensity),
   		    SIGNAL(clicked()),
                    (QObject *) myPrairieQTDriver,
		    SLOT(loadGrassDensityMap()));  		    
   QObject::connect((QObject *)(formGrass->SpinBox_NbMaxGrassesPerPatche),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassNbMaxPerPatche(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassNbMaxPerPatche(int)),
                    (QObject *) formGrass->SpinBox_NbMaxGrassesPerPatche,
		    SLOT(setValue(int))); 
   
   //--------Height/Width/Noise		    
   QObject::connect((QObject *)(formGrass->Slider_GrassHeight),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassHeight(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassHeight(int)),
                    (QObject *) formGrass->Slider_GrassHeight,
		    SLOT(setValue(int))); 
   QObject::connect((QObject *)(formGrass->Slider_GrassWidth),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassWidth(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassWidth(int)),
                    (QObject *) formGrass->Slider_GrassWidth,
		    SLOT(setValue(int))); 
   QObject::connect((QObject *)(formGrass->Slider_GrassNoisePositions),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassNoisePositions(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassNoisePositions(int)),
                    (QObject *) formGrass->Slider_GrassNoisePositions,
		    SLOT(setValue(int)));
		    
   //--------LOD		    
   QObject::connect((QObject *)(formGrass->SpinBox_GrassPolyg3D),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassPolyg3D(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassPolyg3D(int)),
                    (QObject *) formGrass->SpinBox_GrassPolyg3D,
		    SLOT(setValue(int))); 
   QObject::connect((QObject *)(formGrass->SpinBox_GrassPolyg2D5),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassPolyg2D5(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassPolyg2D5(int)),
                    (QObject *) formGrass->SpinBox_GrassPolyg2D5,
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formGrass->Slider_GrassDist3D),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassRadius3D(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassRadius3D(int)),
                    (QObject *) formGrass->Slider_GrassDist3D,
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formGrass->Slider_GrassDist2D5),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassRadius2D5(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassRadius2D5(int)),
                    (QObject *) formGrass->Slider_GrassDist2D5,
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formGrass->Slider_GrassDist2D),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassRadius2D(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassRadius2D(int)),
                    (QObject *) formGrass->Slider_GrassDist2D,
		    SLOT(setValue(int)));
   
   QObject::connect((QObject *)(formGrass->CheckBox_Texture3D),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassTexture3D(bool))); 
   QObject::connect((QObject *)(formGrass->PushButton_Texture3D),
   		    SIGNAL(clicked()),
                    (QObject *) myPrairieQTDriver,
		    SLOT(loadGrassTexture3D()));
   QObject::connect((QObject *)(formGrass->Slider_AntiAliasingTexture3D),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassAntiAliasingTexture3D(int)));
   QObject::connect((QObject *)(formGrass->PushButton_Texture2D5),
   		    SIGNAL(clicked()),
                    (QObject *) myPrairieQTDriver,
		    SLOT(regenerateGrassTexture2D5()));	
   QObject::connect((QObject *)(formGrass->Slider_AntiAliasingTexture2D5),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassAntiAliasingTexture2D5(int)));

 formGrass->ComboBox_SizeTexture2D5->insertItem("256*32");
   formGrass->ComboBox_SizeTexture2D5->insertItem("256*64");
   formGrass->ComboBox_SizeTexture2D5->insertItem("256*128");
   formGrass->ComboBox_SizeTexture2D5->insertItem("512*32");
   formGrass->ComboBox_SizeTexture2D5->insertItem("512*64");
   formGrass->ComboBox_SizeTexture2D5->insertItem("512*128");
   formGrass->ComboBox_SizeTexture2D5->insertItem("1024*32");
   formGrass->ComboBox_SizeTexture2D5->insertItem("1024*64");
   formGrass->ComboBox_SizeTexture2D5->insertItem("1024*128");
   formGrass->ComboBox_SizeTexture2D5->setCurrentItem(4);

   QObject::connect((QObject *)(formGrass->ComboBox_SizeTexture2D5),
   		    SIGNAL(activated(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassSizeTexture2D5(int)));
   
  QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassTexture3D(bool)),
                    (QObject *) formGrass->CheckBox_Texture3D,
		    SLOT(setChecked(bool)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassAntiAliasingTexture3D(int)),
                    (QObject *) formGrass->Slider_AntiAliasingTexture3D,
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassAntiAliasingTexture2D5(int)),
                    (QObject *) formGrass->Slider_AntiAliasingTexture2D5,
		    SLOT(setValue(int)));

   
   //--------Crushing		    
   QObject::connect((QObject *)(formGrass->Slider_crushingMaxTime),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassCrushingMaxTime(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassCrushingMaxTime(int)),
                    (QObject *) formGrass->Slider_crushingMaxTime,
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formGrass->Slider_crushingDamping),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassCrushingDamping(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassCrushingDamping(int)),
                    (QObject *) formGrass->Slider_crushingDamping,
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formGrass->CheckBox_ajustment2D5Height),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGrassAjustment2D5Height(bool)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGrassAjustment2D5Height(bool)),
                    (QObject *) formGrass->CheckBox_ajustment2D5Height,
		    SLOT(setChecked(bool)));
		    
   //----------------------------------------------------------------
   //----------------------------FormGround--------------------------
   //----------------------------------------------------------------
   QObject::connect((QObject *)(formGround ->Slider_GroundSize),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGroundSize(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGroundSize(int)),
                    (QObject *) (formGround ->Slider_GroundSize),
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formGround ->Slider_GroundHeight),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGroundHeight(int)));
   QObject::connect((QObject *)(myPrairieQTDriver),
   		    SIGNAL(setQTGroundHeight(int)),
                    (QObject *) (formGround ->Slider_GroundHeight),
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formGround->PushButton_HeightMap),
   		    SIGNAL(clicked()),
                    (QObject *) myPrairieQTDriver,
		    SLOT(loadGroundHeightMap())); 
   QObject::connect((QObject *)(formGround->PushButton_Texture),
   		    SIGNAL(clicked()),
                    (QObject *) myPrairieQTDriver,
		    SLOT(loadGroundTexture())); 
	    
/*		    
   //----------------------------------------------------------------
   //----------------------------FormTrees---------------------------
   //----------------------------------------------------------------
   QObject::connect((QObject *)(formTrees->SpinBox_TreesNumber),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setTreesNumber(int)));
   QObject::connect((QObject *) myPrairieQTDriver,
   		    SIGNAL(setQTTreesNumber(int)),
                    (QObject *)(formTrees->SpinBox_TreesNumber),
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formTrees->PushButton_ResetPositions),
   		    SIGNAL(clicked()),
                    (QObject *) myPrairieQTDriver,
		    SLOT(resetTreesPositions()));
   QObject::connect((QObject *)(formTrees->PushButton_ResetForms),
   		    SIGNAL(clicked()),
                    (QObject *) myPrairieQTDriver,
		    SLOT(resetTreesForms()));	
   QObject::connect((QObject *)(formTrees->PushButton_loadARB),
   		    SIGNAL(clicked()),
                    (QObject *) myPrairieQTDriver,
		    SLOT(loadARB()));	
   QObject::connect((QObject *)(formTrees->PushButton_ShowInterface),
   		    SIGNAL(toggled(bool)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(showTreesInterface(bool))); 
   QObject::connect((QObject *)(formTrees->SpinBox_NbPgMax),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setTreesNbPolygonsMax(int))); 
     		    
*/		    
   //----------------------------------------------------------------
   //----------------------------FormWind---------------------------
   //----------------------------------------------------------------
   QObject::connect((QObject *)(formWind->Slider_BreezeSpeed),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setBreezeSpeed(int)));
   QObject::connect((QObject *) myPrairieQTDriver,
   		    SIGNAL(setQTBreezeSpeed(int)),
                    (QObject *)(formWind->Slider_BreezeSpeed),
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formWind->Slider_BreezePower),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setBreezePower(int)));
   QObject::connect((QObject *) myPrairieQTDriver,
   		    SIGNAL(setQTBreezePower(int)),
                    (QObject *)(formWind->Slider_BreezePower),
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formWind->Slider_GustSpeed),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGustSpeed(int)));
   QObject::connect((QObject *) myPrairieQTDriver,
   		    SIGNAL(setQTGustSpeed(int)),
                    (QObject *)(formWind->Slider_GustSpeed),
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formWind->Slider_GustPower),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setGustPower(int)));
   QObject::connect((QObject *) myPrairieQTDriver,
   		    SIGNAL(setQTGustPower(int)),
                    (QObject *)(formWind->Slider_GustPower),
		    SLOT(setValue(int)));
   QObject::connect((QObject *)(formWind->PushButton_WindAddGust),
   		    SIGNAL(clicked()),
                    (QObject *) myPrairieQTDriver,
		    SLOT(addWindGust()));

   QObject::connect((QObject *)(formWind->PushButton_WindAddBlast),
   		    SIGNAL(clicked()),
                    (QObject *) myPrairieQTDriver,
		    SLOT(addWindBlast()));
   QObject::connect((QObject *)(formWind->Slider_BlastPower),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setBlastPower(int)));
   QObject::connect((QObject *) myPrairieQTDriver,
   		    SIGNAL(setQTBlastPower(int)),
                    (QObject *)(formWind->Slider_BlastPower),
		    SLOT(setValue(int)));
		       QObject::connect((QObject *)(formWind->Slider_BlastParam),
   		    SIGNAL(valueChanged(int)),
                    (QObject *) myPrairieQTDriver,
		    SLOT(setBlastParam(int)));
   QObject::connect((QObject *) myPrairieQTDriver,
   		    SIGNAL(setQTBlastParam(int)),
                    (QObject *)(formWind->Slider_BlastParam),
		    SLOT(setValue(int)));

   //placement fenetres
   formScene->move(20,30);
   formGrass->move(250,30);
//   formTrees->move(1015,30);
   formGround->move(785,30);
   formWind->move(485,30);
   
   formGrass->show();
   formScene->show();
   formGround->show();
//   formTrees->show();
   formWind->show();
   
   myPrairieViewer->move(485,180);
   myPrairieViewer->resize(780,580);		      
   myPrairieViewer->show();
   
//execution
   myPrairieViewer->setWindowTitle("prairie animee");
   int ret = application.exec();
   
   
   //fin
   delete formScene;
   delete formGrass;
   delete formGround;
 //  delete formTrees;
   delete formWind;
   delete myPrairieQTDriver;
   delete myPrairieViewer;
   
   return ret;
 }
